/* ai.c generated by valac 0.56.17, the Vala compiler
 * generated from ai.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Four-in-a-row.

   Copyright © 2014 Nikhar Agrawal

   GNOME Four-in-a-row is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Four-in-a-row is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with GNOME Four-in-a-row.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define AI_POSITIVE_INFINITY ((gint16) 32000)
#define AI_NEGATIVE_INFINITY ((gint16) -32000)
#define AI_LESS_THAN_NEGATIVE_INFINITY ((gint16) -32001)
#define AI_MAX_HEURIST_VALUE ((gint16) 3200)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	DIFFICULTY_EASY,
	DIFFICULTY_MEDIUM,
	DIFFICULTY_HARD
} Difficulty;

#define TYPE_DIFFICULTY (difficulty_get_type ())
typedef enum  {
	PLAYER_NOBODY,
	PLAYER_HUMAN,
	PLAYER_OPPONENT
} Player;

#define TYPE_PLAYER (player_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN GType difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint8 ai_playgame (guint8 size,
                    Difficulty level,
                    const gchar* vstr,
                    guint8 line);
VALA_EXTERN GType player_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void ai_init_board_from_string (guint8 size,
                                const gchar* vstr,
                                Player** board,
                                gint* board_length1,
                                gint* board_length2);
VALA_EXTERN guint8 ai_immediate_win (Player player,
                         guint8 line,
                         Player** board,
                         gint* board_length1,
                         gint* board_length2);
VALA_EXTERN gint16 ai_negamax (guint8 height,
                   gint16 alpha,
                   gint16 beta,
                   Player player,
                   Difficulty level,
                   guint8 line,
                   Player** board,
                   gint* board_length1,
                   gint* board_length2,
                   guint8* next_move_in_column);
VALA_EXTERN guint8 ai_playandcheck (guint8 size,
                        Difficulty level,
                        const gchar* vstr,
                        guint8 line);
VALA_EXTERN void ai_update_board (const gchar* vstr,
                      Player** board,
                      gint* board_length1,
                      gint* board_length2);
VALA_EXTERN gboolean ai_board_full (Player** board,
                        gint* board_length1,
                        gint* board_length2);
VALA_EXTERN gint16 ai_heurist (Difficulty level,
                   guint8 line,
                   Player** board,
                   gint* board_length1,
                   gint* board_length2);
VALA_EXTERN gboolean ai_move (Player player,
                  guint8 column,
                  Player** board,
                  gint* board_length1,
                  gint* board_length2);
VALA_EXTERN gboolean ai_victory (Player player,
                     guint8 line,
                     guint8 column,
                     Player** board,
                     gint* board_length1,
                     gint* board_length2);
VALA_EXTERN void ai_unmove (guint8 column,
                Player** board,
                gint* board_length1,
                gint* board_length2);
VALA_EXTERN gboolean ai_vertical_win (Player player,
                          guint8 line,
                          guint8 i,
                          guint8 j,
                          Player** board,
                          gint* board_length1,
                          gint* board_length2);
VALA_EXTERN gboolean ai_horizontal_win (Player player,
                            guint8 line,
                            guint8 _i,
                            guint8 _j,
                            Player** board,
                            gint* board_length1,
                            gint* board_length2);
VALA_EXTERN gboolean ai_forward_diagonal_win (Player player,
                                  guint8 line,
                                  guint8 _i,
                                  guint8 _j,
                                  Player** board,
                                  gint* board_length1,
                                  gint* board_length2);
VALA_EXTERN gboolean ai_backward_diagonal_win (Player player,
                                   guint8 line,
                                   guint8 _i,
                                   guint8 _j,
                                   Player** board,
                                   gint* board_length1,
                                   gint* board_length2);
VALA_EXTERN gint16 ai_heurist_easy (guint8 line,
                        Player** board,
                        gint* board_length1,
                        gint* board_length2);
VALA_EXTERN gint16 ai_heurist_medium (void);
VALA_EXTERN gint16 ai_heurist_hard (guint8 line,
                        Player** board,
                        gint* board_length1,
                        gint* board_length2);
VALA_EXTERN gint8 ai_count_3_in_a_row (Player player,
                           guint8 line,
                           Player** board,
                           gint* board_length1,
                           gint* board_length2);
VALA_EXTERN gboolean ai_all_adjacent_empty (guint8 _i,
                                guint8 _j,
                                Player** board,
                                gint* board_length1,
                                gint* board_length2);

const guint8 AI_plies[3] = {(guint8) 4, (guint8) 7, (guint8) 7};

guint8
ai_playgame (guint8 size,
             Difficulty level,
             const gchar* vstr,
             guint8 line)
{
	Player* board = NULL;
	gint board_length1 = 0;
	gint board_length2 = 0;
	Player* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8 temp = 0U;
	guint8 _tmp3_;
	guint8 _tmp4_;
	guint8 next_move_in_column = 0U;
	guint8 _tmp5_;
	guint8 result;
#line 40 "../src/ai.vala"
	g_return_val_if_fail (vstr != NULL, 0U);
#line 43 "../src/ai.vala"
	ai_init_board_from_string (size, vstr, &_tmp0_, &_tmp1_, &_tmp2_);
#line 43 "../src/ai.vala"
	board = (g_free (board), NULL);
#line 43 "../src/ai.vala"
	board = _tmp0_;
#line 43 "../src/ai.vala"
	board_length1 = _tmp1_;
#line 43 "../src/ai.vala"
	board_length2 = _tmp2_;
#line 46 "../src/ai.vala"
	_tmp3_ = ai_immediate_win (PLAYER_OPPONENT, line, &board, (gint*) (&board_length1), (gint*) (&board_length2));
#line 46 "../src/ai.vala"
	temp = _tmp3_;
#line 47 "../src/ai.vala"
	if (temp < size) {
#line 48 "../src/ai.vala"
		result = temp;
#line 48 "../src/ai.vala"
		board = (g_free (board), NULL);
#line 48 "../src/ai.vala"
		return result;
#line 217 "ai.c"
	}
#line 52 "../src/ai.vala"
	_tmp4_ = ai_immediate_win (PLAYER_HUMAN, line, &board, (gint*) (&board_length1), (gint*) (&board_length2));
#line 52 "../src/ai.vala"
	temp = _tmp4_;
#line 53 "../src/ai.vala"
	if (temp < size) {
#line 54 "../src/ai.vala"
		result = temp;
#line 54 "../src/ai.vala"
		board = (g_free (board), NULL);
#line 54 "../src/ai.vala"
		return result;
#line 231 "ai.c"
	}
#line 57 "../src/ai.vala"
	next_move_in_column = G_MAXUINT8;
#line 58 "../src/ai.vala"
	_tmp5_ = AI_plies[level];
#line 58 "../src/ai.vala"
	ai_negamax (_tmp5_, AI_NEGATIVE_INFINITY, AI_POSITIVE_INFINITY, PLAYER_OPPONENT, level, line, &board, (gint*) (&board_length1), (gint*) (&board_length2), &next_move_in_column);
#line 61 "../src/ai.vala"
	result = next_move_in_column;
#line 61 "../src/ai.vala"
	board = (g_free (board), NULL);
#line 61 "../src/ai.vala"
	return result;
#line 245 "ai.c"
}

guint8
ai_playandcheck (guint8 size,
                 Difficulty level,
                 const gchar* vstr,
                 guint8 line)
{
	Player* board = NULL;
	gint board_length1 = 0;
	gint board_length2 = 0;
	Player* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8 temp = 0U;
	guint8 _tmp3_;
	guint8 _tmp4_;
	guint8 next_move_in_column = 0U;
	guint8 _tmp5_;
	guint8 result;
#line 65 "../src/ai.vala"
	g_return_val_if_fail (vstr != NULL, 0U);
#line 68 "../src/ai.vala"
	ai_init_board_from_string (size, vstr, &_tmp0_, &_tmp1_, &_tmp2_);
#line 68 "../src/ai.vala"
	board = (g_free (board), NULL);
#line 68 "../src/ai.vala"
	board = _tmp0_;
#line 68 "../src/ai.vala"
	board_length1 = _tmp1_;
#line 68 "../src/ai.vala"
	board_length2 = _tmp2_;
#line 70 "../src/ai.vala"
	_tmp3_ = ai_immediate_win (PLAYER_OPPONENT, line, &board, (gint*) (&board_length1), (gint*) (&board_length2));
#line 70 "../src/ai.vala"
	temp = _tmp3_;
#line 71 "../src/ai.vala"
	if (temp < size) {
#line 72 "../src/ai.vala"
		result = (guint8) 100;
#line 72 "../src/ai.vala"
		board = (g_free (board), NULL);
#line 72 "../src/ai.vala"
		return result;
#line 290 "ai.c"
	}
#line 74 "../src/ai.vala"
	_tmp4_ = ai_immediate_win (PLAYER_HUMAN, line, &board, (gint*) (&board_length1), (gint*) (&board_length2));
#line 74 "../src/ai.vala"
	temp = _tmp4_;
#line 75 "../src/ai.vala"
	if (temp < size) {
#line 76 "../src/ai.vala"
		result = temp;
#line 76 "../src/ai.vala"
		board = (g_free (board), NULL);
#line 76 "../src/ai.vala"
		return result;
#line 304 "ai.c"
	}
#line 79 "../src/ai.vala"
	next_move_in_column = G_MAXUINT8;
#line 80 "../src/ai.vala"
	_tmp5_ = AI_plies[level];
#line 80 "../src/ai.vala"
	ai_negamax (_tmp5_, AI_NEGATIVE_INFINITY, AI_POSITIVE_INFINITY, PLAYER_OPPONENT, level, line, &board, (gint*) (&board_length1), (gint*) (&board_length2), &next_move_in_column);
#line 82 "../src/ai.vala"
	result = next_move_in_column;
#line 82 "../src/ai.vala"
	board = (g_free (board), NULL);
#line 82 "../src/ai.vala"
	return result;
#line 318 "ai.c"
}

void
ai_init_board_from_string (guint8 size,
                           const gchar* vstr,
                           Player** board,
                           gint* board_length1,
                           gint* board_length2)
{
	Player* _vala_board = NULL;
	gint _vala_board_length1 = 0;
	gint _vala_board_length2 = 0;
	guint8 n_rows = 0U;
	guint8 n_cols = 0U;
	Player* _tmp0_;
#line 90 "../src/ai.vala"
	g_return_if_fail (vstr != NULL);
#line 92 "../src/ai.vala"
	n_rows = (guint8) (size - 1);
#line 93 "../src/ai.vala"
	n_cols = size;
#line 95 "../src/ai.vala"
	_tmp0_ = g_new0 (Player, n_rows * n_cols);
#line 95 "../src/ai.vala"
	_vala_board = (g_free (_vala_board), NULL);
#line 95 "../src/ai.vala"
	_vala_board = _tmp0_;
#line 95 "../src/ai.vala"
	_vala_board_length1 = n_rows;
#line 95 "../src/ai.vala"
	_vala_board_length2 = n_cols;
#line 350 "ai.c"
	{
		guint8 i = 0U;
#line 96 "../src/ai.vala"
		i = (guint8) 0;
#line 355 "ai.c"
		{
			gboolean _tmp1_ = FALSE;
#line 96 "../src/ai.vala"
			_tmp1_ = TRUE;
#line 96 "../src/ai.vala"
			while (TRUE) {
#line 96 "../src/ai.vala"
				if (!_tmp1_) {
#line 364 "ai.c"
					guint8 _tmp2_;
#line 96 "../src/ai.vala"
					_tmp2_ = i;
#line 96 "../src/ai.vala"
					i = _tmp2_ + 1;
#line 370 "ai.c"
				}
#line 96 "../src/ai.vala"
				_tmp1_ = FALSE;
#line 96 "../src/ai.vala"
				if (!(i < n_rows)) {
#line 96 "../src/ai.vala"
					break;
#line 378 "ai.c"
				}
				{
					guint8 j = 0U;
#line 97 "../src/ai.vala"
					j = (guint8) 0;
#line 384 "ai.c"
					{
						gboolean _tmp3_ = FALSE;
#line 97 "../src/ai.vala"
						_tmp3_ = TRUE;
#line 97 "../src/ai.vala"
						while (TRUE) {
#line 391 "ai.c"
							Player* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 97 "../src/ai.vala"
							if (!_tmp3_) {
#line 397 "ai.c"
								guint8 _tmp4_;
#line 97 "../src/ai.vala"
								_tmp4_ = j;
#line 97 "../src/ai.vala"
								j = _tmp4_ + 1;
#line 403 "ai.c"
							}
#line 97 "../src/ai.vala"
							_tmp3_ = FALSE;
#line 97 "../src/ai.vala"
							if (!(j < n_cols)) {
#line 97 "../src/ai.vala"
								break;
#line 411 "ai.c"
							}
#line 98 "../src/ai.vala"
							_tmp5_ = _vala_board;
#line 98 "../src/ai.vala"
							_tmp5__length1 = _vala_board_length1;
#line 98 "../src/ai.vala"
							_tmp5__length2 = _vala_board_length2;
#line 98 "../src/ai.vala"
							_tmp5_[(i * _tmp5__length2) + j] = PLAYER_NOBODY;
#line 421 "ai.c"
						}
					}
				}
			}
		}
	}
#line 101 "../src/ai.vala"
	if (g_strcmp0 (vstr, "") == 0) {
#line 102 "../src/ai.vala"
		if (board) {
#line 102 "../src/ai.vala"
			*board = _vala_board;
#line 434 "ai.c"
		} else {
#line 102 "../src/ai.vala"
			_vala_board = (g_free (_vala_board), NULL);
#line 438 "ai.c"
		}
#line 102 "../src/ai.vala"
		if (board_length1) {
#line 102 "../src/ai.vala"
			*board_length1 = _vala_board_length1;
#line 444 "ai.c"
		}
#line 102 "../src/ai.vala"
		if (board_length2) {
#line 102 "../src/ai.vala"
			*board_length2 = _vala_board_length2;
#line 450 "ai.c"
		}
#line 102 "../src/ai.vala"
		return;
#line 454 "ai.c"
	}
#line 105 "../src/ai.vala"
	ai_update_board (vstr, &_vala_board, (gint*) (&_vala_board_length1), (gint*) (&_vala_board_length2));
#line 90 "../src/ai.vala"
	if (board) {
#line 90 "../src/ai.vala"
		*board = _vala_board;
#line 462 "ai.c"
	} else {
#line 90 "../src/ai.vala"
		_vala_board = (g_free (_vala_board), NULL);
#line 466 "ai.c"
	}
#line 90 "../src/ai.vala"
	if (board_length1) {
#line 90 "../src/ai.vala"
		*board_length1 = _vala_board_length1;
#line 472 "ai.c"
	}
#line 90 "../src/ai.vala"
	if (board_length2) {
#line 90 "../src/ai.vala"
		*board_length2 = _vala_board_length2;
#line 478 "ai.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 496 "ai.c"
}

inline void
ai_update_board (const gchar* vstr,
                 Player** board,
                 gint* board_length1,
                 gint* board_length2)
{
	guint8 n_rows = 0U;
	gint _tmp0_;
	Player _tmp1_ = 0;
	gint _tmp2_;
	gint _tmp3_;
	Player move = 0;
#line 108 "../src/ai.vala"
	g_return_if_fail (vstr != NULL);
#line 110 "../src/ai.vala"
	_tmp0_ = *board_length1;
#line 110 "../src/ai.vala"
	n_rows = (guint8) _tmp0_;
#line 111 "../src/ai.vala"
	_tmp2_ = strlen (vstr);
#line 111 "../src/ai.vala"
	_tmp3_ = _tmp2_;
#line 111 "../src/ai.vala"
	if ((_tmp3_ % 2) == 0) {
#line 111 "../src/ai.vala"
		_tmp1_ = PLAYER_OPPONENT;
#line 525 "ai.c"
	} else {
#line 111 "../src/ai.vala"
		_tmp1_ = PLAYER_HUMAN;
#line 529 "ai.c"
	}
#line 111 "../src/ai.vala"
	move = _tmp1_;
#line 533 "ai.c"
	{
		guint8 i = 0U;
#line 113 "../src/ai.vala"
		i = (guint8) 0;
#line 538 "ai.c"
		{
			gboolean _tmp4_ = FALSE;
#line 113 "../src/ai.vala"
			_tmp4_ = TRUE;
#line 113 "../src/ai.vala"
			while (TRUE) {
#line 545 "ai.c"
				gint _tmp6_;
				gint _tmp7_;
				guint8 column = 0U;
				gchar* _tmp8_;
				gchar* _tmp9_;
				guint8 _tmp10_;
				gint8 row = 0;
				Player _tmp15_ = 0;
#line 113 "../src/ai.vala"
				if (!_tmp4_) {
#line 556 "ai.c"
					guint8 _tmp5_;
#line 113 "../src/ai.vala"
					_tmp5_ = i;
#line 113 "../src/ai.vala"
					i = _tmp5_ + 1;
#line 562 "ai.c"
				}
#line 113 "../src/ai.vala"
				_tmp4_ = FALSE;
#line 113 "../src/ai.vala"
				_tmp6_ = strlen (vstr);
#line 113 "../src/ai.vala"
				_tmp7_ = _tmp6_;
#line 113 "../src/ai.vala"
				if (!(((gint) i) < _tmp7_)) {
#line 113 "../src/ai.vala"
					break;
#line 574 "ai.c"
				}
#line 115 "../src/ai.vala"
				_tmp8_ = g_strdup_printf ("%c", string_get (vstr, (glong) i));
#line 115 "../src/ai.vala"
				_tmp9_ = _tmp8_;
#line 115 "../src/ai.vala"
				_tmp10_ = (guint8) (((guint8) atoi (_tmp9_)) - 1);
#line 115 "../src/ai.vala"
				_g_free0 (_tmp9_);
#line 115 "../src/ai.vala"
				column = _tmp10_;
#line 586 "ai.c"
				{
					gboolean _tmp11_ = FALSE;
#line 119 "../src/ai.vala"
					row = (gint8) (n_rows - 1);
#line 119 "../src/ai.vala"
					_tmp11_ = TRUE;
#line 119 "../src/ai.vala"
					while (TRUE) {
#line 595 "ai.c"
						gboolean _tmp13_ = FALSE;
#line 119 "../src/ai.vala"
						if (!_tmp11_) {
#line 599 "ai.c"
							gint8 _tmp12_;
#line 119 "../src/ai.vala"
							_tmp12_ = row;
#line 119 "../src/ai.vala"
							row = _tmp12_ - 1;
#line 605 "ai.c"
						}
#line 119 "../src/ai.vala"
						_tmp11_ = FALSE;
#line 119 "../src/ai.vala"
						if (((gint) row) >= 0) {
#line 611 "ai.c"
							Player _tmp14_;
#line 119 "../src/ai.vala"
							_tmp14_ = (*board)[(row * (*board_length2)) + column];
#line 119 "../src/ai.vala"
							_tmp13_ = _tmp14_ != PLAYER_NOBODY;
#line 617 "ai.c"
						} else {
#line 119 "../src/ai.vala"
							_tmp13_ = FALSE;
#line 621 "ai.c"
						}
#line 119 "../src/ai.vala"
						if (!_tmp13_) {
#line 119 "../src/ai.vala"
							break;
#line 627 "ai.c"
						}
					}
				}
#line 121 "../src/ai.vala"
				(*board)[(row * (*board_length2)) + column] = move;
#line 123 "../src/ai.vala"
				if (move == PLAYER_HUMAN) {
#line 123 "../src/ai.vala"
					_tmp15_ = PLAYER_OPPONENT;
#line 637 "ai.c"
				} else {
#line 123 "../src/ai.vala"
					_tmp15_ = PLAYER_HUMAN;
#line 641 "ai.c"
				}
#line 123 "../src/ai.vala"
				move = _tmp15_;
#line 645 "ai.c"
			}
		}
	}
}

gint16
ai_negamax (guint8 height,
            gint16 alpha,
            gint16 beta,
            Player player,
            Difficulty level,
            guint8 line,
            Player** board,
            gint* board_length1,
            gint* board_length2,
            guint8* next_move_in_column)
{
	guint8 n_cols = 0U;
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint16 max = 0;
	guint8 next = 0U;
	guint8 _tmp12_;
	gint16 result;
#line 135 "../src/ai.vala"
	_tmp0_ = *board_length2;
#line 135 "../src/ai.vala"
	n_cols = (guint8) _tmp0_;
#line 137 "../src/ai.vala"
	if (((gint) height) == 0) {
#line 137 "../src/ai.vala"
		_tmp1_ = TRUE;
#line 678 "ai.c"
	} else {
		gboolean _tmp2_;
#line 137 "../src/ai.vala"
		_tmp2_ = ai_board_full (board, (gint*) (board_length1), (gint*) (board_length2));
#line 137 "../src/ai.vala"
		_tmp1_ = _tmp2_;
#line 685 "ai.c"
	}
#line 137 "../src/ai.vala"
	if (_tmp1_) {
#line 139 "../src/ai.vala"
		if (player == PLAYER_OPPONENT) {
#line 691 "ai.c"
			gint16 _tmp3_;
#line 140 "../src/ai.vala"
			_tmp3_ = ai_heurist (level, line, board, (gint*) (board_length1), (gint*) (board_length2));
#line 140 "../src/ai.vala"
			result = _tmp3_;
#line 140 "../src/ai.vala"
			return result;
#line 699 "ai.c"
		} else {
#line 141 "../src/ai.vala"
			if (player == PLAYER_HUMAN) {
#line 703 "ai.c"
				gint16 _tmp4_;
#line 142 "../src/ai.vala"
				_tmp4_ = ai_heurist (level, line, board, (gint*) (board_length1), (gint*) (board_length2));
#line 142 "../src/ai.vala"
				result = (gint16) (-1 * _tmp4_);
#line 142 "../src/ai.vala"
				return result;
#line 711 "ai.c"
			} else {
#line 144 "../src/ai.vala"
				g_assert_not_reached ();
#line 715 "ai.c"
			}
		}
	}
#line 150 "../src/ai.vala"
	max = AI_LESS_THAN_NEGATIVE_INFINITY;
#line 154 "../src/ai.vala"
	next = G_MAXUINT8;
#line 723 "ai.c"
	{
		guint8 column = 0U;
#line 156 "../src/ai.vala"
		column = (guint8) 0;
#line 728 "ai.c"
		{
			gboolean _tmp5_ = FALSE;
#line 156 "../src/ai.vala"
			_tmp5_ = TRUE;
#line 156 "../src/ai.vala"
			while (TRUE) {
#line 735 "ai.c"
				gboolean _tmp7_;
				gint16 _tmp8_ = 0;
				gboolean _tmp9_;
				gint16 temp = 0;
#line 156 "../src/ai.vala"
				if (!_tmp5_) {
#line 742 "ai.c"
					guint8 _tmp6_;
#line 156 "../src/ai.vala"
					_tmp6_ = column;
#line 156 "../src/ai.vala"
					column = _tmp6_ + 1;
#line 748 "ai.c"
				}
#line 156 "../src/ai.vala"
				_tmp5_ = FALSE;
#line 156 "../src/ai.vala"
				if (!(column < n_cols)) {
#line 156 "../src/ai.vala"
					break;
#line 756 "ai.c"
				}
#line 158 "../src/ai.vala"
				_tmp7_ = ai_move (player, column, board, (gint*) (board_length1), (gint*) (board_length2));
#line 158 "../src/ai.vala"
				if (!_tmp7_) {
#line 159 "../src/ai.vala"
					continue;
#line 764 "ai.c"
				}
#line 164 "../src/ai.vala"
				_tmp9_ = ai_victory (player, line, column, board, (gint*) (board_length1), (gint*) (board_length2));
#line 164 "../src/ai.vala"
				if (_tmp9_) {
#line 164 "../src/ai.vala"
					_tmp8_ = AI_MAX_HEURIST_VALUE * height;
#line 772 "ai.c"
				} else {
					Player _tmp10_ = 0;
					gint16 _tmp11_;
#line 165 "../src/ai.vala"
					if (player == PLAYER_OPPONENT) {
#line 165 "../src/ai.vala"
						_tmp10_ = PLAYER_HUMAN;
#line 780 "ai.c"
					} else {
#line 165 "../src/ai.vala"
						_tmp10_ = PLAYER_OPPONENT;
#line 784 "ai.c"
					}
#line 165 "../src/ai.vala"
					_tmp11_ = ai_negamax ((guint8) (height - 1), (gint16) (-1 * beta), (gint16) (-1 * alpha), _tmp10_, level, line, board, (gint*) (board_length1), (gint*) (board_length2), next_move_in_column);
#line 165 "../src/ai.vala"
					_tmp8_ = (gint16) (-1 * _tmp11_);
#line 790 "ai.c"
				}
#line 164 "../src/ai.vala"
				temp = _tmp8_;
#line 167 "../src/ai.vala"
				ai_unmove (column, board, (gint*) (board_length1), (gint*) (board_length2));
#line 169 "../src/ai.vala"
				if (temp > max) {
#line 171 "../src/ai.vala"
					next = column;
#line 172 "../src/ai.vala"
					max = temp;
#line 802 "ai.c"
				}
#line 175 "../src/ai.vala"
				if (temp > alpha) {
#line 176 "../src/ai.vala"
					alpha = temp;
#line 808 "ai.c"
				}
#line 178 "../src/ai.vala"
				if (alpha >= beta) {
#line 179 "../src/ai.vala"
					break;
#line 814 "ai.c"
				}
			}
		}
	}
#line 183 "../src/ai.vala"
	_tmp12_ = AI_plies[level];
#line 183 "../src/ai.vala"
	if (height == _tmp12_) {
#line 184 "../src/ai.vala"
		*next_move_in_column = next;
#line 825 "ai.c"
	}
#line 186 "../src/ai.vala"
	result = max;
#line 186 "../src/ai.vala"
	return result;
#line 831 "ai.c"
}

gboolean
ai_victory (Player player,
            guint8 line,
            guint8 column,
            Player** board,
            gint* board_length1,
            gint* board_length2)
{
	guint8 n_rows = 0U;
	gint _tmp0_;
	guint8 row = 0U;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_;
	gboolean result;
#line 196 "../src/ai.vala"
	_tmp0_ = *board_length1;
#line 196 "../src/ai.vala"
	n_rows = (guint8) _tmp0_;
#line 854 "ai.c"
	{
		gboolean _tmp1_ = FALSE;
#line 199 "../src/ai.vala"
		row = (guint8) 0;
#line 199 "../src/ai.vala"
		_tmp1_ = TRUE;
#line 199 "../src/ai.vala"
		while (TRUE) {
#line 863 "ai.c"
			gboolean _tmp3_ = FALSE;
#line 199 "../src/ai.vala"
			if (!_tmp1_) {
#line 867 "ai.c"
				guint8 _tmp2_;
#line 199 "../src/ai.vala"
				_tmp2_ = row;
#line 199 "../src/ai.vala"
				row = _tmp2_ + 1;
#line 873 "ai.c"
			}
#line 199 "../src/ai.vala"
			_tmp1_ = FALSE;
#line 199 "../src/ai.vala"
			if (row < n_rows) {
#line 879 "ai.c"
				Player _tmp4_;
#line 199 "../src/ai.vala"
				_tmp4_ = (*board)[(row * (*board_length2)) + column];
#line 199 "../src/ai.vala"
				_tmp3_ = _tmp4_ == PLAYER_NOBODY;
#line 885 "ai.c"
			} else {
#line 199 "../src/ai.vala"
				_tmp3_ = FALSE;
#line 889 "ai.c"
			}
#line 199 "../src/ai.vala"
			if (!_tmp3_) {
#line 199 "../src/ai.vala"
				break;
#line 895 "ai.c"
			}
		}
	}
#line 201 "../src/ai.vala"
	_tmp8_ = ai_vertical_win (player, line, row, column, board, (gint*) (board_length1), (gint*) (board_length2));
#line 201 "../src/ai.vala"
	if (_tmp8_) {
#line 201 "../src/ai.vala"
		_tmp7_ = TRUE;
#line 905 "ai.c"
	} else {
		gboolean _tmp9_;
#line 202 "../src/ai.vala"
		_tmp9_ = ai_horizontal_win (player, line, row, column, board, (gint*) (board_length1), (gint*) (board_length2));
#line 202 "../src/ai.vala"
		_tmp7_ = _tmp9_;
#line 912 "ai.c"
	}
#line 201 "../src/ai.vala"
	if (_tmp7_) {
#line 201 "../src/ai.vala"
		_tmp6_ = TRUE;
#line 918 "ai.c"
	} else {
		gboolean _tmp10_;
#line 203 "../src/ai.vala"
		_tmp10_ = ai_forward_diagonal_win (player, line, row, column, board, (gint*) (board_length1), (gint*) (board_length2));
#line 203 "../src/ai.vala"
		_tmp6_ = _tmp10_;
#line 925 "ai.c"
	}
#line 201 "../src/ai.vala"
	if (_tmp6_) {
#line 201 "../src/ai.vala"
		_tmp5_ = TRUE;
#line 931 "ai.c"
	} else {
		gboolean _tmp11_;
#line 204 "../src/ai.vala"
		_tmp11_ = ai_backward_diagonal_win (player, line, row, column, board, (gint*) (board_length1), (gint*) (board_length2));
#line 204 "../src/ai.vala"
		_tmp5_ = _tmp11_;
#line 938 "ai.c"
	}
#line 201 "../src/ai.vala"
	result = _tmp5_;
#line 201 "../src/ai.vala"
	return result;
#line 944 "ai.c"
}

inline gboolean
ai_forward_diagonal_win (Player player,
                         guint8 line,
                         guint8 _i,
                         guint8 _j,
                         Player** board,
                         gint* board_length1,
                         gint* board_length2)
{
	guint8 n_rows = 0U;
	gint _tmp0_;
	guint8 n_cols = 0U;
	gint _tmp1_;
	gint8 i = 0;
	gint8 j = 0;
	guint8 count = 0U;
	gboolean result;
#line 209 "../src/ai.vala"
	_tmp0_ = *board_length1;
#line 209 "../src/ai.vala"
	n_rows = (guint8) _tmp0_;
#line 210 "../src/ai.vala"
	_tmp1_ = *board_length2;
#line 210 "../src/ai.vala"
	n_cols = (guint8) _tmp1_;
#line 211 "../src/ai.vala"
	i = (gint8) _i;
#line 212 "../src/ai.vala"
	j = (gint8) _j;
#line 214 "../src/ai.vala"
	count = (guint8) 0;
#line 978 "ai.c"
	{
		gint8 k = 0;
		gint8 l = 0;
#line 216 "../src/ai.vala"
		k = i;
#line 216 "../src/ai.vala"
		l = j;
#line 986 "ai.c"
		{
			gboolean _tmp2_ = FALSE;
#line 216 "../src/ai.vala"
			_tmp2_ = TRUE;
#line 216 "../src/ai.vala"
			while (TRUE) {
#line 993 "ai.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
#line 216 "../src/ai.vala"
				if (!_tmp2_) {
#line 998 "ai.c"
					gint8 _tmp3_;
					gint8 _tmp4_;
					guint8 _tmp5_;
#line 216 "../src/ai.vala"
					_tmp3_ = k;
#line 216 "../src/ai.vala"
					k = _tmp3_ - 1;
#line 216 "../src/ai.vala"
					_tmp4_ = l;
#line 216 "../src/ai.vala"
					l = _tmp4_ + 1;
#line 216 "../src/ai.vala"
					_tmp5_ = count;
#line 216 "../src/ai.vala"
					count = _tmp5_ + 1;
#line 1014 "ai.c"
				}
#line 216 "../src/ai.vala"
				_tmp2_ = FALSE;
#line 216 "../src/ai.vala"
				if (((gint) k) >= 0) {
#line 216 "../src/ai.vala"
					_tmp7_ = ((guint8) l) < n_cols;
#line 1022 "ai.c"
				} else {
#line 216 "../src/ai.vala"
					_tmp7_ = FALSE;
#line 1026 "ai.c"
				}
#line 216 "../src/ai.vala"
				if (_tmp7_) {
#line 1030 "ai.c"
					Player _tmp8_;
#line 216 "../src/ai.vala"
					_tmp8_ = (*board)[(k * (*board_length2)) + l];
#line 216 "../src/ai.vala"
					_tmp6_ = _tmp8_ == player;
#line 1036 "ai.c"
				} else {
#line 216 "../src/ai.vala"
					_tmp6_ = FALSE;
#line 1040 "ai.c"
				}
#line 216 "../src/ai.vala"
				if (!_tmp6_) {
#line 216 "../src/ai.vala"
					break;
#line 1046 "ai.c"
				}
			}
		}
	}
	{
		gint8 k = 0;
		gint8 l = 0;
#line 217 "../src/ai.vala"
		k = (gint8) (i + 1);
#line 217 "../src/ai.vala"
		l = (gint8) (j - 1);
#line 1058 "ai.c"
		{
			gboolean _tmp9_ = FALSE;
#line 217 "../src/ai.vala"
			_tmp9_ = TRUE;
#line 217 "../src/ai.vala"
			while (TRUE) {
#line 1065 "ai.c"
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
#line 217 "../src/ai.vala"
				if (!_tmp9_) {
#line 1070 "ai.c"
					gint8 _tmp10_;
					gint8 _tmp11_;
					guint8 _tmp12_;
#line 217 "../src/ai.vala"
					_tmp10_ = k;
#line 217 "../src/ai.vala"
					k = _tmp10_ + 1;
#line 217 "../src/ai.vala"
					_tmp11_ = l;
#line 217 "../src/ai.vala"
					l = _tmp11_ - 1;
#line 217 "../src/ai.vala"
					_tmp12_ = count;
#line 217 "../src/ai.vala"
					count = _tmp12_ + 1;
#line 1086 "ai.c"
				}
#line 217 "../src/ai.vala"
				_tmp9_ = FALSE;
#line 217 "../src/ai.vala"
				if (((guint8) k) < n_rows) {
#line 217 "../src/ai.vala"
					_tmp14_ = ((gint) l) >= 0;
#line 1094 "ai.c"
				} else {
#line 217 "../src/ai.vala"
					_tmp14_ = FALSE;
#line 1098 "ai.c"
				}
#line 217 "../src/ai.vala"
				if (_tmp14_) {
#line 1102 "ai.c"
					Player _tmp15_;
#line 217 "../src/ai.vala"
					_tmp15_ = (*board)[(k * (*board_length2)) + l];
#line 217 "../src/ai.vala"
					_tmp13_ = _tmp15_ == player;
#line 1108 "ai.c"
				} else {
#line 217 "../src/ai.vala"
					_tmp13_ = FALSE;
#line 1112 "ai.c"
				}
#line 217 "../src/ai.vala"
				if (!_tmp13_) {
#line 217 "../src/ai.vala"
					break;
#line 1118 "ai.c"
				}
			}
		}
	}
#line 219 "../src/ai.vala"
	result = count >= line;
#line 219 "../src/ai.vala"
	return result;
#line 1127 "ai.c"
}

inline gboolean
ai_backward_diagonal_win (Player player,
                          guint8 line,
                          guint8 _i,
                          guint8 _j,
                          Player** board,
                          gint* board_length1,
                          gint* board_length2)
{
	guint8 n_rows = 0U;
	gint _tmp0_;
	guint8 n_cols = 0U;
	gint _tmp1_;
	gint8 i = 0;
	gint8 j = 0;
	guint8 count = 0U;
	gboolean result;
#line 224 "../src/ai.vala"
	_tmp0_ = *board_length1;
#line 224 "../src/ai.vala"
	n_rows = (guint8) _tmp0_;
#line 225 "../src/ai.vala"
	_tmp1_ = *board_length2;
#line 225 "../src/ai.vala"
	n_cols = (guint8) _tmp1_;
#line 226 "../src/ai.vala"
	i = (gint8) _i;
#line 227 "../src/ai.vala"
	j = (gint8) _j;
#line 229 "../src/ai.vala"
	count = (guint8) 0;
#line 1161 "ai.c"
	{
		gint8 k = 0;
		gint8 l = 0;
#line 231 "../src/ai.vala"
		k = i;
#line 231 "../src/ai.vala"
		l = j;
#line 1169 "ai.c"
		{
			gboolean _tmp2_ = FALSE;
#line 231 "../src/ai.vala"
			_tmp2_ = TRUE;
#line 231 "../src/ai.vala"
			while (TRUE) {
#line 1176 "ai.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
#line 231 "../src/ai.vala"
				if (!_tmp2_) {
#line 1181 "ai.c"
					gint8 _tmp3_;
					gint8 _tmp4_;
					guint8 _tmp5_;
#line 231 "../src/ai.vala"
					_tmp3_ = k;
#line 231 "../src/ai.vala"
					k = _tmp3_ - 1;
#line 231 "../src/ai.vala"
					_tmp4_ = l;
#line 231 "../src/ai.vala"
					l = _tmp4_ - 1;
#line 231 "../src/ai.vala"
					_tmp5_ = count;
#line 231 "../src/ai.vala"
					count = _tmp5_ + 1;
#line 1197 "ai.c"
				}
#line 231 "../src/ai.vala"
				_tmp2_ = FALSE;
#line 231 "../src/ai.vala"
				if (((gint) k) >= 0) {
#line 231 "../src/ai.vala"
					_tmp7_ = ((gint) l) >= 0;
#line 1205 "ai.c"
				} else {
#line 231 "../src/ai.vala"
					_tmp7_ = FALSE;
#line 1209 "ai.c"
				}
#line 231 "../src/ai.vala"
				if (_tmp7_) {
#line 1213 "ai.c"
					Player _tmp8_;
#line 231 "../src/ai.vala"
					_tmp8_ = (*board)[(k * (*board_length2)) + l];
#line 231 "../src/ai.vala"
					_tmp6_ = _tmp8_ == player;
#line 1219 "ai.c"
				} else {
#line 231 "../src/ai.vala"
					_tmp6_ = FALSE;
#line 1223 "ai.c"
				}
#line 231 "../src/ai.vala"
				if (!_tmp6_) {
#line 231 "../src/ai.vala"
					break;
#line 1229 "ai.c"
				}
			}
		}
	}
	{
		gint8 k = 0;
		gint8 l = 0;
#line 232 "../src/ai.vala"
		k = (gint8) (i + 1);
#line 232 "../src/ai.vala"
		l = (gint8) (j + 1);
#line 1241 "ai.c"
		{
			gboolean _tmp9_ = FALSE;
#line 232 "../src/ai.vala"
			_tmp9_ = TRUE;
#line 232 "../src/ai.vala"
			while (TRUE) {
#line 1248 "ai.c"
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
#line 232 "../src/ai.vala"
				if (!_tmp9_) {
#line 1253 "ai.c"
					gint8 _tmp10_;
					gint8 _tmp11_;
					guint8 _tmp12_;
#line 232 "../src/ai.vala"
					_tmp10_ = k;
#line 232 "../src/ai.vala"
					k = _tmp10_ + 1;
#line 232 "../src/ai.vala"
					_tmp11_ = l;
#line 232 "../src/ai.vala"
					l = _tmp11_ + 1;
#line 232 "../src/ai.vala"
					_tmp12_ = count;
#line 232 "../src/ai.vala"
					count = _tmp12_ + 1;
#line 1269 "ai.c"
				}
#line 232 "../src/ai.vala"
				_tmp9_ = FALSE;
#line 232 "../src/ai.vala"
				if (((guint8) k) < n_rows) {
#line 232 "../src/ai.vala"
					_tmp14_ = ((guint8) l) < n_cols;
#line 1277 "ai.c"
				} else {
#line 232 "../src/ai.vala"
					_tmp14_ = FALSE;
#line 1281 "ai.c"
				}
#line 232 "../src/ai.vala"
				if (_tmp14_) {
#line 1285 "ai.c"
					Player _tmp15_;
#line 232 "../src/ai.vala"
					_tmp15_ = (*board)[(k * (*board_length2)) + l];
#line 232 "../src/ai.vala"
					_tmp13_ = _tmp15_ == player;
#line 1291 "ai.c"
				} else {
#line 232 "../src/ai.vala"
					_tmp13_ = FALSE;
#line 1295 "ai.c"
				}
#line 232 "../src/ai.vala"
				if (!_tmp13_) {
#line 232 "../src/ai.vala"
					break;
#line 1301 "ai.c"
				}
			}
		}
	}
#line 234 "../src/ai.vala"
	result = count >= line;
#line 234 "../src/ai.vala"
	return result;
#line 1310 "ai.c"
}

inline gboolean
ai_horizontal_win (Player player,
                   guint8 line,
                   guint8 _i,
                   guint8 _j,
                   Player** board,
                   gint* board_length1,
                   gint* board_length2)
{
	guint8 n_cols = 0U;
	gint _tmp0_;
	gint8 i = 0;
	gint8 j = 0;
	guint8 count = 0U;
	gboolean result;
#line 239 "../src/ai.vala"
	_tmp0_ = *board_length2;
#line 239 "../src/ai.vala"
	n_cols = (guint8) _tmp0_;
#line 240 "../src/ai.vala"
	i = (gint8) _i;
#line 241 "../src/ai.vala"
	j = (gint8) _j;
#line 243 "../src/ai.vala"
	count = (guint8) 0;
#line 1338 "ai.c"
	{
		gint8 k = 0;
#line 245 "../src/ai.vala"
		k = j;
#line 1343 "ai.c"
		{
			gboolean _tmp1_ = FALSE;
#line 245 "../src/ai.vala"
			_tmp1_ = TRUE;
#line 245 "../src/ai.vala"
			while (TRUE) {
#line 1350 "ai.c"
				gboolean _tmp4_ = FALSE;
#line 245 "../src/ai.vala"
				if (!_tmp1_) {
#line 1354 "ai.c"
					gint8 _tmp2_;
					guint8 _tmp3_;
#line 245 "../src/ai.vala"
					_tmp2_ = k;
#line 245 "../src/ai.vala"
					k = _tmp2_ - 1;
#line 245 "../src/ai.vala"
					_tmp3_ = count;
#line 245 "../src/ai.vala"
					count = _tmp3_ + 1;
#line 1365 "ai.c"
				}
#line 245 "../src/ai.vala"
				_tmp1_ = FALSE;
#line 245 "../src/ai.vala"
				if (((gint) k) >= 0) {
#line 1371 "ai.c"
					Player _tmp5_;
#line 245 "../src/ai.vala"
					_tmp5_ = (*board)[(i * (*board_length2)) + k];
#line 245 "../src/ai.vala"
					_tmp4_ = _tmp5_ == player;
#line 1377 "ai.c"
				} else {
#line 245 "../src/ai.vala"
					_tmp4_ = FALSE;
#line 1381 "ai.c"
				}
#line 245 "../src/ai.vala"
				if (!_tmp4_) {
#line 245 "../src/ai.vala"
					break;
#line 1387 "ai.c"
				}
			}
		}
	}
	{
		gint8 k = 0;
#line 246 "../src/ai.vala"
		k = (gint8) (j + 1);
#line 1396 "ai.c"
		{
			gboolean _tmp6_ = FALSE;
#line 246 "../src/ai.vala"
			_tmp6_ = TRUE;
#line 246 "../src/ai.vala"
			while (TRUE) {
#line 1403 "ai.c"
				gboolean _tmp9_ = FALSE;
#line 246 "../src/ai.vala"
				if (!_tmp6_) {
#line 1407 "ai.c"
					gint8 _tmp7_;
					guint8 _tmp8_;
#line 246 "../src/ai.vala"
					_tmp7_ = k;
#line 246 "../src/ai.vala"
					k = _tmp7_ + 1;
#line 246 "../src/ai.vala"
					_tmp8_ = count;
#line 246 "../src/ai.vala"
					count = _tmp8_ + 1;
#line 1418 "ai.c"
				}
#line 246 "../src/ai.vala"
				_tmp6_ = FALSE;
#line 246 "../src/ai.vala"
				if (((guint8) k) < n_cols) {
#line 1424 "ai.c"
					Player _tmp10_;
#line 246 "../src/ai.vala"
					_tmp10_ = (*board)[(i * (*board_length2)) + k];
#line 246 "../src/ai.vala"
					_tmp9_ = _tmp10_ == player;
#line 1430 "ai.c"
				} else {
#line 246 "../src/ai.vala"
					_tmp9_ = FALSE;
#line 1434 "ai.c"
				}
#line 246 "../src/ai.vala"
				if (!_tmp9_) {
#line 246 "../src/ai.vala"
					break;
#line 1440 "ai.c"
				}
			}
		}
	}
#line 248 "../src/ai.vala"
	result = count >= line;
#line 248 "../src/ai.vala"
	return result;
#line 1449 "ai.c"
}

inline gboolean
ai_vertical_win (Player player,
                 guint8 line,
                 guint8 i,
                 guint8 j,
                 Player** board,
                 gint* board_length1,
                 gint* board_length2)
{
	guint8 n_rows = 0U;
	gint _tmp0_;
	guint8 count = 0U;
	gboolean result;
#line 253 "../src/ai.vala"
	_tmp0_ = *board_length1;
#line 253 "../src/ai.vala"
	n_rows = (guint8) _tmp0_;
#line 254 "../src/ai.vala"
	count = (guint8) 0;
#line 1471 "ai.c"
	{
		guint8 k = 0U;
#line 256 "../src/ai.vala"
		k = i;
#line 1476 "ai.c"
		{
			gboolean _tmp1_ = FALSE;
#line 256 "../src/ai.vala"
			_tmp1_ = TRUE;
#line 256 "../src/ai.vala"
			while (TRUE) {
#line 1483 "ai.c"
				gboolean _tmp4_ = FALSE;
#line 256 "../src/ai.vala"
				if (!_tmp1_) {
#line 1487 "ai.c"
					guint8 _tmp2_;
					guint8 _tmp3_;
#line 256 "../src/ai.vala"
					_tmp2_ = k;
#line 256 "../src/ai.vala"
					k = _tmp2_ + 1;
#line 256 "../src/ai.vala"
					_tmp3_ = count;
#line 256 "../src/ai.vala"
					count = _tmp3_ + 1;
#line 1498 "ai.c"
				}
#line 256 "../src/ai.vala"
				_tmp1_ = FALSE;
#line 256 "../src/ai.vala"
				if (k < n_rows) {
#line 1504 "ai.c"
					Player _tmp5_;
#line 256 "../src/ai.vala"
					_tmp5_ = (*board)[(k * (*board_length2)) + j];
#line 256 "../src/ai.vala"
					_tmp4_ = _tmp5_ == player;
#line 1510 "ai.c"
				} else {
#line 256 "../src/ai.vala"
					_tmp4_ = FALSE;
#line 1514 "ai.c"
				}
#line 256 "../src/ai.vala"
				if (!_tmp4_) {
#line 256 "../src/ai.vala"
					break;
#line 1520 "ai.c"
				}
			}
		}
	}
#line 258 "../src/ai.vala"
	result = count >= line;
#line 258 "../src/ai.vala"
	return result;
#line 1529 "ai.c"
}

gboolean
ai_board_full (Player** board,
               gint* board_length1,
               gint* board_length2)
{
	guint8 n_cols = 0U;
	gint _tmp0_;
	gboolean result;
#line 268 "../src/ai.vala"
	_tmp0_ = *board_length2;
#line 268 "../src/ai.vala"
	n_cols = (guint8) _tmp0_;
#line 1544 "ai.c"
	{
		guint8 i = 0U;
#line 269 "../src/ai.vala"
		i = (guint8) 0;
#line 1549 "ai.c"
		{
			gboolean _tmp1_ = FALSE;
#line 269 "../src/ai.vala"
			_tmp1_ = TRUE;
#line 269 "../src/ai.vala"
			while (TRUE) {
#line 1556 "ai.c"
				Player _tmp3_;
#line 269 "../src/ai.vala"
				if (!_tmp1_) {
#line 1560 "ai.c"
					guint8 _tmp2_;
#line 269 "../src/ai.vala"
					_tmp2_ = i;
#line 269 "../src/ai.vala"
					i = _tmp2_ + 1;
#line 1566 "ai.c"
				}
#line 269 "../src/ai.vala"
				_tmp1_ = FALSE;
#line 269 "../src/ai.vala"
				if (!(i < n_cols)) {
#line 269 "../src/ai.vala"
					break;
#line 1574 "ai.c"
				}
#line 270 "../src/ai.vala"
				_tmp3_ = (*board)[(0 * (*board_length2)) + i];
#line 270 "../src/ai.vala"
				if (_tmp3_ == PLAYER_NOBODY) {
#line 271 "../src/ai.vala"
					result = FALSE;
#line 271 "../src/ai.vala"
					return result;
#line 1584 "ai.c"
				}
			}
		}
	}
#line 272 "../src/ai.vala"
	result = TRUE;
#line 272 "../src/ai.vala"
	return result;
#line 1593 "ai.c"
}

gboolean
ai_move (Player player,
         guint8 column,
         Player** board,
         gint* board_length1,
         gint* board_length2)
{
	guint8 n_rows = 0U;
	gint _tmp0_;
	gint8 row = 0;
	gboolean result;
#line 278 "../src/ai.vala"
	_tmp0_ = *board_length1;
#line 278 "../src/ai.vala"
	n_rows = (guint8) _tmp0_;
#line 1611 "ai.c"
	{
		gboolean _tmp1_ = FALSE;
#line 281 "../src/ai.vala"
		row = (gint8) (n_rows - 1);
#line 281 "../src/ai.vala"
		_tmp1_ = TRUE;
#line 281 "../src/ai.vala"
		while (TRUE) {
#line 1620 "ai.c"
			gboolean _tmp3_ = FALSE;
#line 281 "../src/ai.vala"
			if (!_tmp1_) {
#line 1624 "ai.c"
				gint8 _tmp2_;
#line 281 "../src/ai.vala"
				_tmp2_ = row;
#line 281 "../src/ai.vala"
				row = _tmp2_ - 1;
#line 1630 "ai.c"
			}
#line 281 "../src/ai.vala"
			_tmp1_ = FALSE;
#line 281 "../src/ai.vala"
			if (((gint) row) >= 0) {
#line 1636 "ai.c"
				Player _tmp4_;
#line 281 "../src/ai.vala"
				_tmp4_ = (*board)[(row * (*board_length2)) + column];
#line 281 "../src/ai.vala"
				_tmp3_ = _tmp4_ != PLAYER_NOBODY;
#line 1642 "ai.c"
			} else {
#line 281 "../src/ai.vala"
				_tmp3_ = FALSE;
#line 1646 "ai.c"
			}
#line 281 "../src/ai.vala"
			if (!_tmp3_) {
#line 281 "../src/ai.vala"
				break;
#line 1652 "ai.c"
			}
		}
	}
#line 283 "../src/ai.vala"
	if (((gint) row) < 0) {
#line 284 "../src/ai.vala"
		result = FALSE;
#line 284 "../src/ai.vala"
		return result;
#line 1662 "ai.c"
	}
#line 286 "../src/ai.vala"
	(*board)[(row * (*board_length2)) + column] = player;
#line 287 "../src/ai.vala"
	result = TRUE;
#line 287 "../src/ai.vala"
	return result;
#line 1670 "ai.c"
}

void
ai_unmove (guint8 column,
           Player** board,
           gint* board_length1,
           gint* board_length2)
{
	guint8 n_rows = 0U;
	gint _tmp0_;
	guint8 row = 0U;
#line 293 "../src/ai.vala"
	_tmp0_ = *board_length1;
#line 293 "../src/ai.vala"
	n_rows = (guint8) _tmp0_;
#line 1686 "ai.c"
	{
		gboolean _tmp1_ = FALSE;
#line 296 "../src/ai.vala"
		row = (guint8) 0;
#line 296 "../src/ai.vala"
		_tmp1_ = TRUE;
#line 296 "../src/ai.vala"
		while (TRUE) {
#line 1695 "ai.c"
			gboolean _tmp3_ = FALSE;
#line 296 "../src/ai.vala"
			if (!_tmp1_) {
#line 1699 "ai.c"
				guint8 _tmp2_;
#line 296 "../src/ai.vala"
				_tmp2_ = row;
#line 296 "../src/ai.vala"
				row = _tmp2_ + 1;
#line 1705 "ai.c"
			}
#line 296 "../src/ai.vala"
			_tmp1_ = FALSE;
#line 296 "../src/ai.vala"
			if (row < n_rows) {
#line 1711 "ai.c"
				Player _tmp4_;
#line 296 "../src/ai.vala"
				_tmp4_ = (*board)[(row * (*board_length2)) + column];
#line 296 "../src/ai.vala"
				_tmp3_ = _tmp4_ == PLAYER_NOBODY;
#line 1717 "ai.c"
			} else {
#line 296 "../src/ai.vala"
				_tmp3_ = FALSE;
#line 1721 "ai.c"
			}
#line 296 "../src/ai.vala"
			if (!_tmp3_) {
#line 296 "../src/ai.vala"
				break;
#line 1727 "ai.c"
			}
		}
	}
#line 298 "../src/ai.vala"
	(*board)[(row * (*board_length2)) + column] = PLAYER_NOBODY;
#line 1733 "ai.c"
}

guint8
ai_immediate_win (Player player,
                  guint8 line,
                  Player** board,
                  gint* board_length1,
                  gint* board_length2)
{
	guint8 n_cols = 0U;
	gint _tmp0_;
	guint8 result;
#line 305 "../src/ai.vala"
	_tmp0_ = *board_length2;
#line 305 "../src/ai.vala"
	n_cols = (guint8) _tmp0_;
#line 1750 "ai.c"
	{
		guint8 i = 0U;
#line 306 "../src/ai.vala"
		i = (guint8) 0;
#line 1755 "ai.c"
		{
			gboolean _tmp1_ = FALSE;
#line 306 "../src/ai.vala"
			_tmp1_ = TRUE;
#line 306 "../src/ai.vala"
			while (TRUE) {
#line 1762 "ai.c"
				gboolean _tmp3_;
				gboolean player_wins = FALSE;
				gboolean _tmp4_;
#line 306 "../src/ai.vala"
				if (!_tmp1_) {
#line 1768 "ai.c"
					guint8 _tmp2_;
#line 306 "../src/ai.vala"
					_tmp2_ = i;
#line 306 "../src/ai.vala"
					i = _tmp2_ + 1;
#line 1774 "ai.c"
				}
#line 306 "../src/ai.vala"
				_tmp1_ = FALSE;
#line 306 "../src/ai.vala"
				if (!(i < n_cols)) {
#line 306 "../src/ai.vala"
					break;
#line 1782 "ai.c"
				}
#line 308 "../src/ai.vala"
				_tmp3_ = ai_move (player, i, board, (gint*) (board_length1), (gint*) (board_length2));
#line 308 "../src/ai.vala"
				if (!_tmp3_) {
#line 309 "../src/ai.vala"
					continue;
#line 1790 "ai.c"
				}
#line 311 "../src/ai.vala"
				_tmp4_ = ai_victory (player, line, i, board, (gint*) (board_length1), (gint*) (board_length2));
#line 311 "../src/ai.vala"
				player_wins = _tmp4_;
#line 312 "../src/ai.vala"
				ai_unmove (i, board, (gint*) (board_length1), (gint*) (board_length2));
#line 314 "../src/ai.vala"
				if (player_wins) {
#line 315 "../src/ai.vala"
					result = i;
#line 315 "../src/ai.vala"
					return result;
#line 1804 "ai.c"
				}
			}
		}
	}
#line 319 "../src/ai.vala"
	result = G_MAXUINT8;
#line 319 "../src/ai.vala"
	return result;
#line 1813 "ai.c"
}

inline gint16
ai_heurist (Difficulty level,
            guint8 line,
            Player** board,
            gint* board_length1,
            gint* board_length2)
{
	gint16 result;
#line 343 "../src/ai.vala"
	switch (level) {
#line 343 "../src/ai.vala"
		case DIFFICULTY_EASY:
#line 1828 "ai.c"
		{
			gint16 _tmp0_;
#line 345 "../src/ai.vala"
			_tmp0_ = ai_heurist_easy (line, board, (gint*) (board_length1), (gint*) (board_length2));
#line 345 "../src/ai.vala"
			result = _tmp0_;
#line 345 "../src/ai.vala"
			return result;
#line 1837 "ai.c"
		}
#line 343 "../src/ai.vala"
		case DIFFICULTY_MEDIUM:
#line 1841 "ai.c"
		{
#line 346 "../src/ai.vala"
			result = ai_heurist_medium ();
#line 346 "../src/ai.vala"
			return result;
#line 1847 "ai.c"
		}
#line 343 "../src/ai.vala"
		case DIFFICULTY_HARD:
#line 1851 "ai.c"
		{
			gint16 _tmp1_;
#line 347 "../src/ai.vala"
			_tmp1_ = ai_heurist_hard (line, board, (gint*) (board_length1), (gint*) (board_length2));
#line 347 "../src/ai.vala"
			result = _tmp1_;
#line 347 "../src/ai.vala"
			return result;
#line 1860 "ai.c"
		}
		default:
		{
#line 348 "../src/ai.vala"
			g_assert_not_reached ();
#line 1866 "ai.c"
		}
	}
}

gint16
ai_heurist_easy (guint8 line,
                 Player** board,
                 gint* board_length1,
                 gint* board_length2)
{
	gint16 _tmp0_;
	gint16 result;
#line 354 "../src/ai.vala"
	_tmp0_ = ai_heurist_hard (line, board, (gint*) (board_length1), (gint*) (board_length2));
#line 354 "../src/ai.vala"
	result = (gint16) (-1 * _tmp0_);
#line 354 "../src/ai.vala"
	return result;
#line 1885 "ai.c"
}

inline gint16
ai_heurist_medium (void)
{
	gint16 result;
#line 359 "../src/ai.vala"
	result = (gint16) g_random_int_range ((gint32) 1, (gint32) 49);
#line 359 "../src/ai.vala"
	return result;
#line 1896 "ai.c"
}

gint16
ai_heurist_hard (guint8 line,
                 Player** board,
                 gint* board_length1,
                 gint* board_length2)
{
	gint8 count = 0;
	gint8 _tmp0_;
	gint8 _tmp1_;
	gint16 _tmp2_ = 0;
	gint16 result;
#line 364 "../src/ai.vala"
	_tmp0_ = ai_count_3_in_a_row (PLAYER_OPPONENT, line, board, (gint*) (board_length1), (gint*) (board_length2));
#line 364 "../src/ai.vala"
	_tmp1_ = ai_count_3_in_a_row (PLAYER_HUMAN, line, board, (gint*) (board_length1), (gint*) (board_length2));
#line 364 "../src/ai.vala"
	count = _tmp0_ - _tmp1_;
#line 365 "../src/ai.vala"
	if (((gint) count) == 0) {
#line 365 "../src/ai.vala"
		_tmp2_ = (gint16) g_random_int_range ((gint32) 1, (gint32) 49);
#line 1920 "ai.c"
	} else {
#line 365 "../src/ai.vala"
		_tmp2_ = (gint16) (((gint16) count) * 100);
#line 1924 "ai.c"
	}
#line 365 "../src/ai.vala"
	result = _tmp2_;
#line 365 "../src/ai.vala"
	return result;
#line 1930 "ai.c"
}

gint8
ai_count_3_in_a_row (Player player,
                     guint8 line,
                     Player** board,
                     gint* board_length1,
                     gint* board_length2)
{
	guint8 n_rows = 0U;
	gint _tmp0_;
	guint8 n_cols = 0U;
	gint _tmp1_;
	gint8 count = 0;
	gint8 result;
#line 372 "../src/ai.vala"
	_tmp0_ = *board_length1;
#line 372 "../src/ai.vala"
	n_rows = (guint8) _tmp0_;
#line 373 "../src/ai.vala"
	_tmp1_ = *board_length2;
#line 373 "../src/ai.vala"
	n_cols = (guint8) _tmp1_;
#line 374 "../src/ai.vala"
	count = (gint8) 0;
#line 1956 "ai.c"
	{
		guint8 j = 0U;
#line 376 "../src/ai.vala"
		j = (guint8) 0;
#line 1961 "ai.c"
		{
			gboolean _tmp2_ = FALSE;
#line 376 "../src/ai.vala"
			_tmp2_ = TRUE;
#line 376 "../src/ai.vala"
			while (TRUE) {
#line 376 "../src/ai.vala"
				if (!_tmp2_) {
#line 1970 "ai.c"
					guint8 _tmp3_;
#line 376 "../src/ai.vala"
					_tmp3_ = j;
#line 376 "../src/ai.vala"
					j = _tmp3_ + 1;
#line 1976 "ai.c"
				}
#line 376 "../src/ai.vala"
				_tmp2_ = FALSE;
#line 376 "../src/ai.vala"
				if (!(j < n_cols)) {
#line 376 "../src/ai.vala"
					break;
#line 1984 "ai.c"
				}
				{
					guint8 i = 0U;
#line 378 "../src/ai.vala"
					i = (guint8) 0;
#line 1990 "ai.c"
					{
						gboolean _tmp4_ = FALSE;
#line 378 "../src/ai.vala"
						_tmp4_ = TRUE;
#line 378 "../src/ai.vala"
						while (TRUE) {
#line 1997 "ai.c"
							Player _tmp6_;
							gboolean _tmp7_;
							gboolean _tmp8_;
#line 378 "../src/ai.vala"
							if (!_tmp4_) {
#line 2003 "ai.c"
								guint8 _tmp5_;
#line 378 "../src/ai.vala"
								_tmp5_ = i;
#line 378 "../src/ai.vala"
								i = _tmp5_ + 1;
#line 2009 "ai.c"
							}
#line 378 "../src/ai.vala"
							_tmp4_ = FALSE;
#line 378 "../src/ai.vala"
							if (!(i < n_rows)) {
#line 378 "../src/ai.vala"
								break;
#line 2017 "ai.c"
							}
#line 380 "../src/ai.vala"
							_tmp6_ = (*board)[(i * (*board_length2)) + j];
#line 380 "../src/ai.vala"
							if (_tmp6_ != PLAYER_NOBODY) {
#line 381 "../src/ai.vala"
								break;
#line 2025 "ai.c"
							}
#line 383 "../src/ai.vala"
							_tmp7_ = ai_all_adjacent_empty (i, j, board, (gint*) (board_length1), (gint*) (board_length2));
#line 383 "../src/ai.vala"
							if (_tmp7_) {
#line 384 "../src/ai.vala"
								continue;
#line 2033 "ai.c"
							}
#line 386 "../src/ai.vala"
							(*board)[(i * (*board_length2)) + j] = player;
#line 388 "../src/ai.vala"
							_tmp8_ = ai_victory (player, line, j, board, (gint*) (board_length1), (gint*) (board_length2));
#line 388 "../src/ai.vala"
							if (_tmp8_) {
#line 390 "../src/ai.vala"
								if (count < G_MAXINT8) {
#line 2043 "ai.c"
									gint8 _tmp9_;
#line 391 "../src/ai.vala"
									_tmp9_ = count;
#line 391 "../src/ai.vala"
									count = _tmp9_ + 1;
#line 2049 "ai.c"
								} else {
#line 393 "../src/ai.vala"
									g_warning ("ai.vala:393: Method count_3_in_a_row() exceeded its maximum count.");
#line 2053 "ai.c"
								}
							}
#line 396 "../src/ai.vala"
							(*board)[(i * (*board_length2)) + j] = PLAYER_NOBODY;
#line 2058 "ai.c"
						}
					}
				}
			}
		}
	}
#line 399 "../src/ai.vala"
	result = count;
#line 399 "../src/ai.vala"
	return result;
#line 2069 "ai.c"
}

inline gboolean
ai_all_adjacent_empty (guint8 _i,
                       guint8 _j,
                       Player** board,
                       gint* board_length1,
                       gint* board_length2)
{
	guint8 n_rows = 0U;
	gint _tmp0_;
	guint8 n_cols = 0U;
	gint _tmp1_;
	gint8 i = 0;
	gint8 j = 0;
	gboolean result;
#line 405 "../src/ai.vala"
	_tmp0_ = *board_length1;
#line 405 "../src/ai.vala"
	n_rows = (guint8) _tmp0_;
#line 406 "../src/ai.vala"
	_tmp1_ = *board_length2;
#line 406 "../src/ai.vala"
	n_cols = (guint8) _tmp1_;
#line 407 "../src/ai.vala"
	i = (gint8) _i;
#line 408 "../src/ai.vala"
	j = (gint8) _j;
#line 2098 "ai.c"
	{
		gint8 k = 0;
#line 410 "../src/ai.vala"
		k = (gint8) -1;
#line 2103 "ai.c"
		{
			gboolean _tmp2_ = FALSE;
#line 410 "../src/ai.vala"
			_tmp2_ = TRUE;
#line 410 "../src/ai.vala"
			while (TRUE) {
#line 410 "../src/ai.vala"
				if (!_tmp2_) {
#line 2112 "ai.c"
					gint8 _tmp3_;
#line 410 "../src/ai.vala"
					_tmp3_ = k;
#line 410 "../src/ai.vala"
					k = _tmp3_ + 1;
#line 2118 "ai.c"
				}
#line 410 "../src/ai.vala"
				_tmp2_ = FALSE;
#line 410 "../src/ai.vala"
				if (!(((gint) k) <= 1)) {
#line 410 "../src/ai.vala"
					break;
#line 2126 "ai.c"
				}
				{
					gint8 l = 0;
#line 412 "../src/ai.vala"
					l = (gint8) -1;
#line 2132 "ai.c"
					{
						gboolean _tmp4_ = FALSE;
#line 412 "../src/ai.vala"
						_tmp4_ = TRUE;
#line 412 "../src/ai.vala"
						while (TRUE) {
#line 2139 "ai.c"
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							gboolean _tmp8_ = FALSE;
							gboolean _tmp9_ = FALSE;
							gboolean _tmp10_ = FALSE;
#line 412 "../src/ai.vala"
							if (!_tmp4_) {
#line 2147 "ai.c"
								gint8 _tmp5_;
#line 412 "../src/ai.vala"
								_tmp5_ = l;
#line 412 "../src/ai.vala"
								l = _tmp5_ + 1;
#line 2153 "ai.c"
							}
#line 412 "../src/ai.vala"
							_tmp4_ = FALSE;
#line 412 "../src/ai.vala"
							if (!(((gint) l) <= 1)) {
#line 412 "../src/ai.vala"
								break;
#line 2161 "ai.c"
							}
#line 414 "../src/ai.vala"
							if (((gint) k) == 0) {
#line 414 "../src/ai.vala"
								_tmp6_ = ((gint) l) == 0;
#line 2167 "ai.c"
							} else {
#line 414 "../src/ai.vala"
								_tmp6_ = FALSE;
#line 2171 "ai.c"
							}
#line 414 "../src/ai.vala"
							if (_tmp6_) {
#line 415 "../src/ai.vala"
								continue;
#line 2177 "ai.c"
							}
#line 416 "../src/ai.vala"
							if (((gint) (i + k)) >= 0) {
#line 416 "../src/ai.vala"
								_tmp10_ = ((guint8) (i + k)) < n_rows;
#line 2183 "ai.c"
							} else {
#line 416 "../src/ai.vala"
								_tmp10_ = FALSE;
#line 2187 "ai.c"
							}
#line 416 "../src/ai.vala"
							if (_tmp10_) {
#line 416 "../src/ai.vala"
								_tmp9_ = ((gint) (j + l)) >= 0;
#line 2193 "ai.c"
							} else {
#line 416 "../src/ai.vala"
								_tmp9_ = FALSE;
#line 2197 "ai.c"
							}
#line 416 "../src/ai.vala"
							if (_tmp9_) {
#line 416 "../src/ai.vala"
								_tmp8_ = ((guint8) (j + l)) < n_cols;
#line 2203 "ai.c"
							} else {
#line 416 "../src/ai.vala"
								_tmp8_ = FALSE;
#line 2207 "ai.c"
							}
#line 416 "../src/ai.vala"
							if (_tmp8_) {
#line 2211 "ai.c"
								Player _tmp11_;
#line 416 "../src/ai.vala"
								_tmp11_ = (*board)[((i + k) * (*board_length2)) + (j + l)];
#line 416 "../src/ai.vala"
								_tmp7_ = _tmp11_ != PLAYER_NOBODY;
#line 2217 "ai.c"
							} else {
#line 416 "../src/ai.vala"
								_tmp7_ = FALSE;
#line 2221 "ai.c"
							}
#line 416 "../src/ai.vala"
							if (_tmp7_) {
#line 417 "../src/ai.vala"
								result = FALSE;
#line 417 "../src/ai.vala"
								return result;
#line 2229 "ai.c"
							}
						}
					}
				}
			}
		}
	}
#line 421 "../src/ai.vala"
	result = TRUE;
#line 421 "../src/ai.vala"
	return result;
#line 2241 "ai.c"
}

