/* four-in-a-row.c generated by valac 0.56.17, the Vala compiler
 * generated from four-in-a-row.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Four-in-a-row.

   Copyright © 2018 Jacob Humphrey
   Copyright © 2019 Arnaud Bonatti

   GNOME Four-in-a-row is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Four-in-a-row is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with GNOME Four-in-a-row.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gsound.h>
#include <glib/gi18n-lib.h>
#include <locale.h>
#include <stdio.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>

#define FOUR_IN_AROW_PROGRAM_NAME _ ("Four-in-a-row")
#define FOUR_IN_AROW_SPEED_BLINK ((guint) 150)
#define FOUR_IN_AROW_SPEED_MOVE ((guint) 35)
#define FOUR_IN_AROW_SPEED_DROP ((guint) 20)
#define FOUR_IN_AROW_COMPUTER_INITIAL_DELAY ((guint) 1200)
#define FOUR_IN_AROW_COMPUTER_MOVE_DELAY ((guint) 600)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_FOUR_IN_AROW (four_in_arow_get_type ())
#define FOUR_IN_AROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FOUR_IN_AROW, FourInARow))
#define FOUR_IN_AROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FOUR_IN_AROW, FourInARowClass))
#define IS_FOUR_IN_AROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FOUR_IN_AROW))
#define IS_FOUR_IN_AROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FOUR_IN_AROW))
#define FOUR_IN_AROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FOUR_IN_AROW, FourInARowClass))

typedef struct _FourInARow FourInARow;
typedef struct _FourInARowClass FourInARowClass;
typedef struct _FourInARowPrivate FourInARowPrivate;
typedef enum  {
	PLAYER_NOBODY,
	PLAYER_HUMAN,
	PLAYER_OPPONENT
} Player;

#define TYPE_PLAYER (player_get_type ())

#define TYPE_BOARD (board_get_type ())
#define BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD, Board))
#define BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD, BoardClass))
#define IS_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD))
#define IS_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD))
#define BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD, BoardClass))

typedef struct _Board Board;
typedef struct _BoardClass BoardClass;
typedef enum  {
	DIFFICULTY_EASY,
	DIFFICULTY_MEDIUM,
	DIFFICULTY_HARD
} Difficulty;

#define TYPE_DIFFICULTY (difficulty_get_type ())

#define TYPE_SCOREBOX (scorebox_get_type ())
#define SCOREBOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCOREBOX, Scorebox))
#define SCOREBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCOREBOX, ScoreboxClass))
#define IS_SCOREBOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCOREBOX))
#define IS_SCOREBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCOREBOX))
#define SCOREBOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCOREBOX, ScoreboxClass))

typedef struct _Scorebox Scorebox;
typedef struct _ScoreboxClass ScoreboxClass;

#define TYPE_GAME_BOARD_VIEW (game_board_view_get_type ())
#define GAME_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_BOARD_VIEW, GameBoardView))
#define GAME_BOARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_BOARD_VIEW, GameBoardViewClass))
#define IS_GAME_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_BOARD_VIEW))
#define IS_GAME_BOARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_BOARD_VIEW))
#define GAME_BOARD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_BOARD_VIEW, GameBoardViewClass))

typedef struct _GameBoardView GameBoardView;
typedef struct _GameBoardViewClass GameBoardViewClass;

#define TYPE_ADAPTATIVE_WINDOW (adaptative_window_get_type ())
#define ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindow))
#define ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))
#define IS_ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WINDOW))
#define IS_ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADAPTATIVE_WINDOW))
#define ADAPTATIVE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))

typedef struct _AdaptativeWindow AdaptativeWindow;
typedef struct _AdaptativeWindowClass AdaptativeWindowClass;

#define TYPE_GAME_WINDOW (game_window_get_type ())
#define GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_WINDOW, GameWindow))
#define GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_WINDOW, GameWindowClass))
#define IS_GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_WINDOW))
#define IS_GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_WINDOW))
#define GAME_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_WINDOW, GameWindowClass))

typedef struct _GameWindow GameWindow;
typedef struct _GameWindowClass GameWindowClass;

#define TYPE_NEW_GAME_SCREEN (new_game_screen_get_type ())
#define NEW_GAME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_GAME_SCREEN, NewGameScreen))
#define NEW_GAME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_GAME_SCREEN, NewGameScreenClass))
#define IS_NEW_GAME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_GAME_SCREEN))
#define IS_NEW_GAME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_GAME_SCREEN))
#define NEW_GAME_SCREEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_GAME_SCREEN, NewGameScreenClass))

typedef struct _NewGameScreen NewGameScreen;
typedef struct _NewGameScreenClass NewGameScreenClass;

#define TYPE_HISTORY_BUTTON (history_button_get_type ())
#define HISTORY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY_BUTTON, HistoryButton))
#define HISTORY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY_BUTTON, HistoryButtonClass))
#define IS_HISTORY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY_BUTTON))
#define IS_HISTORY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY_BUTTON))
#define HISTORY_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY_BUTTON, HistoryButtonClass))

typedef struct _HistoryButton HistoryButton;
typedef struct _HistoryButtonClass HistoryButtonClass;

#define TYPE_THEME_MANAGER (theme_manager_get_type ())
#define THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_MANAGER, ThemeManager))
#define THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_MANAGER, ThemeManagerClass))
#define IS_THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_MANAGER))
#define IS_THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_MANAGER))
#define THEME_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_MANAGER, ThemeManagerClass))

typedef struct _ThemeManager ThemeManager;
typedef struct _ThemeManagerClass ThemeManagerClass;
typedef enum  {
	FOUR_IN_AROW_SOUND_CONTEXT_STATE_INITIAL,
	FOUR_IN_AROW_SOUND_CONTEXT_STATE_WORKING,
	FOUR_IN_AROW_SOUND_CONTEXT_STATE_ERRORED
} FourInARowSoundContextState;

#define FOUR_IN_AROW_TYPE_SOUND_CONTEXT_STATE (four_in_arow_sound_context_state_get_type ())
enum  {
	FOUR_IN_AROW_0_PROPERTY,
	FOUR_IN_AROW_KEYPRESS_DROP_PROPERTY,
	FOUR_IN_AROW_KEYPRESS_RIGHT_PROPERTY,
	FOUR_IN_AROW_KEYPRESS_LEFT_PROPERTY,
	FOUR_IN_AROW_SOUND_ON_PROPERTY,
	FOUR_IN_AROW_NUM_PROPERTIES
};
static GParamSpec* four_in_arow_properties[FOUR_IN_AROW_NUM_PROPERTIES];
typedef enum  {
	FOUR_IN_AROW_ANIM_ID_NONE,
	FOUR_IN_AROW_ANIM_ID_MOVE,
	FOUR_IN_AROW_ANIM_ID_DROP,
	FOUR_IN_AROW_ANIM_ID_BLINK,
	FOUR_IN_AROW_ANIM_ID_HINT
} FourInARowAnimID;

#define FOUR_IN_AROW_TYPE_ANIM_ID (four_in_arow_anim_id_get_type ())
typedef enum  {
	FOUR_IN_AROW_SOUND_ID_DROP,
	FOUR_IN_AROW_SOUND_ID_I_WIN,
	FOUR_IN_AROW_SOUND_ID_YOU_WIN,
	FOUR_IN_AROW_SOUND_ID_PLAYER_WIN,
	FOUR_IN_AROW_SOUND_ID_DRAWN_GAME,
	FOUR_IN_AROW_SOUND_ID_COLUMN_FULL
} FourInARowSoundID;

#define FOUR_IN_AROW_TYPE_SOUND_ID (four_in_arow_sound_id_get_type ())
typedef void (*GSimpleActionChangeStateCallback) (GSimpleAction* action, GVariant* value, gpointer user_data);
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	GAME_WINDOW_FLAGS_SHOW_UNDO = 1 << 0,
	GAME_WINDOW_FLAGS_SHOW_START_BUTTON = 1 << 1
} GameWindowFlags;

#define TYPE_GAME_WINDOW_FLAGS (game_window_flags_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define FOUR_IN_AROW_TYPE_ANIMATE (four_in_arow_animate_get_type ())
#define FOUR_IN_AROW_ANIMATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FOUR_IN_AROW_TYPE_ANIMATE, FourInARowAnimate))
#define FOUR_IN_AROW_ANIMATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FOUR_IN_AROW_TYPE_ANIMATE, FourInARowAnimateClass))
#define FOUR_IN_AROW_IS_ANIMATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FOUR_IN_AROW_TYPE_ANIMATE))
#define FOUR_IN_AROW_IS_ANIMATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FOUR_IN_AROW_TYPE_ANIMATE))
#define FOUR_IN_AROW_ANIMATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FOUR_IN_AROW_TYPE_ANIMATE, FourInARowAnimateClass))

typedef struct _FourInARowAnimate FourInARowAnimate;
typedef struct _FourInARowAnimateClass FourInARowAnimateClass;
#define _four_in_arow_animate_unref0(var) ((var == NULL) ? NULL : (var = (four_in_arow_animate_unref (var), NULL)))

#define FOUR_IN_AROW_TYPE_NEXT_MOVE (four_in_arow_next_move_get_type ())
#define FOUR_IN_AROW_NEXT_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FOUR_IN_AROW_TYPE_NEXT_MOVE, FourInARowNextMove))
#define FOUR_IN_AROW_NEXT_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FOUR_IN_AROW_TYPE_NEXT_MOVE, FourInARowNextMoveClass))
#define FOUR_IN_AROW_IS_NEXT_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FOUR_IN_AROW_TYPE_NEXT_MOVE))
#define FOUR_IN_AROW_IS_NEXT_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FOUR_IN_AROW_TYPE_NEXT_MOVE))
#define FOUR_IN_AROW_NEXT_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FOUR_IN_AROW_TYPE_NEXT_MOVE, FourInARowNextMoveClass))

typedef struct _FourInARowNextMove FourInARowNextMove;
typedef struct _FourInARowNextMoveClass FourInARowNextMoveClass;
#define _four_in_arow_next_move_unref0(var) ((var == NULL) ? NULL : (var = (four_in_arow_next_move_unref (var), NULL)))
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _FourInARowNextMovePrivate FourInARowNextMovePrivate;
typedef struct _FourInARowParamSpecNextMove FourInARowParamSpecNextMove;
typedef struct _FourInARowAnimatePrivate FourInARowAnimatePrivate;
typedef struct _FourInARowParamSpecAnimate FourInARowParamSpecAnimate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FourInARow {
	GtkApplication parent_instance;
	FourInARowPrivate * priv;
};

struct _FourInARowClass {
	GtkApplicationClass parent_class;
};

struct _FourInARowPrivate {
	GSettings* settings;
	gboolean gameover;
	Player player;
	Player winner;
	Player last_first_player;
	Board* game_board;
	gboolean one_player_game;
	Difficulty ai_level;
	guint playgame_timeout;
	Scorebox* scorebox;
	GameBoardView* game_board_view;
	GameWindow* window;
	NewGameScreen* new_game_screen;
	HistoryButton* history_button_1;
	HistoryButton* history_button_2;
	gchar* vstr;
	guint8 moves;
	guint8 column;
	guint8 column_moveto;
	guint8 row;
	guint8 row_dropto;
	guint8* blink_lines;
	gint blink_lines_length1;
	gint blink_lines_length2;
	guint8 blink_line;
	Player blink_t;
	guint8 blink_n;
	gboolean blink_on;
	guint timeout;
	gint _keypress_drop;
	gint _keypress_right;
	gint _keypress_left;
	gboolean _sound_on;
	ThemeManager* theme_manager;
	GSimpleAction* game_type_action;
	GSimpleAction* next_round_action;
	GtkEventControllerKey* window_key_controller;
	GtkEventControllerKey* board_key_controller;
	GSoundContext* sound_context;
	FourInARowSoundContextState sound_context_state;
	GMenu* game_menu;
	GMenu* round_section;
};

struct _FourInARowNextMove {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FourInARowNextMovePrivate * priv;
};

struct _FourInARowNextMoveClass {
	GTypeClass parent_class;
	void (*finalize) (FourInARowNextMove *self);
};

struct _FourInARowNextMovePrivate {
	guint8 c;
	FourInARow* application;
};

struct _FourInARowParamSpecNextMove {
	GParamSpec parent_instance;
};

struct _FourInARowAnimate {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FourInARowAnimatePrivate * priv;
};

struct _FourInARowAnimateClass {
	GTypeClass parent_class;
	void (*finalize) (FourInARowAnimate *self);
};

struct _FourInARowAnimatePrivate {
	guint8 c;
	FourInARow* application;
	guint8 blink_n_times;
};

struct _FourInARowParamSpecAnimate {
	GParamSpec parent_instance;
};

static gint FourInARow_private_offset;
static gpointer four_in_arow_parent_class = NULL;
static gchar* four_in_arow_level;
static gint four_in_arow_size;
static gint four_in_arow_target;
static FourInARowAnimID four_in_arow_anim;
static FourInARowAnimID four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_NONE;
static gchar* four_in_arow_level = NULL;
static gint four_in_arow_size = 7;
static gint four_in_arow_target = 4;
static gboolean* four_in_arow_sound;
static gboolean* four_in_arow_sound = NULL;
static gint FourInARowNextMove_private_offset;
static gpointer four_in_arow_next_move_parent_class = NULL;
static gint FourInARowAnimate_private_offset;
static gpointer four_in_arow_animate_parent_class = NULL;

VALA_EXTERN GType four_in_arow_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FourInARow, g_object_unref)
VALA_EXTERN GType player_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType board_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Board, g_object_unref)
VALA_EXTERN GType difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType scorebox_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Scorebox, g_object_unref)
VALA_EXTERN GType game_board_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameBoardView, g_object_unref)
VALA_EXTERN GType adaptative_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWindow, g_object_unref)
VALA_EXTERN GType game_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameWindow, g_object_unref)
VALA_EXTERN GType new_game_screen_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewGameScreen, g_object_unref)
VALA_EXTERN GType history_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HistoryButton, g_object_unref)
VALA_EXTERN GType theme_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemeManager, g_object_unref)
static GType four_in_arow_sound_context_state_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType four_in_arow_anim_id_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType four_in_arow_sound_id_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void four_in_arow_change_game_type (FourInARow* self,
                                    GSimpleAction* action,
                                    GVariant* gvariant);
static void _four_in_arow_change_game_type_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                          GVariant* value,
                                                                          gpointer self);
static inline void four_in_arow_on_next_round (FourInARow* self);
static void _four_in_arow_on_next_round_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self);
static inline void four_in_arow_on_give_up (FourInARow* self);
static void _four_in_arow_on_give_up_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static inline void four_in_arow_on_game_scores (FourInARow* self);
static void _four_in_arow_on_game_scores_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static inline void four_in_arow_on_game_exit (FourInARow* self);
static void _four_in_arow_on_game_exit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static inline void four_in_arow_on_help_contents (FourInARow* self);
static void _four_in_arow_on_help_contents_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static inline void four_in_arow_on_help_about (FourInARow* self);
static void _four_in_arow_on_help_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self);
static gint four_in_arow_main (gchar** args,
                        gint args_length1);
static FourInARow* four_in_arow_new (void);
static FourInARow* four_in_arow_construct (GType object_type);
static gint four_in_arow_real_handle_local_options (GApplication* base,
                                             GVariantDict* options);
static gboolean* _bool_dup (gboolean* self);
static void four_in_arow_real_startup (GApplication* base);
VALA_EXTERN Board* board_new (guint8 size,
                  guint8 line);
VALA_EXTERN Board* board_construct (GType object_type,
                        guint8 size,
                        guint8 line);
static void four_in_arow_clear_board (FourInARow* self);
static inline void four_in_arow_init_sound (FourInARow* self);
VALA_EXTERN ThemeManager* theme_manager_new (guint8 size);
VALA_EXTERN ThemeManager* theme_manager_construct (GType object_type,
                                       guint8 size);
VALA_EXTERN NewGameScreen* new_game_screen_new (void);
VALA_EXTERN NewGameScreen* new_game_screen_construct (GType object_type);
VALA_EXTERN GameBoardView* game_board_view_new (Board* game_board,
                                    ThemeManager* theme_manager);
VALA_EXTERN GameBoardView* game_board_view_construct (GType object_type,
                                          Board* game_board,
                                          ThemeManager* theme_manager);
VALA_EXTERN gchar** theme_manager_get_themes (ThemeManager* self,
                                  gint* result_length1);
static inline void four_in_arow_generate_game_menu (FourInARow* self);
VALA_EXTERN HistoryButton* history_button_new (GMenu** menu,
                                   ThemeManager* theme_manager);
VALA_EXTERN HistoryButton* history_button_construct (GType object_type,
                                         GMenu** menu,
                                         ThemeManager* theme_manager);
VALA_EXTERN GType game_window_flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameWindow* game_window_new (const gchar* css_resource,
                             const gchar* name,
                             gboolean start_now,
                             GameWindowFlags flags,
                             GtkBox* new_game_screen,
                             GtkWidget* _view,
                             GMenu* app_menu,
                             GtkWidget* _game_widget_1,
                             GtkWidget* game_widget_2);
VALA_EXTERN GameWindow* game_window_construct (GType object_type,
                                   const gchar* css_resource,
                                   const gchar* name,
                                   gboolean start_now,
                                   GameWindowFlags flags,
                                   GtkBox* new_game_screen,
                                   GtkWidget* _view,
                                   GMenu* app_menu,
                                   GtkWidget* _game_widget_1,
                                   GtkWidget* game_widget_2);
VALA_EXTERN Scorebox* scorebox_new (GtkWindow* parent,
                        FourInARow* application,
                        ThemeManager* theme_manager);
VALA_EXTERN Scorebox* scorebox_construct (GType object_type,
                              GtkWindow* parent,
                              FourInARow* application,
                              ThemeManager* theme_manager);
static void four_in_arow_prompt_player (FourInARow* self);
static void _four_in_arow_prompt_player_g_settings_changed (GSettings* _sender,
                                                     const gchar* key,
                                                     gpointer self);
static inline void four_in_arow_add_actions (FourInARow* self);
static inline gboolean four_in_arow_column_clicked_cb (FourInARow* self,
                                         guint8 column);
static gboolean _four_in_arow_column_clicked_cb_game_board_view_column_clicked (GameBoardView* _sender,
                                                                         guint8 column,
                                                                         gpointer self);
static inline void four_in_arow_init_keyboard (FourInARow* self);
static inline void four_in_arow_on_game_new (FourInARow* self);
static void _four_in_arow_on_game_new_game_window_play (GameWindow* _sender,
                                                 gpointer self);
static inline void four_in_arow_on_game_undo (FourInARow* self);
static void _four_in_arow_on_game_undo_game_window_undo (GameWindow* _sender,
                                                  gpointer self);
static inline void four_in_arow_on_game_hint (FourInARow* self);
static void _four_in_arow_on_game_hint_game_window_hint (GameWindow* _sender,
                                                  gpointer self);
VALA_EXTERN void game_window_allow_hint (GameWindow* self,
                             gboolean allow);
VALA_EXTERN void game_window_allow_undo (GameWindow* self,
                             gboolean allow);
VALA_EXTERN void four_in_arow_game_reset (FourInARow* self,
                              gboolean reload_settings);
static void __lambda9_ (FourInARow* self);
static void ___lambda9__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void __lambda10_ (FourInARow* self);
VALA_EXTERN void new_game_screen_update_sensitivity (NewGameScreen* self,
                                         gboolean new_sensitivity);
static void ___lambda10__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void four_in_arow_real_activate (GApplication* base);
static void four_in_arow_stop_anim (FourInARow* self);
static void four_in_arow_set_gameover (FourInARow* self,
                                gboolean new_value);
VALA_EXTERN void scorebox_new_match (Scorebox* self,
                         gboolean _one_player_game);
static void four_in_arow_switch_players (FourInARow* self);
static void four_in_arow_set_status_message (FourInARow* self,
                                      const gchar* message);
static void four_in_arow_move_cursor (FourInARow* self,
                               guint8 c);
static gboolean four_in_arow_is_player_human (FourInARow* self);
static gboolean ___lambda7_ (FourInARow* self);
VALA_EXTERN guint8 ai_playgame (guint8 size,
                    Difficulty level,
                    const gchar* vstr,
                    guint8 line);
static void four_in_arow_process_move (FourInARow* self,
                                guint8 c);
static gboolean ____lambda7__gsource_func (gpointer self);
static void four_in_arow_blink_winner (FourInARow* self,
                                guint8 n);
VALA_EXTERN gboolean board_is_line_at (Board* self,
                           Player tile,
                           guint8 row,
                           guint8 col,
                           guint8** lines,
                           gint* lines_length1,
                           gint* lines_length2);
static gpointer four_in_arow_animate_ref (gpointer instance);
static void four_in_arow_animate_unref (gpointer instance);
static GParamSpec* four_in_arow_param_spec_animate (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags) G_GNUC_UNUSED ;
static void four_in_arow_value_set_animate (GValue* value,
                                     gpointer v_object) G_GNUC_UNUSED ;
static void four_in_arow_value_take_animate (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED ;
static gpointer four_in_arow_value_get_animate (const GValue* value) G_GNUC_UNUSED ;
static GType four_in_arow_animate_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FourInARowAnimate, four_in_arow_animate_unref)
static FourInARowAnimate* four_in_arow_animate_new (guint8 c,
                                             FourInARow* application,
                                             guint8 blink_n_times);
static FourInARowAnimate* four_in_arow_animate_construct (GType object_type,
                                                   guint8 c,
                                                   FourInARow* application,
                                                   guint8 blink_n_times);
static gboolean four_in_arow_animate_exec (FourInARowAnimate* self);
static gboolean _four_in_arow_animate_exec_gsource_func (gpointer self);
static inline void four_in_arow_draw_line (FourInARow* self,
                             guint8 _r1,
                             guint8 _c1,
                             guint8 _r2,
                             guint8 _c2,
                             Player owner);
VALA_EXTERN void board_set (Board* self,
                guint8 x,
                guint8 y,
                Player tile);
VALA_EXTERN void game_board_view_draw_tile (GameBoardView* self,
                                gint row,
                                gint col);
static void four_in_arow_update_round_section (FourInARow* self,
                                        gboolean menu_init);
VALA_EXTERN gboolean scorebox_is_first_game (Scorebox* self);
VALA_EXTERN void history_button_set_player (HistoryButton* self,
                                Player player);
VALA_EXTERN gchar* theme_manager_get_player_win (ThemeManager* self,
                                     Player who);
VALA_EXTERN gchar* theme_manager_get_player_turn (ThemeManager* self,
                                      Player who);
static void four_in_arow_swap_player (FourInARow* self);
static void four_in_arow_process_move3 (FourInARow* self,
                                 guint8 c);
static void four_in_arow_play_sound (FourInARow* self,
                              FourInARowSoundID id);
static inline void four_in_arow_check_game_state (FourInARow* self);
VALA_EXTERN void scorebox_win (Scorebox* self,
                   Player player);
static gboolean ____lambda8_ (FourInARow* self);
static gpointer four_in_arow_next_move_ref (gpointer instance);
static void four_in_arow_next_move_unref (gpointer instance);
static GParamSpec* four_in_arow_param_spec_next_move (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags) G_GNUC_UNUSED ;
static void four_in_arow_value_set_next_move (GValue* value,
                                       gpointer v_object) G_GNUC_UNUSED ;
static void four_in_arow_value_take_next_move (GValue* value,
                                        gpointer v_object) G_GNUC_UNUSED ;
static gpointer four_in_arow_value_get_next_move (const GValue* value) G_GNUC_UNUSED ;
static GType four_in_arow_next_move_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FourInARowNextMove, four_in_arow_next_move_unref)
static FourInARowNextMove* four_in_arow_next_move_new (guint8 c,
                                                FourInARow* application);
static FourInARowNextMove* four_in_arow_next_move_construct (GType object_type,
                                                      guint8 c,
                                                      FourInARow* application);
static gboolean four_in_arow_next_move_exec (FourInARowNextMove* self);
static gboolean _four_in_arow_next_move_exec_gsource_func (gpointer self);
static gboolean _____lambda8__gsource_func (gpointer self);
static void four_in_arow_process_move2 (FourInARow* self,
                                 guint8 c);
VALA_EXTERN guint8 board_first_empty_row (Board* self,
                              guint8 col);
static inline void four_in_arow_drop (FourInARow* self);
static inline void four_in_arow_move (FourInARow* self,
                        guint8 c);
VALA_EXTERN void game_window_set_subtitle (GameWindow* self,
                               const gchar* subtitle);
VALA_EXTERN void board_clear (Board* self);
static inline void four_in_arow_blink_tile (FourInARow* self,
                              guint8 row,
                              guint8 col,
                              Player tile,
                              guint8 n);
VALA_EXTERN Player board_get (Board* self,
                  guint8 x,
                  guint8 y);
VALA_EXTERN void scorebox_unwin (Scorebox* self);
static inline gboolean four_in_arow_on_window_key_pressed (FourInARow* self,
                                             GtkEventControllerKey* _window_key_controller,
                                             guint keyval,
                                             guint keycode,
                                             GdkModifierType state);
static gboolean _four_in_arow_on_window_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                   guint keyval,
                                                                                   guint keycode,
                                                                                   GdkModifierType state,
                                                                                   gpointer self);
static inline gboolean four_in_arow_on_board_key_pressed (FourInARow* self,
                                            GtkEventControllerKey* _board_key_controller,
                                            guint keyval,
                                            guint keycode,
                                            GdkModifierType state);
static gboolean _four_in_arow_on_board_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                  guint keyval,
                                                                                  guint keycode,
                                                                                  GdkModifierType state,
                                                                                  gpointer self);
VALA_EXTERN void game_window_close_hamburger (GameWindow* self);
static inline void four_in_arow_toggle_game_menu (FourInARow* self);
static void _vala_GdkEvent_free (GdkEvent* self);
static gint four_in_arow_get_keypress_left (FourInARow* self);
static gint four_in_arow_get_keypress_right (FourInARow* self);
static gint four_in_arow_get_keypress_drop (FourInARow* self);
static gboolean four_in_arow_get_sound_on (FourInARow* self);
static void four_in_arow_do_play_sound (FourInARowSoundID id,
                                 GSoundContext* sound_context);
VALA_EXTERN void scorebox_give_up (Scorebox* self,
                       Player player);
VALA_EXTERN gboolean game_window_new_game_screen_visible (GameWindow* self);
VALA_EXTERN gboolean game_window_get_is_extra_thin (GameWindow* self);
VALA_EXTERN void four_in_arow_set_keypress_drop (FourInARow* self,
                                     gint value);
VALA_EXTERN void four_in_arow_set_keypress_right (FourInARow* self,
                                      gint value);
VALA_EXTERN void four_in_arow_set_keypress_left (FourInARow* self,
                                     gint value);
VALA_EXTERN void four_in_arow_set_sound_on (FourInARow* self,
                                gboolean value);
static void four_in_arow_next_move_finalize (FourInARowNextMove * obj);
static GType four_in_arow_next_move_get_type_once (void);
static void four_in_arow_animate_finalize (FourInARowAnimate * obj);
static GType four_in_arow_animate_get_type_once (void);
static void four_in_arow_finalize (GObject * obj);
static GType four_in_arow_get_type_once (void);
static void _vala_four_in_arow_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_four_in_arow_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GOptionEntry FOUR_IN_AROW_option_entries[7] = {{"level", 'l', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_STRING, &four_in_arow_level, N_ ("Set the level of the computer’s AI"), N_ ("LEVEL")}, {"mute", (gchar) 0, (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Turn off the sound"), NULL}, {"size", 's', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_INT, &four_in_arow_size, N_ ("Size of the board"), N_ ("SIZE")}, {"target", 't', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_INT, &four_in_arow_target, N_ ("Length of a winning line"), N_ ("TARGET")}, {"unmute", (gchar) 0, (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Turn on the sound"), NULL}, {"version", 'v', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Print release version and exit"), NULL}, {0}};
static const GActionEntry FOUR_IN_AROW_app_entries[7] = {{"game-type", NULL, "s", "'dark'", _four_in_arow_change_game_type_gsimple_action_change_state_callback}, {"next-round", _four_in_arow_on_next_round_gsimple_action_activate_callback}, {"give-up", _four_in_arow_on_give_up_gsimple_action_activate_callback}, {"scores", _four_in_arow_on_game_scores_gsimple_action_activate_callback}, {"quit", _four_in_arow_on_game_exit_gsimple_action_activate_callback}, {"help", _four_in_arow_on_help_contents_gsimple_action_activate_callback}, {"about", _four_in_arow_on_help_about_gsimple_action_activate_callback}};

static inline gpointer
four_in_arow_get_instance_private (FourInARow* self)
{
	return G_STRUCT_MEMBER_P (self, FourInARow_private_offset);
}

static GType
four_in_arow_anim_id_get_type_once (void)
{
	static const GEnumValue values[] = {{FOUR_IN_AROW_ANIM_ID_NONE, "FOUR_IN_AROW_ANIM_ID_NONE", "none"}, {FOUR_IN_AROW_ANIM_ID_MOVE, "FOUR_IN_AROW_ANIM_ID_MOVE", "move"}, {FOUR_IN_AROW_ANIM_ID_DROP, "FOUR_IN_AROW_ANIM_ID_DROP", "drop"}, {FOUR_IN_AROW_ANIM_ID_BLINK, "FOUR_IN_AROW_ANIM_ID_BLINK", "blink"}, {FOUR_IN_AROW_ANIM_ID_HINT, "FOUR_IN_AROW_ANIM_ID_HINT", "hint"}, {0, NULL, NULL}};
	GType four_in_arow_anim_id_type_id;
	four_in_arow_anim_id_type_id = g_enum_register_static ("FourInARowAnimID", values);
	return four_in_arow_anim_id_type_id;
}

static GType
four_in_arow_anim_id_get_type (void)
{
	static volatile gsize four_in_arow_anim_id_type_id__once = 0;
	if (g_once_init_enter (&four_in_arow_anim_id_type_id__once)) {
		GType four_in_arow_anim_id_type_id;
		four_in_arow_anim_id_type_id = four_in_arow_anim_id_get_type_once ();
		g_once_init_leave (&four_in_arow_anim_id_type_id__once, four_in_arow_anim_id_type_id);
	}
	return four_in_arow_anim_id_type_id__once;
}

static GType
four_in_arow_sound_id_get_type_once (void)
{
	static const GEnumValue values[] = {{FOUR_IN_AROW_SOUND_ID_DROP, "FOUR_IN_AROW_SOUND_ID_DROP", "drop"}, {FOUR_IN_AROW_SOUND_ID_I_WIN, "FOUR_IN_AROW_SOUND_ID_I_WIN", "i-win"}, {FOUR_IN_AROW_SOUND_ID_YOU_WIN, "FOUR_IN_AROW_SOUND_ID_YOU_WIN", "you-win"}, {FOUR_IN_AROW_SOUND_ID_PLAYER_WIN, "FOUR_IN_AROW_SOUND_ID_PLAYER_WIN", "player-win"}, {FOUR_IN_AROW_SOUND_ID_DRAWN_GAME, "FOUR_IN_AROW_SOUND_ID_DRAWN_GAME", "drawn-game"}, {FOUR_IN_AROW_SOUND_ID_COLUMN_FULL, "FOUR_IN_AROW_SOUND_ID_COLUMN_FULL", "column-full"}, {0, NULL, NULL}};
	GType four_in_arow_sound_id_type_id;
	four_in_arow_sound_id_type_id = g_enum_register_static ("FourInARowSoundID", values);
	return four_in_arow_sound_id_type_id;
}

static GType
four_in_arow_sound_id_get_type (void)
{
	static volatile gsize four_in_arow_sound_id_type_id__once = 0;
	if (g_once_init_enter (&four_in_arow_sound_id_type_id__once)) {
		GType four_in_arow_sound_id_type_id;
		four_in_arow_sound_id_type_id = four_in_arow_sound_id_get_type_once ();
		g_once_init_leave (&four_in_arow_sound_id_type_id__once, four_in_arow_sound_id_type_id);
	}
	return four_in_arow_sound_id_type_id__once;
}

static GType
four_in_arow_sound_context_state_get_type_once (void)
{
	static const GEnumValue values[] = {{FOUR_IN_AROW_SOUND_CONTEXT_STATE_INITIAL, "FOUR_IN_AROW_SOUND_CONTEXT_STATE_INITIAL", "initial"}, {FOUR_IN_AROW_SOUND_CONTEXT_STATE_WORKING, "FOUR_IN_AROW_SOUND_CONTEXT_STATE_WORKING", "working"}, {FOUR_IN_AROW_SOUND_CONTEXT_STATE_ERRORED, "FOUR_IN_AROW_SOUND_CONTEXT_STATE_ERRORED", "errored"}, {0, NULL, NULL}};
	GType four_in_arow_sound_context_state_type_id;
	four_in_arow_sound_context_state_type_id = g_enum_register_static ("FourInARowSoundContextState", values);
	return four_in_arow_sound_context_state_type_id;
}

static GType
four_in_arow_sound_context_state_get_type (void)
{
	static volatile gsize four_in_arow_sound_context_state_type_id__once = 0;
	if (g_once_init_enter (&four_in_arow_sound_context_state_type_id__once)) {
		GType four_in_arow_sound_context_state_type_id;
		four_in_arow_sound_context_state_type_id = four_in_arow_sound_context_state_get_type_once ();
		g_once_init_leave (&four_in_arow_sound_context_state_type_id__once, four_in_arow_sound_context_state_type_id);
	}
	return four_in_arow_sound_context_state_type_id__once;
}

static void
_four_in_arow_change_game_type_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                     GVariant* value,
                                                                     gpointer self)
{
#line 123 "../src/four-in-a-row.vala"
	four_in_arow_change_game_type ((FourInARow*) self, action, value);
#line 772 "four-in-a-row.c"
}

static void
_four_in_arow_on_next_round_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 123 "../src/four-in-a-row.vala"
	four_in_arow_on_next_round ((FourInARow*) self);
#line 782 "four-in-a-row.c"
}

static void
_four_in_arow_on_give_up_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 123 "../src/four-in-a-row.vala"
	four_in_arow_on_give_up ((FourInARow*) self);
#line 792 "four-in-a-row.c"
}

static void
_four_in_arow_on_game_scores_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 123 "../src/four-in-a-row.vala"
	four_in_arow_on_game_scores ((FourInARow*) self);
#line 802 "four-in-a-row.c"
}

static void
_four_in_arow_on_game_exit_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 123 "../src/four-in-a-row.vala"
	four_in_arow_on_game_exit ((FourInARow*) self);
#line 812 "four-in-a-row.c"
}

static void
_four_in_arow_on_help_contents_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 123 "../src/four-in-a-row.vala"
	four_in_arow_on_help_contents ((FourInARow*) self);
#line 822 "four-in-a-row.c"
}

static void
_four_in_arow_on_help_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 123 "../src/four-in-a-row.vala"
	four_in_arow_on_help_about ((FourInARow*) self);
#line 832 "four-in-a-row.c"
}

static gint
four_in_arow_main (gchar** args,
                   gint args_length1)
{
	FourInARow* _tmp0_;
	FourInARow* _tmp1_;
	gint _tmp2_;
	gint result;
#line 137 "../src/four-in-a-row.vala"
	setlocale (LC_ALL, "");
#line 138 "../src/four-in-a-row.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 139 "../src/four-in-a-row.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 140 "../src/four-in-a-row.vala"
	textdomain (GETTEXT_PACKAGE);
#line 142 "../src/four-in-a-row.vala"
	g_set_application_name (FOUR_IN_AROW_PROGRAM_NAME);
#line 143 "../src/four-in-a-row.vala"
	gtk_window_set_default_icon_name ("org.gnome.Four-in-a-row");
#line 145 "../src/four-in-a-row.vala"
	_tmp0_ = four_in_arow_new ();
#line 145 "../src/four-in-a-row.vala"
	_tmp1_ = _tmp0_;
#line 145 "../src/four-in-a-row.vala"
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
#line 145 "../src/four-in-a-row.vala"
	_g_object_unref0 (_tmp1_);
#line 145 "../src/four-in-a-row.vala"
	result = _tmp2_;
#line 145 "../src/four-in-a-row.vala"
	return result;
#line 867 "four-in-a-row.c"
}

int
main (int argc,
      char ** argv)
{
#line 135 "../src/four-in-a-row.vala"
	return four_in_arow_main (argv, argc);
#line 876 "four-in-a-row.c"
}

static FourInARow*
four_in_arow_construct (GType object_type)
{
	FourInARow * self = NULL;
#line 150 "../src/four-in-a-row.vala"
	self = (FourInARow*) g_object_new (object_type, "application-id", "org.gnome.Four-in-a-row", "flags", G_APPLICATION_FLAGS_NONE, NULL);
#line 152 "../src/four-in-a-row.vala"
	g_application_add_main_option_entries ((GApplication*) self, FOUR_IN_AROW_option_entries);
#line 148 "../src/four-in-a-row.vala"
	return self;
#line 889 "four-in-a-row.c"
}

static FourInARow*
four_in_arow_new (void)
{
#line 148 "../src/four-in-a-row.vala"
	return four_in_arow_construct (TYPE_FOUR_IN_AROW);
#line 897 "four-in-a-row.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 191 "../src/four-in-a-row.vala"
	dup = g_new0 (gboolean, 1);
#line 191 "../src/four-in-a-row.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 191 "../src/four-in-a-row.vala"
	return dup;
#line 910 "four-in-a-row.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 191 "../src/four-in-a-row.vala"
	return self ? _bool_dup (self) : NULL;
#line 918 "four-in-a-row.c"
}

static gint
four_in_arow_real_handle_local_options (GApplication* base,
                                        GVariantDict* options)
{
	FourInARow * self;
	gint result;
#line 155 "../src/four-in-a-row.vala"
	self = (FourInARow*) base;
#line 155 "../src/four-in-a-row.vala"
	g_return_val_if_fail (options != NULL, 0);
#line 157 "../src/four-in-a-row.vala"
	if (g_variant_dict_contains (options, "version")) {
#line 933 "four-in-a-row.c"
		FILE* _tmp0_;
#line 160 "../src/four-in-a-row.vala"
		_tmp0_ = stdout;
#line 160 "../src/four-in-a-row.vala"
		fprintf (_tmp0_, "%1$s %2$s\n", "four-in-a-row", VERSION);
#line 161 "../src/four-in-a-row.vala"
		result = EXIT_SUCCESS;
#line 161 "../src/four-in-a-row.vala"
		return result;
#line 943 "four-in-a-row.c"
	}
#line 164 "../src/four-in-a-row.vala"
	if (four_in_arow_size < 4) {
#line 947 "four-in-a-row.c"
		FILE* _tmp1_;
#line 167 "../src/four-in-a-row.vala"
		_tmp1_ = stderr;
#line 167 "../src/four-in-a-row.vala"
		fprintf (_tmp1_, "%s\n", _ ("Size must be at least 4."));
#line 168 "../src/four-in-a-row.vala"
		result = EXIT_FAILURE;
#line 168 "../src/four-in-a-row.vala"
		return result;
#line 957 "four-in-a-row.c"
	}
#line 170 "../src/four-in-a-row.vala"
	if (four_in_arow_size > 16) {
#line 961 "four-in-a-row.c"
		FILE* _tmp2_;
#line 173 "../src/four-in-a-row.vala"
		_tmp2_ = stderr;
#line 173 "../src/four-in-a-row.vala"
		fprintf (_tmp2_, "%s\n", _ ("Size must not be more than 16."));
#line 174 "../src/four-in-a-row.vala"
		result = EXIT_FAILURE;
#line 174 "../src/four-in-a-row.vala"
		return result;
#line 971 "four-in-a-row.c"
	}
#line 177 "../src/four-in-a-row.vala"
	if (four_in_arow_target < 3) {
#line 975 "four-in-a-row.c"
		FILE* _tmp3_;
#line 180 "../src/four-in-a-row.vala"
		_tmp3_ = stderr;
#line 180 "../src/four-in-a-row.vala"
		fprintf (_tmp3_, "%s\n", _ ("Lines must be at least 3 tiles."));
#line 181 "../src/four-in-a-row.vala"
		result = EXIT_FAILURE;
#line 181 "../src/four-in-a-row.vala"
		return result;
#line 985 "four-in-a-row.c"
	}
#line 183 "../src/four-in-a-row.vala"
	if (four_in_arow_target > (four_in_arow_size - 1)) {
#line 989 "four-in-a-row.c"
		FILE* _tmp4_;
#line 186 "../src/four-in-a-row.vala"
		_tmp4_ = stderr;
#line 186 "../src/four-in-a-row.vala"
		fprintf (_tmp4_, "%s\n", _ ("Lines cannot be longer than board height or width."));
#line 187 "../src/four-in-a-row.vala"
		result = EXIT_FAILURE;
#line 187 "../src/four-in-a-row.vala"
		return result;
#line 999 "four-in-a-row.c"
	}
#line 190 "../src/four-in-a-row.vala"
	if (g_variant_dict_contains (options, "mute")) {
#line 1003 "four-in-a-row.c"
		gboolean _tmp5_;
		gboolean* _tmp6_;
#line 191 "../src/four-in-a-row.vala"
		_tmp5_ = FALSE;
#line 191 "../src/four-in-a-row.vala"
		_tmp6_ = __bool_dup0 (&_tmp5_);
#line 191 "../src/four-in-a-row.vala"
		_g_free0 (four_in_arow_sound);
#line 191 "../src/four-in-a-row.vala"
		four_in_arow_sound = _tmp6_;
#line 1014 "four-in-a-row.c"
	} else {
#line 192 "../src/four-in-a-row.vala"
		if (g_variant_dict_contains (options, "unmute")) {
#line 1018 "four-in-a-row.c"
			gboolean _tmp7_;
			gboolean* _tmp8_;
#line 193 "../src/four-in-a-row.vala"
			_tmp7_ = TRUE;
#line 193 "../src/four-in-a-row.vala"
			_tmp8_ = __bool_dup0 (&_tmp7_);
#line 193 "../src/four-in-a-row.vala"
			_g_free0 (four_in_arow_sound);
#line 193 "../src/four-in-a-row.vala"
			four_in_arow_sound = _tmp8_;
#line 1029 "four-in-a-row.c"
		}
	}
#line 196 "../src/four-in-a-row.vala"
	result = -1;
#line 196 "../src/four-in-a-row.vala"
	return result;
#line 1036 "four-in-a-row.c"
}

static void
_four_in_arow_prompt_player_g_settings_changed (GSettings* _sender,
                                                const gchar* key,
                                                gpointer self)
{
#line 308 "../src/four-in-a-row.vala"
	four_in_arow_prompt_player ((FourInARow*) self);
#line 1046 "four-in-a-row.c"
}

static gboolean
_four_in_arow_column_clicked_cb_game_board_view_column_clicked (GameBoardView* _sender,
                                                                guint8 column,
                                                                gpointer self)
{
	gboolean result;
	result = four_in_arow_column_clicked_cb ((FourInARow*) self, column);
#line 313 "../src/four-in-a-row.vala"
	return result;
#line 1058 "four-in-a-row.c"
}

static void
_four_in_arow_on_game_new_game_window_play (GameWindow* _sender,
                                            gpointer self)
{
#line 316 "../src/four-in-a-row.vala"
	four_in_arow_on_game_new ((FourInARow*) self);
#line 1067 "four-in-a-row.c"
}

static void
_four_in_arow_on_game_undo_game_window_undo (GameWindow* _sender,
                                             gpointer self)
{
#line 317 "../src/four-in-a-row.vala"
	four_in_arow_on_game_undo ((FourInARow*) self);
#line 1076 "four-in-a-row.c"
}

static void
_four_in_arow_on_game_hint_game_window_hint (GameWindow* _sender,
                                             gpointer self)
{
#line 318 "../src/four-in-a-row.vala"
	four_in_arow_on_game_hint ((FourInARow*) self);
#line 1085 "four-in-a-row.c"
}

static void
four_in_arow_real_startup (GApplication* base)
{
	FourInARow * self;
	gboolean _tmp0_ = FALSE;
	gboolean* _tmp1_;
	Board* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
	ThemeManager* _tmp23_;
	GSettings* _tmp24_;
	ThemeManager* _tmp25_;
	NewGameScreen* _tmp26_;
	NewGameScreen* _tmp27_;
	Board* _tmp28_;
	ThemeManager* _tmp29_;
	GameBoardView* _tmp30_;
	GameBoardView* _tmp31_;
	GMenu* app_menu = NULL;
	GMenu* _tmp32_;
	GMenu* appearance_menu = NULL;
	GMenu* _tmp33_;
	gchar** themes = NULL;
	ThemeManager* _tmp34_;
	gint _tmp35_ = 0;
	gchar** _tmp36_;
	gint themes_length1;
	gint _themes_size_;
	GMenu* _tmp47_;
	GMenu* section = NULL;
	GMenu* _tmp48_;
	GMenu* _tmp49_;
	GMenu* _tmp50_;
	GMenu* _tmp51_;
	GMenu* _tmp52_;
	GMenu* _tmp53_;
	GMenu* _tmp54_;
	GMenu* _tmp55_;
	GMenu* _tmp56_;
	GMenu* _tmp57_;
	GMenu* _tmp58_;
	GMenu* _tmp59_;
	GMenu* _tmp60_;
	GMenu* _tmp61_;
	GMenu* _tmp62_;
	ThemeManager* _tmp63_;
	HistoryButton* _tmp64_;
	ThemeManager* _tmp65_;
	HistoryButton* _tmp66_;
	NewGameScreen* _tmp67_;
	GameBoardView* _tmp68_;
	GMenu* _tmp69_;
	HistoryButton* _tmp70_;
	HistoryButton* _tmp71_;
	GameWindow* _tmp72_;
	GameWindow* _tmp73_;
	ThemeManager* _tmp74_;
	Scorebox* _tmp75_;
	GSettings* _tmp76_;
	GameBoardView* _tmp77_;
	GameWindow* _tmp78_;
	GameWindow* _tmp79_;
	GameWindow* _tmp80_;
	GameWindow* _tmp81_;
	GameWindow* _tmp82_;
	GameWindow* _tmp83_;
#line 199 "../src/four-in-a-row.vala"
	self = (FourInARow*) base;
#line 201 "../src/four-in-a-row.vala"
	G_APPLICATION_CLASS (four_in_arow_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 203 "../src/four-in-a-row.vala"
	_tmp1_ = four_in_arow_sound;
#line 203 "../src/four-in-a-row.vala"
	if (_tmp1_ != NULL) {
#line 203 "../src/four-in-a-row.vala"
		_tmp0_ = TRUE;
#line 1167 "four-in-a-row.c"
	} else {
		const gchar* _tmp2_;
#line 203 "../src/four-in-a-row.vala"
		_tmp2_ = four_in_arow_level;
#line 203 "../src/four-in-a-row.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 1174 "four-in-a-row.c"
	}
#line 203 "../src/four-in-a-row.vala"
	if (_tmp0_) {
#line 1178 "four-in-a-row.c"
		GSettings* _tmp3_;
		gboolean* _tmp4_;
		const gchar* _tmp7_;
		GSettings* _tmp16_;
#line 205 "../src/four-in-a-row.vala"
		_tmp3_ = self->priv->settings;
#line 205 "../src/four-in-a-row.vala"
		g_settings_delay (_tmp3_);
#line 207 "../src/four-in-a-row.vala"
		_tmp4_ = four_in_arow_sound;
#line 207 "../src/four-in-a-row.vala"
		if (_tmp4_ != NULL) {
#line 1191 "four-in-a-row.c"
			GSettings* _tmp5_;
			gboolean* _tmp6_;
#line 208 "../src/four-in-a-row.vala"
			_tmp5_ = self->priv->settings;
#line 208 "../src/four-in-a-row.vala"
			_tmp6_ = four_in_arow_sound;
#line 208 "../src/four-in-a-row.vala"
			g_settings_set_boolean (_tmp5_, "sound", (gboolean) (*_tmp6_));
#line 1200 "four-in-a-row.c"
		}
#line 210 "../src/four-in-a-row.vala"
		_tmp7_ = four_in_arow_level;
#line 210 "../src/four-in-a-row.vala"
		if (_tmp7_ != NULL) {
#line 1206 "four-in-a-row.c"
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			GQuark _tmp11_ = 0U;
#line 213 "../src/four-in-a-row.vala"
			static GQuark _tmp10_label0 = 0;
#line 213 "../src/four-in-a-row.vala"
			static GQuark _tmp10_label1 = 0;
#line 213 "../src/four-in-a-row.vala"
			static GQuark _tmp10_label2 = 0;
#line 213 "../src/four-in-a-row.vala"
			static GQuark _tmp10_label3 = 0;
#line 213 "../src/four-in-a-row.vala"
			static GQuark _tmp10_label4 = 0;
#line 213 "../src/four-in-a-row.vala"
			static GQuark _tmp10_label5 = 0;
#line 213 "../src/four-in-a-row.vala"
			static GQuark _tmp10_label6 = 0;
#line 213 "../src/four-in-a-row.vala"
			static GQuark _tmp10_label7 = 0;
#line 213 "../src/four-in-a-row.vala"
			static GQuark _tmp10_label8 = 0;
#line 213 "../src/four-in-a-row.vala"
			_tmp8_ = four_in_arow_level;
#line 213 "../src/four-in-a-row.vala"
			_tmp9_ = (const gchar*) _tmp8_;
#line 213 "../src/four-in-a-row.vala"
			_tmp11_ = (NULL == _tmp9_) ? 0 : g_quark_from_string (_tmp9_);
#line 213 "../src/four-in-a-row.vala"
			if (((_tmp11_ == ((0 != _tmp10_label0) ? _tmp10_label0 : (_tmp10_label0 = g_quark_from_static_string ("1")))) || (_tmp11_ == ((0 != _tmp10_label1) ? _tmp10_label1 : (_tmp10_label1 = g_quark_from_static_string ("easy"))))) || (_tmp11_ == ((0 != _tmp10_label2) ? _tmp10_label2 : (_tmp10_label2 = g_quark_from_static_string ("one"))))) {
#line 213 "../src/four-in-a-row.vala"
				switch (0) {
#line 1238 "four-in-a-row.c"
					default:
					{
						GSettings* _tmp12_;
#line 217 "../src/four-in-a-row.vala"
						_tmp12_ = self->priv->settings;
#line 217 "../src/four-in-a-row.vala"
						g_settings_set_int (_tmp12_, "opponent", 1);
#line 217 "../src/four-in-a-row.vala"
						break;
#line 1248 "four-in-a-row.c"
					}
				}
			} else if (((_tmp11_ == ((0 != _tmp10_label3) ? _tmp10_label3 : (_tmp10_label3 = g_quark_from_static_string ("2")))) || (_tmp11_ == ((0 != _tmp10_label4) ? _tmp10_label4 : (_tmp10_label4 = g_quark_from_static_string ("medium"))))) || (_tmp11_ == ((0 != _tmp10_label5) ? _tmp10_label5 : (_tmp10_label5 = g_quark_from_static_string ("two"))))) {
#line 213 "../src/four-in-a-row.vala"
				switch (0) {
#line 1254 "four-in-a-row.c"
					default:
					{
						GSettings* _tmp13_;
#line 221 "../src/four-in-a-row.vala"
						_tmp13_ = self->priv->settings;
#line 221 "../src/four-in-a-row.vala"
						g_settings_set_int (_tmp13_, "opponent", 2);
#line 221 "../src/four-in-a-row.vala"
						break;
#line 1264 "four-in-a-row.c"
					}
				}
			} else if (((_tmp11_ == ((0 != _tmp10_label6) ? _tmp10_label6 : (_tmp10_label6 = g_quark_from_static_string ("3")))) || (_tmp11_ == ((0 != _tmp10_label7) ? _tmp10_label7 : (_tmp10_label7 = g_quark_from_static_string ("hard"))))) || (_tmp11_ == ((0 != _tmp10_label8) ? _tmp10_label8 : (_tmp10_label8 = g_quark_from_static_string ("three"))))) {
#line 213 "../src/four-in-a-row.vala"
				switch (0) {
#line 1270 "four-in-a-row.c"
					default:
					{
						GSettings* _tmp14_;
#line 225 "../src/four-in-a-row.vala"
						_tmp14_ = self->priv->settings;
#line 225 "../src/four-in-a-row.vala"
						g_settings_set_int (_tmp14_, "opponent", 3);
#line 225 "../src/four-in-a-row.vala"
						break;
#line 1280 "four-in-a-row.c"
					}
				}
			} else {
#line 213 "../src/four-in-a-row.vala"
				switch (0) {
#line 1286 "four-in-a-row.c"
					default:
					{
						FILE* _tmp15_;
#line 229 "../src/four-in-a-row.vala"
						_tmp15_ = stderr;
#line 229 "../src/four-in-a-row.vala"
						fprintf (_tmp15_, "%s\n", _ ("Level should be 1 (easy), 2 (medium) or 3 (hard). Settings unchanged."));
#line 230 "../src/four-in-a-row.vala"
						break;
#line 1296 "four-in-a-row.c"
					}
				}
			}
		}
#line 233 "../src/four-in-a-row.vala"
		_tmp16_ = self->priv->settings;
#line 233 "../src/four-in-a-row.vala"
		g_settings_apply (_tmp16_);
#line 1305 "four-in-a-row.c"
	}
#line 236 "../src/four-in-a-row.vala"
	_tmp17_ = board_new ((guint8) four_in_arow_size, (guint8) four_in_arow_target);
#line 236 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->game_board);
#line 236 "../src/four-in-a-row.vala"
	self->priv->game_board = _tmp17_;
#line 237 "../src/four-in-a-row.vala"
	four_in_arow_clear_board (self);
#line 239 "../src/four-in-a-row.vala"
	_tmp18_ = self->priv->settings;
#line 239 "../src/four-in-a-row.vala"
	if (g_settings_get_boolean (_tmp18_, "sound")) {
#line 240 "../src/four-in-a-row.vala"
		four_in_arow_init_sound (self);
#line 1321 "four-in-a-row.c"
	}
#line 242 "../src/four-in-a-row.vala"
	_tmp19_ = self->priv->settings;
#line 242 "../src/four-in-a-row.vala"
	g_settings_bind (_tmp19_, "key-drop", (GObject*) self, "keypress-drop", G_SETTINGS_BIND_GET | G_SETTINGS_BIND_NO_SENSITIVITY);
#line 243 "../src/four-in-a-row.vala"
	_tmp20_ = self->priv->settings;
#line 243 "../src/four-in-a-row.vala"
	g_settings_bind (_tmp20_, "key-right", (GObject*) self, "keypress-right", G_SETTINGS_BIND_GET | G_SETTINGS_BIND_NO_SENSITIVITY);
#line 244 "../src/four-in-a-row.vala"
	_tmp21_ = self->priv->settings;
#line 244 "../src/four-in-a-row.vala"
	g_settings_bind (_tmp21_, "key-left", (GObject*) self, "keypress-left", G_SETTINGS_BIND_GET | G_SETTINGS_BIND_NO_SENSITIVITY);
#line 245 "../src/four-in-a-row.vala"
	_tmp22_ = self->priv->settings;
#line 245 "../src/four-in-a-row.vala"
	g_settings_bind (_tmp22_, "sound", (GObject*) self, "sound-on", G_SETTINGS_BIND_GET | G_SETTINGS_BIND_NO_SENSITIVITY);
#line 247 "../src/four-in-a-row.vala"
	_tmp23_ = theme_manager_new ((guint8) four_in_arow_size);
#line 247 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->theme_manager);
#line 247 "../src/four-in-a-row.vala"
	self->priv->theme_manager = _tmp23_;
#line 248 "../src/four-in-a-row.vala"
	_tmp24_ = self->priv->settings;
#line 248 "../src/four-in-a-row.vala"
	_tmp25_ = self->priv->theme_manager;
#line 248 "../src/four-in-a-row.vala"
	g_settings_bind (_tmp24_, "theme-id", (GObject*) _tmp25_, "theme-id", G_SETTINGS_BIND_GET | G_SETTINGS_BIND_NO_SENSITIVITY);
#line 251 "../src/four-in-a-row.vala"
	_tmp26_ = new_game_screen_new ();
#line 251 "../src/four-in-a-row.vala"
	g_object_ref_sink (_tmp26_);
#line 251 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->new_game_screen);
#line 251 "../src/four-in-a-row.vala"
	self->priv->new_game_screen = _tmp26_;
#line 252 "../src/four-in-a-row.vala"
	_tmp27_ = self->priv->new_game_screen;
#line 252 "../src/four-in-a-row.vala"
	gtk_widget_show ((GtkWidget*) _tmp27_);
#line 254 "../src/four-in-a-row.vala"
	_tmp28_ = self->priv->game_board;
#line 254 "../src/four-in-a-row.vala"
	_tmp29_ = self->priv->theme_manager;
#line 254 "../src/four-in-a-row.vala"
	_tmp30_ = game_board_view_new (_tmp28_, _tmp29_);
#line 254 "../src/four-in-a-row.vala"
	g_object_ref_sink (_tmp30_);
#line 254 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->game_board_view);
#line 254 "../src/four-in-a-row.vala"
	self->priv->game_board_view = _tmp30_;
#line 255 "../src/four-in-a-row.vala"
	_tmp31_ = self->priv->game_board_view;
#line 255 "../src/four-in-a-row.vala"
	gtk_widget_show ((GtkWidget*) _tmp31_);
#line 257 "../src/four-in-a-row.vala"
	_tmp32_ = g_menu_new ();
#line 257 "../src/four-in-a-row.vala"
	app_menu = _tmp32_;
#line 259 "../src/four-in-a-row.vala"
	_tmp33_ = g_menu_new ();
#line 259 "../src/four-in-a-row.vala"
	appearance_menu = _tmp33_;
#line 260 "../src/four-in-a-row.vala"
	_tmp34_ = self->priv->theme_manager;
#line 260 "../src/four-in-a-row.vala"
	_tmp36_ = theme_manager_get_themes (_tmp34_, &_tmp35_);
#line 260 "../src/four-in-a-row.vala"
	themes = _tmp36_;
#line 260 "../src/four-in-a-row.vala"
	themes_length1 = _tmp35_;
#line 260 "../src/four-in-a-row.vala"
	_themes_size_ = themes_length1;
#line 1397 "four-in-a-row.c"
	{
		guint8 i = 0U;
#line 261 "../src/four-in-a-row.vala"
		i = (guint8) 0;
#line 1402 "four-in-a-row.c"
		{
			gboolean _tmp37_ = FALSE;
#line 261 "../src/four-in-a-row.vala"
			_tmp37_ = TRUE;
#line 261 "../src/four-in-a-row.vala"
			while (TRUE) {
#line 1409 "four-in-a-row.c"
				gchar** _tmp39_;
				gint _tmp39__length1;
				GMenu* _tmp40_;
				gchar** _tmp41_;
				gint _tmp41__length1;
				const gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
#line 261 "../src/four-in-a-row.vala"
				if (!_tmp37_) {
#line 1422 "four-in-a-row.c"
					guint8 _tmp38_;
#line 261 "../src/four-in-a-row.vala"
					_tmp38_ = i;
#line 261 "../src/four-in-a-row.vala"
					i = _tmp38_ + 1;
#line 1428 "four-in-a-row.c"
				}
#line 261 "../src/four-in-a-row.vala"
				_tmp37_ = FALSE;
#line 261 "../src/four-in-a-row.vala"
				_tmp39_ = themes;
#line 261 "../src/four-in-a-row.vala"
				_tmp39__length1 = themes_length1;
#line 261 "../src/four-in-a-row.vala"
				if (!(((gint) i) < _tmp39__length1)) {
#line 261 "../src/four-in-a-row.vala"
					break;
#line 1440 "four-in-a-row.c"
				}
#line 262 "../src/four-in-a-row.vala"
				_tmp40_ = appearance_menu;
#line 262 "../src/four-in-a-row.vala"
				_tmp41_ = themes;
#line 262 "../src/four-in-a-row.vala"
				_tmp41__length1 = themes_length1;
#line 262 "../src/four-in-a-row.vala"
				_tmp42_ = _tmp41_[i];
#line 262 "../src/four-in-a-row.vala"
				_tmp43_ = g_strdup_printf ("%hhu", i);
#line 262 "../src/four-in-a-row.vala"
				_tmp44_ = _tmp43_;
#line 262 "../src/four-in-a-row.vala"
				_tmp45_ = g_strconcat ("app.theme-id(", _tmp44_, ")", NULL);
#line 262 "../src/four-in-a-row.vala"
				_tmp46_ = _tmp45_;
#line 262 "../src/four-in-a-row.vala"
				g_menu_append (_tmp40_, _tmp42_, _tmp46_);
#line 262 "../src/four-in-a-row.vala"
				_g_free0 (_tmp46_);
#line 262 "../src/four-in-a-row.vala"
				_g_free0 (_tmp44_);
#line 1464 "four-in-a-row.c"
			}
		}
	}
#line 263 "../src/four-in-a-row.vala"
	_tmp47_ = appearance_menu;
#line 263 "../src/four-in-a-row.vala"
	g_menu_freeze (_tmp47_);
#line 265 "../src/four-in-a-row.vala"
	_tmp48_ = g_menu_new ();
#line 265 "../src/four-in-a-row.vala"
	section = _tmp48_;
#line 267 "../src/four-in-a-row.vala"
	_tmp49_ = section;
#line 267 "../src/four-in-a-row.vala"
	_tmp50_ = appearance_menu;
#line 267 "../src/four-in-a-row.vala"
	g_menu_append_submenu (_tmp49_, _ ("A_ppearance"), (GMenuModel*) G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, g_menu_get_type (), GMenu));
#line 271 "../src/four-in-a-row.vala"
	_tmp51_ = section;
#line 271 "../src/four-in-a-row.vala"
	g_menu_append (_tmp51_, _ ("_Sound"), "app.sound");
#line 272 "../src/four-in-a-row.vala"
	_tmp52_ = section;
#line 272 "../src/four-in-a-row.vala"
	g_menu_freeze (_tmp52_);
#line 273 "../src/four-in-a-row.vala"
	_tmp53_ = app_menu;
#line 273 "../src/four-in-a-row.vala"
	_tmp54_ = section;
#line 273 "../src/four-in-a-row.vala"
	g_menu_append_section (_tmp53_, NULL, (GMenuModel*) _tmp54_);
#line 275 "../src/four-in-a-row.vala"
	_tmp55_ = g_menu_new ();
#line 275 "../src/four-in-a-row.vala"
	_g_object_unref0 (section);
#line 275 "../src/four-in-a-row.vala"
	section = _tmp55_;
#line 277 "../src/four-in-a-row.vala"
	_tmp56_ = section;
#line 277 "../src/four-in-a-row.vala"
	g_menu_append (_tmp56_, _ ("_Keyboard Shortcuts"), "win.show-help-overlay");
#line 281 "../src/four-in-a-row.vala"
	_tmp57_ = section;
#line 281 "../src/four-in-a-row.vala"
	g_menu_append (_tmp57_, _ ("_Help"), "app.help");
#line 285 "../src/four-in-a-row.vala"
	_tmp58_ = section;
#line 285 "../src/four-in-a-row.vala"
	g_menu_append (_tmp58_, _ ("_About Four-in-a-row"), "app.about");
#line 286 "../src/four-in-a-row.vala"
	_tmp59_ = section;
#line 286 "../src/four-in-a-row.vala"
	g_menu_freeze (_tmp59_);
#line 287 "../src/four-in-a-row.vala"
	_tmp60_ = app_menu;
#line 287 "../src/four-in-a-row.vala"
	_tmp61_ = section;
#line 287 "../src/four-in-a-row.vala"
	g_menu_append_section (_tmp60_, NULL, (GMenuModel*) _tmp61_);
#line 289 "../src/four-in-a-row.vala"
	_tmp62_ = app_menu;
#line 289 "../src/four-in-a-row.vala"
	g_menu_freeze (_tmp62_);
#line 291 "../src/four-in-a-row.vala"
	four_in_arow_generate_game_menu (self);
#line 292 "../src/four-in-a-row.vala"
	_tmp63_ = self->priv->theme_manager;
#line 292 "../src/four-in-a-row.vala"
	_tmp64_ = history_button_new (&self->priv->game_menu, _tmp63_);
#line 292 "../src/four-in-a-row.vala"
	g_object_ref_sink (_tmp64_);
#line 292 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->history_button_1);
#line 292 "../src/four-in-a-row.vala"
	self->priv->history_button_1 = _tmp64_;
#line 293 "../src/four-in-a-row.vala"
	_tmp65_ = self->priv->theme_manager;
#line 293 "../src/four-in-a-row.vala"
	_tmp66_ = history_button_new (&self->priv->game_menu, _tmp65_);
#line 293 "../src/four-in-a-row.vala"
	g_object_ref_sink (_tmp66_);
#line 293 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->history_button_2);
#line 293 "../src/four-in-a-row.vala"
	self->priv->history_button_2 = _tmp66_;
#line 296 "../src/four-in-a-row.vala"
	_tmp67_ = self->priv->new_game_screen;
#line 296 "../src/four-in-a-row.vala"
	_tmp68_ = self->priv->game_board_view;
#line 296 "../src/four-in-a-row.vala"
	_tmp69_ = app_menu;
#line 296 "../src/four-in-a-row.vala"
	_tmp70_ = self->priv->history_button_1;
#line 296 "../src/four-in-a-row.vala"
	_tmp71_ = self->priv->history_button_2;
#line 296 "../src/four-in-a-row.vala"
	_tmp72_ = game_window_new ("/org/gnome/Four-in-a-row/ui/four-in-a-row.css", FOUR_IN_AROW_PROGRAM_NAME, TRUE, GAME_WINDOW_FLAGS_SHOW_START_BUTTON, G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, gtk_box_get_type (), GtkBox), (GtkWidget*) _tmp68_, _tmp69_, (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, gtk_menu_button_get_type (), GtkMenuButton), (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, gtk_menu_button_get_type (), GtkMenuButton));
#line 296 "../src/four-in-a-row.vala"
	g_object_ref_sink (_tmp72_);
#line 296 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->window);
#line 296 "../src/four-in-a-row.vala"
	self->priv->window = _tmp72_;
#line 306 "../src/four-in-a-row.vala"
	_tmp73_ = self->priv->window;
#line 306 "../src/four-in-a-row.vala"
	_tmp74_ = self->priv->theme_manager;
#line 306 "../src/four-in-a-row.vala"
	_tmp75_ = scorebox_new ((GtkWindow*) _tmp73_, self, _tmp74_);
#line 306 "../src/four-in-a-row.vala"
	g_object_ref_sink (_tmp75_);
#line 306 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->scorebox);
#line 306 "../src/four-in-a-row.vala"
	self->priv->scorebox = _tmp75_;
#line 308 "../src/four-in-a-row.vala"
	_tmp76_ = self->priv->settings;
#line 308 "../src/four-in-a-row.vala"
	g_signal_connect_object (_tmp76_, "changed::theme-id", (GCallback) _four_in_arow_prompt_player_g_settings_changed, self, 0);
#line 310 "../src/four-in-a-row.vala"
	four_in_arow_add_actions (self);
#line 313 "../src/four-in-a-row.vala"
	_tmp77_ = self->priv->game_board_view;
#line 313 "../src/four-in-a-row.vala"
	g_signal_connect_object (_tmp77_, "column-clicked", (GCallback) _four_in_arow_column_clicked_cb_game_board_view_column_clicked, self, 0);
#line 314 "../src/four-in-a-row.vala"
	four_in_arow_init_keyboard (self);
#line 316 "../src/four-in-a-row.vala"
	_tmp78_ = self->priv->window;
#line 316 "../src/four-in-a-row.vala"
	g_signal_connect_object (_tmp78_, "play", (GCallback) _four_in_arow_on_game_new_game_window_play, self, 0);
#line 317 "../src/four-in-a-row.vala"
	_tmp79_ = self->priv->window;
#line 317 "../src/four-in-a-row.vala"
	g_signal_connect_object (_tmp79_, "undo", (GCallback) _four_in_arow_on_game_undo_game_window_undo, self, 0);
#line 318 "../src/four-in-a-row.vala"
	_tmp80_ = self->priv->window;
#line 318 "../src/four-in-a-row.vala"
	g_signal_connect_object (_tmp80_, "hint", (GCallback) _four_in_arow_on_game_hint_game_window_hint, self, 0);
#line 320 "../src/four-in-a-row.vala"
	_tmp81_ = self->priv->window;
#line 320 "../src/four-in-a-row.vala"
	game_window_allow_hint (_tmp81_, FALSE);
#line 321 "../src/four-in-a-row.vala"
	_tmp82_ = self->priv->window;
#line 321 "../src/four-in-a-row.vala"
	game_window_allow_undo (_tmp82_, FALSE);
#line 323 "../src/four-in-a-row.vala"
	four_in_arow_prompt_player (self);
#line 324 "../src/four-in-a-row.vala"
	four_in_arow_game_reset (self, TRUE);
#line 326 "../src/four-in-a-row.vala"
	_tmp83_ = self->priv->window;
#line 326 "../src/four-in-a-row.vala"
	gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp83_);
#line 199 "../src/four-in-a-row.vala"
	_g_object_unref0 (section);
#line 199 "../src/four-in-a-row.vala"
	themes = (_vala_array_free (themes, themes_length1, (GDestroyNotify) g_free), NULL);
#line 199 "../src/four-in-a-row.vala"
	_g_object_unref0 (appearance_menu);
#line 199 "../src/four-in-a-row.vala"
	_g_object_unref0 (app_menu);
#line 1628 "four-in-a-row.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 350 "../src/four-in-a-row.vala"
	return self ? g_object_ref (self) : NULL;
#line 1636 "four-in-a-row.c"
}

static void
__lambda9_ (FourInARow* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 355 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->settings;
#line 355 "../src/four-in-a-row.vala"
	if (g_settings_get_int (_tmp0_, "num-players") == 2) {
#line 356 "../src/four-in-a-row.vala"
		return;
#line 1653 "four-in-a-row.c"
	}
#line 357 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->settings;
#line 357 "../src/four-in-a-row.vala"
	_tmp2_ = g_settings_get_string (_tmp1_, "first-player");
#line 357 "../src/four-in-a-row.vala"
	_tmp3_ = _tmp2_;
#line 357 "../src/four-in-a-row.vala"
	_tmp4_ = g_strcmp0 (_tmp3_, "human") == 0;
#line 357 "../src/four-in-a-row.vala"
	_g_free0 (_tmp3_);
#line 357 "../src/four-in-a-row.vala"
	if (_tmp4_) {
#line 1667 "four-in-a-row.c"
		GSimpleAction* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
#line 358 "../src/four-in-a-row.vala"
		_tmp5_ = self->priv->game_type_action;
#line 358 "../src/four-in-a-row.vala"
		_tmp6_ = g_variant_new_string ("human");
#line 358 "../src/four-in-a-row.vala"
		g_variant_ref_sink (_tmp6_);
#line 358 "../src/four-in-a-row.vala"
		_tmp7_ = _tmp6_;
#line 358 "../src/four-in-a-row.vala"
		g_simple_action_set_state (_tmp5_, _tmp7_);
#line 358 "../src/four-in-a-row.vala"
		_g_variant_unref0 (_tmp7_);
#line 1683 "four-in-a-row.c"
	} else {
		GSimpleAction* _tmp8_;
		GVariant* _tmp9_;
		GVariant* _tmp10_;
#line 360 "../src/four-in-a-row.vala"
		_tmp8_ = self->priv->game_type_action;
#line 360 "../src/four-in-a-row.vala"
		_tmp9_ = g_variant_new_string ("computer");
#line 360 "../src/four-in-a-row.vala"
		g_variant_ref_sink (_tmp9_);
#line 360 "../src/four-in-a-row.vala"
		_tmp10_ = _tmp9_;
#line 360 "../src/four-in-a-row.vala"
		g_simple_action_set_state (_tmp8_, _tmp10_);
#line 360 "../src/four-in-a-row.vala"
		_g_variant_unref0 (_tmp10_);
#line 1700 "four-in-a-row.c"
	}
}

static void
___lambda9__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 354 "../src/four-in-a-row.vala"
	__lambda9_ ((FourInARow*) self);
#line 1711 "four-in-a-row.c"
}

static void
__lambda10_ (FourInARow* self)
{
	gboolean solo = FALSE;
	GSettings* _tmp0_;
	NewGameScreen* _tmp1_;
#line 364 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->settings;
#line 364 "../src/four-in-a-row.vala"
	solo = g_settings_get_int (_tmp0_, "num-players") == 1;
#line 365 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->new_game_screen;
#line 365 "../src/four-in-a-row.vala"
	new_game_screen_update_sensitivity (_tmp1_, solo);
#line 366 "../src/four-in-a-row.vala"
	if (solo) {
#line 1730 "four-in-a-row.c"
		NewGameScreen* _tmp2_;
		GSettings* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gboolean _tmp6_;
#line 368 "../src/four-in-a-row.vala"
		_tmp2_ = self->priv->new_game_screen;
#line 368 "../src/four-in-a-row.vala"
		new_game_screen_update_sensitivity (_tmp2_, TRUE);
#line 369 "../src/four-in-a-row.vala"
		_tmp3_ = self->priv->settings;
#line 369 "../src/four-in-a-row.vala"
		_tmp4_ = g_settings_get_string (_tmp3_, "first-player");
#line 369 "../src/four-in-a-row.vala"
		_tmp5_ = _tmp4_;
#line 369 "../src/four-in-a-row.vala"
		_tmp6_ = g_strcmp0 (_tmp5_, "human") == 0;
#line 369 "../src/four-in-a-row.vala"
		_g_free0 (_tmp5_);
#line 369 "../src/four-in-a-row.vala"
		if (_tmp6_) {
#line 1752 "four-in-a-row.c"
			GSimpleAction* _tmp7_;
			GVariant* _tmp8_;
			GVariant* _tmp9_;
#line 371 "../src/four-in-a-row.vala"
			_tmp7_ = self->priv->game_type_action;
#line 371 "../src/four-in-a-row.vala"
			_tmp8_ = g_variant_new_string ("human");
#line 371 "../src/four-in-a-row.vala"
			g_variant_ref_sink (_tmp8_);
#line 371 "../src/four-in-a-row.vala"
			_tmp9_ = _tmp8_;
#line 371 "../src/four-in-a-row.vala"
			g_simple_action_set_state (_tmp7_, _tmp9_);
#line 371 "../src/four-in-a-row.vala"
			_g_variant_unref0 (_tmp9_);
#line 372 "../src/four-in-a-row.vala"
			self->priv->last_first_player = PLAYER_HUMAN;
#line 1770 "four-in-a-row.c"
		} else {
			GSimpleAction* _tmp10_;
			GVariant* _tmp11_;
			GVariant* _tmp12_;
#line 376 "../src/four-in-a-row.vala"
			_tmp10_ = self->priv->game_type_action;
#line 376 "../src/four-in-a-row.vala"
			_tmp11_ = g_variant_new_string ("computer");
#line 376 "../src/four-in-a-row.vala"
			g_variant_ref_sink (_tmp11_);
#line 376 "../src/four-in-a-row.vala"
			_tmp12_ = _tmp11_;
#line 376 "../src/four-in-a-row.vala"
			g_simple_action_set_state (_tmp10_, _tmp12_);
#line 376 "../src/four-in-a-row.vala"
			_g_variant_unref0 (_tmp12_);
#line 377 "../src/four-in-a-row.vala"
			self->priv->last_first_player = PLAYER_OPPONENT;
#line 1789 "four-in-a-row.c"
		}
	} else {
		NewGameScreen* _tmp13_;
		GSimpleAction* _tmp14_;
		GVariant* _tmp15_;
		GVariant* _tmp16_;
#line 382 "../src/four-in-a-row.vala"
		_tmp13_ = self->priv->new_game_screen;
#line 382 "../src/four-in-a-row.vala"
		new_game_screen_update_sensitivity (_tmp13_, FALSE);
#line 383 "../src/four-in-a-row.vala"
		_tmp14_ = self->priv->game_type_action;
#line 383 "../src/four-in-a-row.vala"
		_tmp15_ = g_variant_new_string ("two");
#line 383 "../src/four-in-a-row.vala"
		g_variant_ref_sink (_tmp15_);
#line 383 "../src/four-in-a-row.vala"
		_tmp16_ = _tmp15_;
#line 383 "../src/four-in-a-row.vala"
		g_simple_action_set_state (_tmp14_, _tmp16_);
#line 383 "../src/four-in-a-row.vala"
		_g_variant_unref0 (_tmp16_);
#line 384 "../src/four-in-a-row.vala"
		self->priv->last_first_player = PLAYER_NOBODY;
#line 1814 "four-in-a-row.c"
	}
}

static void
___lambda10__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 363 "../src/four-in-a-row.vala"
	__lambda10_ ((FourInARow*) self);
#line 1825 "four-in-a-row.c"
}

static inline void
four_in_arow_add_actions (FourInARow* self)
{
	GSettings* _tmp0_;
	GAction* _tmp1_;
	GAction* _tmp2_;
	GSettings* _tmp3_;
	GAction* _tmp4_;
	GAction* _tmp5_;
	GSettings* _tmp6_;
	GAction* _tmp7_;
	GAction* _tmp8_;
	GSettings* _tmp9_;
	GAction* _tmp10_;
	GAction* _tmp11_;
	GSettings* _tmp12_;
	GAction* _tmp13_;
	GAction* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	gchar* _tmp24_;
	gchar** _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gchar* _tmp27_;
	gchar** _tmp28_;
	gchar** _tmp29_;
	gint _tmp29__length1;
	gchar* _tmp30_;
	gchar** _tmp31_;
	gchar** _tmp32_;
	gint _tmp32__length1;
	gchar* _tmp33_;
	gchar** _tmp34_;
	gchar** _tmp35_;
	gint _tmp35__length1;
	GAction* _tmp36_;
	GSimpleAction* _tmp37_;
	GAction* _tmp38_;
	GSimpleAction* _tmp39_;
	GSimpleAction* _tmp40_;
	GSettings* _tmp41_;
	GSettings* _tmp42_;
	gboolean solo = FALSE;
	GSettings* _tmp43_;
	NewGameScreen* _tmp44_;
#line 328 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 330 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->settings;
#line 330 "../src/four-in-a-row.vala"
	_tmp1_ = g_settings_create_action (_tmp0_, "sound");
#line 330 "../src/four-in-a-row.vala"
	_tmp2_ = _tmp1_;
#line 330 "../src/four-in-a-row.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp2_);
#line 330 "../src/four-in-a-row.vala"
	_g_object_unref0 (_tmp2_);
#line 331 "../src/four-in-a-row.vala"
	_tmp3_ = self->priv->settings;
#line 331 "../src/four-in-a-row.vala"
	_tmp4_ = g_settings_create_action (_tmp3_, "theme-id");
#line 331 "../src/four-in-a-row.vala"
	_tmp5_ = _tmp4_;
#line 331 "../src/four-in-a-row.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp5_);
#line 331 "../src/four-in-a-row.vala"
	_g_object_unref0 (_tmp5_);
#line 332 "../src/four-in-a-row.vala"
	_tmp6_ = self->priv->settings;
#line 332 "../src/four-in-a-row.vala"
	_tmp7_ = g_settings_create_action (_tmp6_, "num-players");
#line 332 "../src/four-in-a-row.vala"
	_tmp8_ = _tmp7_;
#line 332 "../src/four-in-a-row.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp8_);
#line 332 "../src/four-in-a-row.vala"
	_g_object_unref0 (_tmp8_);
#line 333 "../src/four-in-a-row.vala"
	_tmp9_ = self->priv->settings;
#line 333 "../src/four-in-a-row.vala"
	_tmp10_ = g_settings_create_action (_tmp9_, "first-player");
#line 333 "../src/four-in-a-row.vala"
	_tmp11_ = _tmp10_;
#line 333 "../src/four-in-a-row.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp11_);
#line 333 "../src/four-in-a-row.vala"
	_g_object_unref0 (_tmp11_);
#line 334 "../src/four-in-a-row.vala"
	_tmp12_ = self->priv->settings;
#line 334 "../src/four-in-a-row.vala"
	_tmp13_ = g_settings_create_action (_tmp12_, "opponent");
#line 334 "../src/four-in-a-row.vala"
	_tmp14_ = _tmp13_;
#line 334 "../src/four-in-a-row.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp14_);
#line 334 "../src/four-in-a-row.vala"
	_g_object_unref0 (_tmp14_);
#line 336 "../src/four-in-a-row.vala"
	_tmp15_ = g_strdup ("<Primary>n");
#line 336 "../src/four-in-a-row.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 336 "../src/four-in-a-row.vala"
	_tmp16_[0] = _tmp15_;
#line 336 "../src/four-in-a-row.vala"
	_tmp17_ = _tmp16_;
#line 336 "../src/four-in-a-row.vala"
	_tmp17__length1 = 1;
#line 336 "../src/four-in-a-row.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "ui.new-game", _tmp17_);
#line 336 "../src/four-in-a-row.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 337 "../src/four-in-a-row.vala"
	_tmp18_ = g_strdup ("<Shift><Primary>n");
#line 337 "../src/four-in-a-row.vala"
	_tmp19_ = g_new0 (gchar*, 1 + 1);
#line 337 "../src/four-in-a-row.vala"
	_tmp19_[0] = _tmp18_;
#line 337 "../src/four-in-a-row.vala"
	_tmp20_ = _tmp19_;
#line 337 "../src/four-in-a-row.vala"
	_tmp20__length1 = 1;
#line 337 "../src/four-in-a-row.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "ui.start-game", _tmp20_);
#line 337 "../src/four-in-a-row.vala"
	_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 338 "../src/four-in-a-row.vala"
	_tmp21_ = g_strdup ("<Primary>q");
#line 338 "../src/four-in-a-row.vala"
	_tmp22_ = g_new0 (gchar*, 1 + 1);
#line 338 "../src/four-in-a-row.vala"
	_tmp22_[0] = _tmp21_;
#line 338 "../src/four-in-a-row.vala"
	_tmp23_ = _tmp22_;
#line 338 "../src/four-in-a-row.vala"
	_tmp23__length1 = 1;
#line 338 "../src/four-in-a-row.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.quit", _tmp23_);
#line 338 "../src/four-in-a-row.vala"
	_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 339 "../src/four-in-a-row.vala"
	_tmp24_ = g_strdup ("<Primary>h");
#line 339 "../src/four-in-a-row.vala"
	_tmp25_ = g_new0 (gchar*, 1 + 1);
#line 339 "../src/four-in-a-row.vala"
	_tmp25_[0] = _tmp24_;
#line 339 "../src/four-in-a-row.vala"
	_tmp26_ = _tmp25_;
#line 339 "../src/four-in-a-row.vala"
	_tmp26__length1 = 1;
#line 339 "../src/four-in-a-row.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "ui.hint", _tmp26_);
#line 339 "../src/four-in-a-row.vala"
	_tmp26_ = (_vala_array_free (_tmp26_, _tmp26__length1, (GDestroyNotify) g_free), NULL);
#line 340 "../src/four-in-a-row.vala"
	_tmp27_ = g_strdup ("<Primary>z");
#line 340 "../src/four-in-a-row.vala"
	_tmp28_ = g_new0 (gchar*, 1 + 1);
#line 340 "../src/four-in-a-row.vala"
	_tmp28_[0] = _tmp27_;
#line 340 "../src/four-in-a-row.vala"
	_tmp29_ = _tmp28_;
#line 340 "../src/four-in-a-row.vala"
	_tmp29__length1 = 1;
#line 340 "../src/four-in-a-row.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "ui.undo", _tmp29_);
#line 340 "../src/four-in-a-row.vala"
	_tmp29_ = (_vala_array_free (_tmp29_, _tmp29__length1, (GDestroyNotify) g_free), NULL);
#line 342 "../src/four-in-a-row.vala"
	_tmp30_ = g_strdup ("Escape");
#line 342 "../src/four-in-a-row.vala"
	_tmp31_ = g_new0 (gchar*, 1 + 1);
#line 342 "../src/four-in-a-row.vala"
	_tmp31_[0] = _tmp30_;
#line 342 "../src/four-in-a-row.vala"
	_tmp32_ = _tmp31_;
#line 342 "../src/four-in-a-row.vala"
	_tmp32__length1 = 1;
#line 342 "../src/four-in-a-row.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "ui.back", _tmp32_);
#line 342 "../src/four-in-a-row.vala"
	_tmp32_ = (_vala_array_free (_tmp32_, _tmp32__length1, (GDestroyNotify) g_free), NULL);
#line 343 "../src/four-in-a-row.vala"
	_tmp33_ = g_strdup ("F10");
#line 343 "../src/four-in-a-row.vala"
	_tmp34_ = g_new0 (gchar*, 1 + 1);
#line 343 "../src/four-in-a-row.vala"
	_tmp34_[0] = _tmp33_;
#line 343 "../src/four-in-a-row.vala"
	_tmp35_ = _tmp34_;
#line 343 "../src/four-in-a-row.vala"
	_tmp35__length1 = 1;
#line 343 "../src/four-in-a-row.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "ui.toggle-hamburger", _tmp35_);
#line 343 "../src/four-in-a-row.vala"
	_tmp35_ = (_vala_array_free (_tmp35_, _tmp35__length1, (GDestroyNotify) g_free), NULL);
#line 348 "../src/four-in-a-row.vala"
	g_action_map_add_action_entries ((GActionMap*) self, FOUR_IN_AROW_app_entries, (gint) G_N_ELEMENTS (FOUR_IN_AROW_app_entries), self);
#line 350 "../src/four-in-a-row.vala"
	_tmp36_ = g_action_map_lookup_action ((GActionMap*) self, "game-type");
#line 350 "../src/four-in-a-row.vala"
	_tmp37_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, g_simple_action_get_type (), GSimpleAction));
#line 350 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->game_type_action);
#line 350 "../src/four-in-a-row.vala"
	self->priv->game_type_action = _tmp37_;
#line 351 "../src/four-in-a-row.vala"
	_tmp38_ = g_action_map_lookup_action ((GActionMap*) self, "next-round");
#line 351 "../src/four-in-a-row.vala"
	_tmp39_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, g_simple_action_get_type (), GSimpleAction));
#line 351 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->next_round_action);
#line 351 "../src/four-in-a-row.vala"
	self->priv->next_round_action = _tmp39_;
#line 352 "../src/four-in-a-row.vala"
	_tmp40_ = self->priv->next_round_action;
#line 352 "../src/four-in-a-row.vala"
	g_simple_action_set_enabled (_tmp40_, FALSE);
#line 354 "../src/four-in-a-row.vala"
	_tmp41_ = self->priv->settings;
#line 354 "../src/four-in-a-row.vala"
	g_signal_connect_object (_tmp41_, "changed::first-player", (GCallback) ___lambda9__g_settings_changed, self, 0);
#line 363 "../src/four-in-a-row.vala"
	_tmp42_ = self->priv->settings;
#line 363 "../src/four-in-a-row.vala"
	g_signal_connect_object (_tmp42_, "changed::num-players", (GCallback) ___lambda10__g_settings_changed, self, 0);
#line 387 "../src/four-in-a-row.vala"
	_tmp43_ = self->priv->settings;
#line 387 "../src/four-in-a-row.vala"
	solo = g_settings_get_int (_tmp43_, "num-players") == 1;
#line 388 "../src/four-in-a-row.vala"
	_tmp44_ = self->priv->new_game_screen;
#line 388 "../src/four-in-a-row.vala"
	new_game_screen_update_sensitivity (_tmp44_, solo);
#line 389 "../src/four-in-a-row.vala"
	if (solo) {
#line 2074 "four-in-a-row.c"
		NewGameScreen* _tmp45_;
		GSettings* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gboolean _tmp49_;
#line 391 "../src/four-in-a-row.vala"
		_tmp45_ = self->priv->new_game_screen;
#line 391 "../src/four-in-a-row.vala"
		new_game_screen_update_sensitivity (_tmp45_, TRUE);
#line 392 "../src/four-in-a-row.vala"
		_tmp46_ = self->priv->settings;
#line 392 "../src/four-in-a-row.vala"
		_tmp47_ = g_settings_get_string (_tmp46_, "first-player");
#line 392 "../src/four-in-a-row.vala"
		_tmp48_ = _tmp47_;
#line 392 "../src/four-in-a-row.vala"
		_tmp49_ = g_strcmp0 (_tmp48_, "human") == 0;
#line 392 "../src/four-in-a-row.vala"
		_g_free0 (_tmp48_);
#line 392 "../src/four-in-a-row.vala"
		if (_tmp49_) {
#line 2096 "four-in-a-row.c"
			GSimpleAction* _tmp50_;
			GVariant* _tmp51_;
			GVariant* _tmp52_;
#line 394 "../src/four-in-a-row.vala"
			_tmp50_ = self->priv->game_type_action;
#line 394 "../src/four-in-a-row.vala"
			_tmp51_ = g_variant_new_string ("human");
#line 394 "../src/four-in-a-row.vala"
			g_variant_ref_sink (_tmp51_);
#line 394 "../src/four-in-a-row.vala"
			_tmp52_ = _tmp51_;
#line 394 "../src/four-in-a-row.vala"
			g_simple_action_set_state (_tmp50_, _tmp52_);
#line 394 "../src/four-in-a-row.vala"
			_g_variant_unref0 (_tmp52_);
#line 395 "../src/four-in-a-row.vala"
			self->priv->last_first_player = PLAYER_HUMAN;
#line 2114 "four-in-a-row.c"
		} else {
			GSimpleAction* _tmp53_;
			GVariant* _tmp54_;
			GVariant* _tmp55_;
#line 399 "../src/four-in-a-row.vala"
			_tmp53_ = self->priv->game_type_action;
#line 399 "../src/four-in-a-row.vala"
			_tmp54_ = g_variant_new_string ("computer");
#line 399 "../src/four-in-a-row.vala"
			g_variant_ref_sink (_tmp54_);
#line 399 "../src/four-in-a-row.vala"
			_tmp55_ = _tmp54_;
#line 399 "../src/four-in-a-row.vala"
			g_simple_action_set_state (_tmp53_, _tmp55_);
#line 399 "../src/four-in-a-row.vala"
			_g_variant_unref0 (_tmp55_);
#line 400 "../src/four-in-a-row.vala"
			self->priv->last_first_player = PLAYER_OPPONENT;
#line 2133 "four-in-a-row.c"
		}
	} else {
		NewGameScreen* _tmp56_;
		GSimpleAction* _tmp57_;
		GVariant* _tmp58_;
		GVariant* _tmp59_;
#line 405 "../src/four-in-a-row.vala"
		_tmp56_ = self->priv->new_game_screen;
#line 405 "../src/four-in-a-row.vala"
		new_game_screen_update_sensitivity (_tmp56_, FALSE);
#line 406 "../src/four-in-a-row.vala"
		_tmp57_ = self->priv->game_type_action;
#line 406 "../src/four-in-a-row.vala"
		_tmp58_ = g_variant_new_string ("two");
#line 406 "../src/four-in-a-row.vala"
		g_variant_ref_sink (_tmp58_);
#line 406 "../src/four-in-a-row.vala"
		_tmp59_ = _tmp58_;
#line 406 "../src/four-in-a-row.vala"
		g_simple_action_set_state (_tmp57_, _tmp59_);
#line 406 "../src/four-in-a-row.vala"
		_g_variant_unref0 (_tmp59_);
#line 407 "../src/four-in-a-row.vala"
		self->priv->last_first_player = PLAYER_NOBODY;
#line 2158 "four-in-a-row.c"
	}
}

static void
four_in_arow_real_activate (GApplication* base)
{
	FourInARow * self;
	GameWindow* _tmp0_;
#line 411 "../src/four-in-a-row.vala"
	self = (FourInARow*) base;
#line 413 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->window;
#line 413 "../src/four-in-a-row.vala"
	gtk_window_present ((GtkWindow*) _tmp0_);
#line 2173 "four-in-a-row.c"
}

static gboolean
___lambda7_ (FourInARow* self)
{
	guint8 c = 0U;
	const gchar* _tmp0_;
	gboolean result;
#line 474 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->vstr;
#line 474 "../src/four-in-a-row.vala"
	c = ai_playgame ((guint8) four_in_arow_size, self->priv->ai_level, _tmp0_, (guint8) four_in_arow_target);
#line 475 "../src/four-in-a-row.vala"
	if (((gint) c) >= four_in_arow_size) {
#line 476 "../src/four-in-a-row.vala"
		result = G_SOURCE_REMOVE;
#line 476 "../src/four-in-a-row.vala"
		return result;
#line 2192 "four-in-a-row.c"
	}
#line 477 "../src/four-in-a-row.vala"
	four_in_arow_process_move (self, c);
#line 478 "../src/four-in-a-row.vala"
	self->priv->playgame_timeout = (guint) 0;
#line 479 "../src/four-in-a-row.vala"
	result = G_SOURCE_REMOVE;
#line 479 "../src/four-in-a-row.vala"
	return result;
#line 2202 "four-in-a-row.c"
}

static gboolean
____lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda7_ ((FourInARow*) self);
#line 473 "../src/four-in-a-row.vala"
	return result;
#line 2212 "four-in-a-row.c"
}

void
four_in_arow_game_reset (FourInARow* self,
                         gboolean reload_settings)
{
	GameWindow* _tmp0_;
	GameWindow* _tmp1_;
	gint _tmp12_ = 0;
	gboolean _tmp13_ = FALSE;
	GameBoardView* _tmp14_;
#line 420 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/four-in-a-row.vala"
	four_in_arow_stop_anim (self);
#line 423 "../src/four-in-a-row.vala"
	if (self->priv->playgame_timeout != ((guint) 0)) {
#line 425 "../src/four-in-a-row.vala"
		g_source_remove (self->priv->playgame_timeout);
#line 426 "../src/four-in-a-row.vala"
		self->priv->playgame_timeout = (guint) 0;
#line 2234 "four-in-a-row.c"
	}
#line 429 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->window;
#line 429 "../src/four-in-a-row.vala"
	game_window_allow_undo (_tmp0_, FALSE);
#line 430 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->window;
#line 430 "../src/four-in-a-row.vala"
	game_window_allow_hint (_tmp1_, FALSE);
#line 432 "../src/four-in-a-row.vala"
	four_in_arow_set_gameover (self, FALSE);
#line 434 "../src/four-in-a-row.vala"
	if (reload_settings) {
#line 2248 "four-in-a-row.c"
		GSettings* _tmp2_;
		Scorebox* _tmp3_;
#line 436 "../src/four-in-a-row.vala"
		_tmp2_ = self->priv->settings;
#line 436 "../src/four-in-a-row.vala"
		self->priv->one_player_game = g_settings_get_int (_tmp2_, "num-players") == 1;
#line 437 "../src/four-in-a-row.vala"
		_tmp3_ = self->priv->scorebox;
#line 437 "../src/four-in-a-row.vala"
		scorebox_new_match (_tmp3_, self->priv->one_player_game);
#line 439 "../src/four-in-a-row.vala"
		if (self->priv->one_player_game) {
#line 2261 "four-in-a-row.c"
			Player _tmp4_ = 0;
			GSettings* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gboolean _tmp8_;
			const gchar* _tmp9_ = NULL;
			GSettings* _tmp10_;
			GSettings* _tmp11_;
#line 441 "../src/four-in-a-row.vala"
			_tmp5_ = self->priv->settings;
#line 441 "../src/four-in-a-row.vala"
			_tmp6_ = g_settings_get_string (_tmp5_, "first-player");
#line 441 "../src/four-in-a-row.vala"
			_tmp7_ = _tmp6_;
#line 441 "../src/four-in-a-row.vala"
			_tmp8_ = g_strcmp0 (_tmp7_, "computer") == 0;
#line 441 "../src/four-in-a-row.vala"
			_g_free0 (_tmp7_);
#line 441 "../src/four-in-a-row.vala"
			if (_tmp8_) {
#line 441 "../src/four-in-a-row.vala"
				_tmp4_ = PLAYER_OPPONENT;
#line 2284 "four-in-a-row.c"
			} else {
#line 441 "../src/four-in-a-row.vala"
				_tmp4_ = PLAYER_HUMAN;
#line 2288 "four-in-a-row.c"
			}
#line 441 "../src/four-in-a-row.vala"
			self->priv->player = _tmp4_;
#line 443 "../src/four-in-a-row.vala"
			if (self->priv->player == PLAYER_HUMAN) {
#line 443 "../src/four-in-a-row.vala"
				_tmp9_ = "computer";
#line 2296 "four-in-a-row.c"
			} else {
#line 443 "../src/four-in-a-row.vala"
				_tmp9_ = "human";
#line 2300 "four-in-a-row.c"
			}
#line 443 "../src/four-in-a-row.vala"
			_tmp10_ = self->priv->settings;
#line 443 "../src/four-in-a-row.vala"
			g_settings_set_string (_tmp10_, "first-player", _tmp9_);
#line 444 "../src/four-in-a-row.vala"
			_tmp11_ = self->priv->settings;
#line 444 "../src/four-in-a-row.vala"
			switch (g_settings_get_int (_tmp11_, "opponent")) {
#line 444 "../src/four-in-a-row.vala"
				case 1:
#line 2312 "four-in-a-row.c"
				{
#line 446 "../src/four-in-a-row.vala"
					self->priv->ai_level = DIFFICULTY_EASY;
#line 446 "../src/four-in-a-row.vala"
					break;
#line 2318 "four-in-a-row.c"
				}
#line 444 "../src/four-in-a-row.vala"
				case 2:
#line 2322 "four-in-a-row.c"
				{
#line 447 "../src/four-in-a-row.vala"
					self->priv->ai_level = DIFFICULTY_MEDIUM;
#line 447 "../src/four-in-a-row.vala"
					break;
#line 2328 "four-in-a-row.c"
				}
#line 444 "../src/four-in-a-row.vala"
				case 3:
#line 2332 "four-in-a-row.c"
				{
#line 448 "../src/four-in-a-row.vala"
					self->priv->ai_level = DIFFICULTY_HARD;
#line 448 "../src/four-in-a-row.vala"
					break;
#line 2338 "four-in-a-row.c"
				}
				default:
				{
#line 449 "../src/four-in-a-row.vala"
					g_assert_not_reached ();
#line 2344 "four-in-a-row.c"
				}
			}
		} else {
#line 453 "../src/four-in-a-row.vala"
			four_in_arow_switch_players (self);
#line 2350 "four-in-a-row.c"
		}
	} else {
#line 456 "../src/four-in-a-row.vala"
		four_in_arow_switch_players (self);
#line 2355 "four-in-a-row.c"
	}
#line 458 "../src/four-in-a-row.vala"
	self->priv->winner = PLAYER_NOBODY;
#line 459 "../src/four-in-a-row.vala"
	if ((four_in_arow_size % 2) == 0) {
#line 459 "../src/four-in-a-row.vala"
		_tmp13_ = gtk_get_locale_direction () == GTK_TEXT_DIR_LTR;
#line 2363 "four-in-a-row.c"
	} else {
#line 459 "../src/four-in-a-row.vala"
		_tmp13_ = FALSE;
#line 2367 "four-in-a-row.c"
	}
#line 459 "../src/four-in-a-row.vala"
	if (_tmp13_) {
#line 459 "../src/four-in-a-row.vala"
		_tmp12_ = (((guint8) four_in_arow_size) / 2) - 1;
#line 2373 "four-in-a-row.c"
	} else {
#line 460 "../src/four-in-a-row.vala"
		_tmp12_ = ((guint8) four_in_arow_size) / 2;
#line 2377 "four-in-a-row.c"
	}
#line 459 "../src/four-in-a-row.vala"
	self->priv->column = (guint8) _tmp12_;
#line 461 "../src/four-in-a-row.vala"
	self->priv->column_moveto = self->priv->column;
#line 462 "../src/four-in-a-row.vala"
	self->priv->row = (guint8) 0;
#line 463 "../src/four-in-a-row.vala"
	self->priv->row_dropto = (guint8) 0;
#line 465 "../src/four-in-a-row.vala"
	four_in_arow_clear_board (self);
#line 466 "../src/four-in-a-row.vala"
	four_in_arow_set_status_message (self, NULL);
#line 467 "../src/four-in-a-row.vala"
	_tmp14_ = self->priv->game_board_view;
#line 467 "../src/four-in-a-row.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp14_);
#line 469 "../src/four-in-a-row.vala"
	four_in_arow_move_cursor (self, self->priv->column);
#line 470 "../src/four-in-a-row.vala"
	four_in_arow_prompt_player (self);
#line 471 "../src/four-in-a-row.vala"
	if (!four_in_arow_is_player_human (self)) {
#line 473 "../src/four-in-a-row.vala"
		self->priv->playgame_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, FOUR_IN_AROW_COMPUTER_INITIAL_DELAY, ____lambda7__gsource_func, g_object_ref (self), g_object_unref);
#line 2403 "four-in-a-row.c"
	}
}

static void
four_in_arow_switch_players (FourInARow* self)
{
#line 483 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 485 "../src/four-in-a-row.vala"
	switch (self->priv->last_first_player) {
#line 485 "../src/four-in-a-row.vala"
		case PLAYER_HUMAN:
#line 2416 "four-in-a-row.c"
		{
#line 487 "../src/four-in-a-row.vala"
			self->priv->player = PLAYER_OPPONENT;
#line 487 "../src/four-in-a-row.vala"
			break;
#line 2422 "four-in-a-row.c"
		}
#line 485 "../src/four-in-a-row.vala"
		case PLAYER_OPPONENT:
#line 485 "../src/four-in-a-row.vala"
		case PLAYER_NOBODY:
#line 2428 "four-in-a-row.c"
		{
#line 489 "../src/four-in-a-row.vala"
			self->priv->player = PLAYER_HUMAN;
#line 489 "../src/four-in-a-row.vala"
			break;
#line 2434 "four-in-a-row.c"
		}
		default:
#line 485 "../src/four-in-a-row.vala"
		break;
#line 2439 "four-in-a-row.c"
	}
#line 491 "../src/four-in-a-row.vala"
	self->priv->last_first_player = self->priv->player;
#line 2443 "four-in-a-row.c"
}

static gboolean
_four_in_arow_animate_exec_gsource_func (gpointer self)
{
	gboolean result;
	result = four_in_arow_animate_exec ((FourInARowAnimate*) self);
#line 509 "../src/four-in-a-row.vala"
	return result;
#line 2453 "four-in-a-row.c"
}

static void
four_in_arow_blink_winner (FourInARow* self,
                           guint8 n)
{
	Board* _tmp0_;
	guint8* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
#line 494 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 497 "../src/four-in-a-row.vala"
	if (self->priv->winner == PLAYER_NOBODY) {
#line 498 "../src/four-in-a-row.vala"
		return;
#line 2471 "four-in-a-row.c"
	}
#line 500 "../src/four-in-a-row.vala"
	self->priv->blink_t = self->priv->winner;
#line 502 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->game_board;
#line 502 "../src/four-in-a-row.vala"
	_tmp4_ = board_is_line_at (_tmp0_, self->priv->winner, self->priv->row, self->priv->column, &_tmp1_, &_tmp2_, &_tmp3_);
#line 502 "../src/four-in-a-row.vala"
	self->priv->blink_lines = (g_free (self->priv->blink_lines), NULL);
#line 502 "../src/four-in-a-row.vala"
	self->priv->blink_lines = _tmp1_;
#line 502 "../src/four-in-a-row.vala"
	self->priv->blink_lines_length1 = _tmp2_;
#line 502 "../src/four-in-a-row.vala"
	self->priv->blink_lines_length2 = _tmp3_;
#line 502 "../src/four-in-a-row.vala"
	if (_tmp4_) {
#line 2489 "four-in-a-row.c"
		FourInARowAnimate* temp = NULL;
		FourInARowAnimate* _tmp5_;
		FourInARowAnimate* _tmp6_;
#line 504 "../src/four-in-a-row.vala"
		four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_BLINK;
#line 505 "../src/four-in-a-row.vala"
		self->priv->blink_on = FALSE;
#line 506 "../src/four-in-a-row.vala"
		self->priv->blink_n = (guint8) (2 * n);
#line 507 "../src/four-in-a-row.vala"
		self->priv->blink_line = (guint8) 0;
#line 508 "../src/four-in-a-row.vala"
		_tmp5_ = four_in_arow_animate_new ((guint8) 0, self, (guint8) (2 * n));
#line 508 "../src/four-in-a-row.vala"
		temp = _tmp5_;
#line 509 "../src/four-in-a-row.vala"
		_tmp6_ = temp;
#line 509 "../src/four-in-a-row.vala"
		self->priv->timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, FOUR_IN_AROW_SPEED_BLINK, _four_in_arow_animate_exec_gsource_func, four_in_arow_animate_ref (_tmp6_), four_in_arow_animate_unref);
#line 510 "../src/four-in-a-row.vala"
		while (TRUE) {
#line 510 "../src/four-in-a-row.vala"
			if (!(self->priv->timeout != ((guint) 0))) {
#line 510 "../src/four-in-a-row.vala"
				break;
#line 2515 "four-in-a-row.c"
			}
#line 511 "../src/four-in-a-row.vala"
			gtk_main_iteration ();
#line 2519 "four-in-a-row.c"
		}
#line 502 "../src/four-in-a-row.vala"
		_four_in_arow_animate_unref0 (temp);
#line 2523 "four-in-a-row.c"
	}
}

static inline void
four_in_arow_draw_line (FourInARow* self,
                        guint8 _r1,
                        guint8 _c1,
                        guint8 _r2,
                        guint8 _c2,
                        Player owner)
{
	gboolean done = FALSE;
	gint8 d_row = 0;
	gint8 d_col = 0;
	gint8 r1 = 0;
	gint8 c1 = 0;
	gint8 r2 = 0;
	gint8 c2 = 0;
#line 515 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 519 "../src/four-in-a-row.vala"
	done = FALSE;
#line 523 "../src/four-in-a-row.vala"
	r1 = (gint8) _r1;
#line 524 "../src/four-in-a-row.vala"
	c1 = (gint8) _c1;
#line 525 "../src/four-in-a-row.vala"
	r2 = (gint8) _r2;
#line 526 "../src/four-in-a-row.vala"
	c2 = (gint8) _c2;
#line 528 "../src/four-in-a-row.vala"
	if (r1 < r2) {
#line 528 "../src/four-in-a-row.vala"
		d_row = (gint8) 1;
#line 2558 "four-in-a-row.c"
	} else {
#line 529 "../src/four-in-a-row.vala"
		if (r1 > r2) {
#line 529 "../src/four-in-a-row.vala"
			d_row = (gint8) -1;
#line 2564 "four-in-a-row.c"
		} else {
#line 530 "../src/four-in-a-row.vala"
			d_row = (gint8) 0;
#line 2568 "four-in-a-row.c"
		}
	}
#line 532 "../src/four-in-a-row.vala"
	if (c1 < c2) {
#line 532 "../src/four-in-a-row.vala"
		d_col = (gint8) 1;
#line 2575 "four-in-a-row.c"
	} else {
#line 533 "../src/four-in-a-row.vala"
		if (c1 > c2) {
#line 533 "../src/four-in-a-row.vala"
			d_col = (gint8) -1;
#line 2581 "four-in-a-row.c"
		} else {
#line 534 "../src/four-in-a-row.vala"
			d_col = (gint8) 0;
#line 2585 "four-in-a-row.c"
		}
	}
	{
		gboolean _tmp0_ = FALSE;
#line 536 "../src/four-in-a-row.vala"
		_tmp0_ = TRUE;
#line 536 "../src/four-in-a-row.vala"
		while (TRUE) {
#line 2594 "four-in-a-row.c"
			gboolean _tmp1_ = FALSE;
			Board* _tmp2_;
			GameBoardView* _tmp3_;
#line 536 "../src/four-in-a-row.vala"
			if (!_tmp0_) {
#line 546 "../src/four-in-a-row.vala"
				if (!(!done)) {
#line 546 "../src/four-in-a-row.vala"
					break;
#line 2604 "four-in-a-row.c"
				}
			}
#line 536 "../src/four-in-a-row.vala"
			_tmp0_ = FALSE;
#line 538 "../src/four-in-a-row.vala"
			if (r1 == r2) {
#line 538 "../src/four-in-a-row.vala"
				_tmp1_ = c1 == c2;
#line 2613 "four-in-a-row.c"
			} else {
#line 538 "../src/four-in-a-row.vala"
				_tmp1_ = FALSE;
#line 2617 "four-in-a-row.c"
			}
#line 538 "../src/four-in-a-row.vala"
			done = _tmp1_;
#line 539 "../src/four-in-a-row.vala"
			_tmp2_ = self->priv->game_board;
#line 539 "../src/four-in-a-row.vala"
			board_set (_tmp2_, (guint8) r1, (guint8) c1, owner);
#line 540 "../src/four-in-a-row.vala"
			_tmp3_ = self->priv->game_board_view;
#line 540 "../src/four-in-a-row.vala"
			game_board_view_draw_tile (_tmp3_, (gint) r1, (gint) c1);
#line 541 "../src/four-in-a-row.vala"
			if (r1 != r2) {
#line 542 "../src/four-in-a-row.vala"
				r1 += d_row;
#line 2633 "four-in-a-row.c"
			}
#line 543 "../src/four-in-a-row.vala"
			if (c1 != c2) {
#line 544 "../src/four-in-a-row.vala"
				c1 += d_col;
#line 2639 "four-in-a-row.c"
			}
		}
	}
}

static void
four_in_arow_prompt_player (FourInARow* self)
{
	gboolean human = FALSE;
	gboolean _tmp0_ = FALSE;
	GameWindow* _tmp1_;
	gboolean _tmp7_ = FALSE;
#line 549 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 551 "../src/four-in-a-row.vala"
	human = four_in_arow_is_player_human (self);
#line 553 "../src/four-in-a-row.vala"
	if (human) {
#line 553 "../src/four-in-a-row.vala"
		_tmp0_ = !self->priv->gameover;
#line 2660 "four-in-a-row.c"
	} else {
#line 553 "../src/four-in-a-row.vala"
		_tmp0_ = FALSE;
#line 2664 "four-in-a-row.c"
	}
#line 553 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->window;
#line 553 "../src/four-in-a-row.vala"
	game_window_allow_hint (_tmp1_, _tmp0_);
#line 554 "../src/four-in-a-row.vala"
	four_in_arow_update_round_section (self, FALSE);
#line 556 "../src/four-in-a-row.vala"
	if (self->priv->one_player_game) {
#line 2674 "four-in-a-row.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		GameWindow* _tmp5_;
#line 557 "../src/four-in-a-row.vala"
		if (human) {
#line 557 "../src/four-in-a-row.vala"
			_tmp3_ = ((gint) self->priv->moves) > 1;
#line 2682 "four-in-a-row.c"
		} else {
#line 557 "../src/four-in-a-row.vala"
			_tmp3_ = FALSE;
#line 2686 "four-in-a-row.c"
		}
#line 557 "../src/four-in-a-row.vala"
		if (_tmp3_) {
#line 557 "../src/four-in-a-row.vala"
			_tmp2_ = TRUE;
#line 2692 "four-in-a-row.c"
		} else {
			gboolean _tmp4_ = FALSE;
#line 557 "../src/four-in-a-row.vala"
			if (!human) {
#line 557 "../src/four-in-a-row.vala"
				_tmp4_ = self->priv->gameover;
#line 2699 "four-in-a-row.c"
			} else {
#line 557 "../src/four-in-a-row.vala"
				_tmp4_ = FALSE;
#line 2703 "four-in-a-row.c"
			}
#line 557 "../src/four-in-a-row.vala"
			_tmp2_ = _tmp4_;
#line 2707 "four-in-a-row.c"
		}
#line 557 "../src/four-in-a-row.vala"
		_tmp5_ = self->priv->window;
#line 557 "../src/four-in-a-row.vala"
		game_window_allow_undo (_tmp5_, _tmp2_);
#line 2713 "four-in-a-row.c"
	} else {
		GameWindow* _tmp6_;
#line 559 "../src/four-in-a-row.vala"
		_tmp6_ = self->priv->window;
#line 559 "../src/four-in-a-row.vala"
		game_window_allow_undo (_tmp6_, ((gint) self->priv->moves) > 0);
#line 2720 "four-in-a-row.c"
	}
#line 561 "../src/four-in-a-row.vala"
	if (self->priv->gameover) {
#line 561 "../src/four-in-a-row.vala"
		_tmp7_ = self->priv->winner == PLAYER_NOBODY;
#line 2726 "four-in-a-row.c"
	} else {
#line 561 "../src/four-in-a-row.vala"
		_tmp7_ = FALSE;
#line 2730 "four-in-a-row.c"
	}
#line 561 "../src/four-in-a-row.vala"
	if (_tmp7_) {
#line 2734 "four-in-a-row.c"
		Scorebox* _tmp8_;
		HistoryButton* _tmp9_;
		HistoryButton* _tmp10_;
#line 563 "../src/four-in-a-row.vala"
		_tmp8_ = self->priv->scorebox;
#line 563 "../src/four-in-a-row.vala"
		if (scorebox_is_first_game (_tmp8_)) {
#line 564 "../src/four-in-a-row.vala"
			four_in_arow_set_status_message (self, NULL);
#line 2744 "four-in-a-row.c"
		} else {
#line 567 "../src/four-in-a-row.vala"
			four_in_arow_set_status_message (self, _ ("It’s a draw!"));
#line 2748 "four-in-a-row.c"
		}
#line 568 "../src/four-in-a-row.vala"
		_tmp9_ = self->priv->history_button_1;
#line 568 "../src/four-in-a-row.vala"
		history_button_set_player (_tmp9_, PLAYER_NOBODY);
#line 569 "../src/four-in-a-row.vala"
		_tmp10_ = self->priv->history_button_2;
#line 569 "../src/four-in-a-row.vala"
		history_button_set_player (_tmp10_, PLAYER_NOBODY);
#line 570 "../src/four-in-a-row.vala"
		return;
#line 2760 "four-in-a-row.c"
	}
#line 573 "../src/four-in-a-row.vala"
	if (self->priv->one_player_game) {
#line 575 "../src/four-in-a-row.vala"
		if (self->priv->gameover) {
#line 2766 "four-in-a-row.c"
			HistoryButton* _tmp11_;
			HistoryButton* _tmp12_;
#line 577 "../src/four-in-a-row.vala"
			_tmp11_ = self->priv->history_button_1;
#line 577 "../src/four-in-a-row.vala"
			history_button_set_player (_tmp11_, PLAYER_NOBODY);
#line 578 "../src/four-in-a-row.vala"
			_tmp12_ = self->priv->history_button_2;
#line 578 "../src/four-in-a-row.vala"
			history_button_set_player (_tmp12_, PLAYER_NOBODY);
#line 579 "../src/four-in-a-row.vala"
			if (human) {
#line 581 "../src/four-in-a-row.vala"
				four_in_arow_set_status_message (self, _ ("You win!"));
#line 2781 "four-in-a-row.c"
			} else {
#line 584 "../src/four-in-a-row.vala"
				four_in_arow_set_status_message (self, _ ("I win!"));
#line 2785 "four-in-a-row.c"
			}
		} else {
#line 588 "../src/four-in-a-row.vala"
			if (human) {
#line 2790 "four-in-a-row.c"
				HistoryButton* _tmp13_;
				HistoryButton* _tmp14_;
#line 590 "../src/four-in-a-row.vala"
				_tmp13_ = self->priv->history_button_1;
#line 590 "../src/four-in-a-row.vala"
				history_button_set_player (_tmp13_, PLAYER_HUMAN);
#line 591 "../src/four-in-a-row.vala"
				_tmp14_ = self->priv->history_button_2;
#line 591 "../src/four-in-a-row.vala"
				history_button_set_player (_tmp14_, PLAYER_HUMAN);
#line 593 "../src/four-in-a-row.vala"
				four_in_arow_set_status_message (self, _ ("Your Turn"));
#line 2803 "four-in-a-row.c"
			} else {
				HistoryButton* _tmp15_;
				HistoryButton* _tmp16_;
#line 597 "../src/four-in-a-row.vala"
				_tmp15_ = self->priv->history_button_1;
#line 597 "../src/four-in-a-row.vala"
				history_button_set_player (_tmp15_, PLAYER_OPPONENT);
#line 598 "../src/four-in-a-row.vala"
				_tmp16_ = self->priv->history_button_2;
#line 598 "../src/four-in-a-row.vala"
				history_button_set_player (_tmp16_, PLAYER_OPPONENT);
#line 600 "../src/four-in-a-row.vala"
				four_in_arow_set_status_message (self, _ ("I’m Thinking…"));
#line 2817 "four-in-a-row.c"
			}
		}
	} else {
		gchar* who = NULL;
		const gchar* _tmp26_;
#line 607 "../src/four-in-a-row.vala"
		if (self->priv->gameover) {
#line 2825 "four-in-a-row.c"
			HistoryButton* _tmp17_;
			HistoryButton* _tmp18_;
			ThemeManager* _tmp19_;
			gchar* _tmp20_;
#line 609 "../src/four-in-a-row.vala"
			_tmp17_ = self->priv->history_button_1;
#line 609 "../src/four-in-a-row.vala"
			history_button_set_player (_tmp17_, PLAYER_NOBODY);
#line 610 "../src/four-in-a-row.vala"
			_tmp18_ = self->priv->history_button_2;
#line 610 "../src/four-in-a-row.vala"
			history_button_set_player (_tmp18_, PLAYER_NOBODY);
#line 611 "../src/four-in-a-row.vala"
			_tmp19_ = self->priv->theme_manager;
#line 611 "../src/four-in-a-row.vala"
			_tmp20_ = theme_manager_get_player_win (_tmp19_, self->priv->player);
#line 611 "../src/four-in-a-row.vala"
			_g_free0 (who);
#line 611 "../src/four-in-a-row.vala"
			who = _tmp20_;
#line 2846 "four-in-a-row.c"
		} else {
			Player _tmp21_ = 0;
			Player current_player = 0;
			HistoryButton* _tmp22_;
			HistoryButton* _tmp23_;
			ThemeManager* _tmp24_;
			gchar* _tmp25_;
#line 616 "../src/four-in-a-row.vala"
			if (self->priv->player == PLAYER_HUMAN) {
#line 616 "../src/four-in-a-row.vala"
				_tmp21_ = PLAYER_HUMAN;
#line 2858 "four-in-a-row.c"
			} else {
#line 616 "../src/four-in-a-row.vala"
				_tmp21_ = PLAYER_OPPONENT;
#line 2862 "four-in-a-row.c"
			}
#line 616 "../src/four-in-a-row.vala"
			current_player = _tmp21_;
#line 617 "../src/four-in-a-row.vala"
			_tmp22_ = self->priv->history_button_1;
#line 617 "../src/four-in-a-row.vala"
			history_button_set_player (_tmp22_, current_player);
#line 618 "../src/four-in-a-row.vala"
			_tmp23_ = self->priv->history_button_2;
#line 618 "../src/four-in-a-row.vala"
			history_button_set_player (_tmp23_, current_player);
#line 619 "../src/four-in-a-row.vala"
			_tmp24_ = self->priv->theme_manager;
#line 619 "../src/four-in-a-row.vala"
			_tmp25_ = theme_manager_get_player_turn (_tmp24_, current_player);
#line 619 "../src/four-in-a-row.vala"
			_g_free0 (who);
#line 619 "../src/four-in-a-row.vala"
			who = _tmp25_;
#line 2882 "four-in-a-row.c"
		}
#line 622 "../src/four-in-a-row.vala"
		_tmp26_ = who;
#line 622 "../src/four-in-a-row.vala"
		four_in_arow_set_status_message (self, _ (_tmp26_));
#line 573 "../src/four-in-a-row.vala"
		_g_free0 (who);
#line 2890 "four-in-a-row.c"
	}
}

static void
four_in_arow_swap_player (FourInARow* self)
{
	Player _tmp0_ = 0;
#line 626 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 628 "../src/four-in-a-row.vala"
	if (self->priv->player == PLAYER_HUMAN) {
#line 628 "../src/four-in-a-row.vala"
		_tmp0_ = PLAYER_OPPONENT;
#line 2904 "four-in-a-row.c"
	} else {
#line 628 "../src/four-in-a-row.vala"
		_tmp0_ = PLAYER_HUMAN;
#line 2908 "four-in-a-row.c"
	}
#line 628 "../src/four-in-a-row.vala"
	self->priv->player = _tmp0_;
#line 629 "../src/four-in-a-row.vala"
	four_in_arow_move_cursor (self, (guint8) 3);
#line 630 "../src/four-in-a-row.vala"
	four_in_arow_prompt_player (self);
#line 2916 "four-in-a-row.c"
}

static gboolean
_four_in_arow_next_move_exec_gsource_func (gpointer self)
{
	gboolean result;
	result = four_in_arow_next_move_exec ((FourInARowNextMove*) self);
#line 659 "../src/four-in-a-row.vala"
	return result;
#line 2926 "four-in-a-row.c"
}

static gboolean
____lambda8_ (FourInARow* self)
{
	guint8 col = 0U;
	const gchar* _tmp0_;
	FourInARowNextMove* nm = NULL;
	FourInARowNextMove* _tmp1_;
	gboolean result;
#line 655 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->vstr;
#line 655 "../src/four-in-a-row.vala"
	col = ai_playgame ((guint8) four_in_arow_size, self->priv->ai_level, _tmp0_, (guint8) four_in_arow_target);
#line 656 "../src/four-in-a-row.vala"
	if (((gint) col) >= four_in_arow_size) {
#line 657 "../src/four-in-a-row.vala"
		four_in_arow_set_gameover (self, TRUE);
#line 2945 "four-in-a-row.c"
	}
#line 658 "../src/four-in-a-row.vala"
	_tmp1_ = four_in_arow_next_move_new (col, self);
#line 658 "../src/four-in-a-row.vala"
	nm = _tmp1_;
#line 659 "../src/four-in-a-row.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, FOUR_IN_AROW_SPEED_DROP, _four_in_arow_next_move_exec_gsource_func, four_in_arow_next_move_ref (nm), four_in_arow_next_move_unref);
#line 660 "../src/four-in-a-row.vala"
	self->priv->playgame_timeout = (guint) 0;
#line 661 "../src/four-in-a-row.vala"
	result = G_SOURCE_REMOVE;
#line 661 "../src/four-in-a-row.vala"
	_four_in_arow_next_move_unref0 (nm);
#line 661 "../src/four-in-a-row.vala"
	return result;
#line 2961 "four-in-a-row.c"
}

static gboolean
_____lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda8_ ((FourInARow*) self);
#line 654 "../src/four-in-a-row.vala"
	return result;
#line 2971 "four-in-a-row.c"
}

static void
four_in_arow_process_move3 (FourInARow* self,
                            guint8 c)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint8 _tmp4_;
#line 633 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 635 "../src/four-in-a-row.vala"
	four_in_arow_play_sound (self, FOUR_IN_AROW_SOUND_ID_DROP);
#line 637 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->vstr;
#line 637 "../src/four-in-a-row.vala"
	_tmp1_ = g_strdup_printf ("%i", c + 1);
#line 637 "../src/four-in-a-row.vala"
	_tmp2_ = _tmp1_;
#line 637 "../src/four-in-a-row.vala"
	_tmp3_ = g_strconcat (_tmp0_, _tmp2_, NULL);
#line 637 "../src/four-in-a-row.vala"
	_g_free0 (self->priv->vstr);
#line 637 "../src/four-in-a-row.vala"
	self->priv->vstr = _tmp3_;
#line 637 "../src/four-in-a-row.vala"
	_g_free0 (_tmp2_);
#line 638 "../src/four-in-a-row.vala"
	_tmp4_ = self->priv->moves;
#line 638 "../src/four-in-a-row.vala"
	self->priv->moves = _tmp4_ + 1;
#line 640 "../src/four-in-a-row.vala"
	four_in_arow_check_game_state (self);
#line 642 "../src/four-in-a-row.vala"
	if (self->priv->gameover) {
#line 3009 "four-in-a-row.c"
		Scorebox* _tmp5_;
#line 644 "../src/four-in-a-row.vala"
		_tmp5_ = self->priv->scorebox;
#line 644 "../src/four-in-a-row.vala"
		scorebox_win (_tmp5_, self->priv->winner);
#line 645 "../src/four-in-a-row.vala"
		four_in_arow_prompt_player (self);
#line 646 "../src/four-in-a-row.vala"
		if (self->priv->winner != PLAYER_NOBODY) {
#line 647 "../src/four-in-a-row.vala"
			four_in_arow_blink_winner (self, (guint8) 3);
#line 3021 "four-in-a-row.c"
		}
	} else {
#line 651 "../src/four-in-a-row.vala"
		four_in_arow_swap_player (self);
#line 652 "../src/four-in-a-row.vala"
		if (!four_in_arow_is_player_human (self)) {
#line 654 "../src/four-in-a-row.vala"
			self->priv->playgame_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, FOUR_IN_AROW_COMPUTER_MOVE_DELAY, _____lambda8__gsource_func, g_object_ref (self), g_object_unref);
#line 3030 "four-in-a-row.c"
		}
	}
}

static inline void
four_in_arow_check_game_state (FourInARow* self)
{
	Board* _tmp0_;
#line 666 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 668 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->game_board;
#line 668 "../src/four-in-a-row.vala"
	if (board_is_line_at (_tmp0_, self->priv->player, self->priv->row, self->priv->column, NULL, (gint) 0, (gint) 0)) {
#line 3045 "four-in-a-row.c"
		GameWindow* _tmp2_;
#line 670 "../src/four-in-a-row.vala"
		four_in_arow_set_gameover (self, TRUE);
#line 671 "../src/four-in-a-row.vala"
		self->priv->winner = self->priv->player;
#line 672 "../src/four-in-a-row.vala"
		if (self->priv->one_player_game) {
#line 3053 "four-in-a-row.c"
			FourInARowSoundID _tmp1_ = 0;
#line 673 "../src/four-in-a-row.vala"
			if (four_in_arow_is_player_human (self)) {
#line 673 "../src/four-in-a-row.vala"
				_tmp1_ = FOUR_IN_AROW_SOUND_ID_YOU_WIN;
#line 3059 "four-in-a-row.c"
			} else {
#line 673 "../src/four-in-a-row.vala"
				_tmp1_ = FOUR_IN_AROW_SOUND_ID_I_WIN;
#line 3063 "four-in-a-row.c"
			}
#line 673 "../src/four-in-a-row.vala"
			four_in_arow_play_sound (self, _tmp1_);
#line 3067 "four-in-a-row.c"
		} else {
#line 675 "../src/four-in-a-row.vala"
			four_in_arow_play_sound (self, FOUR_IN_AROW_SOUND_ID_PLAYER_WIN);
#line 3071 "four-in-a-row.c"
		}
#line 676 "../src/four-in-a-row.vala"
		_tmp2_ = self->priv->window;
#line 676 "../src/four-in-a-row.vala"
		game_window_allow_hint (_tmp2_, FALSE);
#line 3077 "four-in-a-row.c"
	} else {
#line 678 "../src/four-in-a-row.vala"
		if (((gint) self->priv->moves) == ((four_in_arow_size - 1) * four_in_arow_size)) {
#line 680 "../src/four-in-a-row.vala"
			four_in_arow_set_gameover (self, TRUE);
#line 681 "../src/four-in-a-row.vala"
			self->priv->winner = PLAYER_NOBODY;
#line 682 "../src/four-in-a-row.vala"
			four_in_arow_play_sound (self, FOUR_IN_AROW_SOUND_ID_DRAWN_GAME);
#line 3087 "four-in-a-row.c"
		}
	}
}

static gboolean
four_in_arow_is_player_human (FourInARow* self)
{
	gboolean result;
#line 686 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 688 "../src/four-in-a-row.vala"
	if (self->priv->one_player_game) {
#line 689 "../src/four-in-a-row.vala"
		result = self->priv->player == PLAYER_HUMAN;
#line 689 "../src/four-in-a-row.vala"
		return result;
#line 3104 "four-in-a-row.c"
	} else {
#line 691 "../src/four-in-a-row.vala"
		result = TRUE;
#line 691 "../src/four-in-a-row.vala"
		return result;
#line 3110 "four-in-a-row.c"
	}
}

static void
four_in_arow_process_move2 (FourInARow* self,
                            guint8 c)
{
	guint8 r = 0U;
	Board* _tmp0_;
#line 694 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->game_board;
#line 696 "../src/four-in-a-row.vala"
	r = board_first_empty_row (_tmp0_, c);
#line 697 "../src/four-in-a-row.vala"
	if (((gint) r) != 0) {
#line 3128 "four-in-a-row.c"
		FourInARowAnimate* temp = NULL;
		FourInARowAnimate* _tmp1_;
		FourInARowAnimate* _tmp2_;
#line 699 "../src/four-in-a-row.vala"
		self->priv->row = (guint8) 0;
#line 700 "../src/four-in-a-row.vala"
		self->priv->row_dropto = r;
#line 701 "../src/four-in-a-row.vala"
		four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_DROP;
#line 702 "../src/four-in-a-row.vala"
		_tmp1_ = four_in_arow_animate_new (c, self, (guint8) 0);
#line 702 "../src/four-in-a-row.vala"
		temp = _tmp1_;
#line 703 "../src/four-in-a-row.vala"
		_tmp2_ = temp;
#line 703 "../src/four-in-a-row.vala"
		self->priv->timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, FOUR_IN_AROW_SPEED_DROP, _four_in_arow_animate_exec_gsource_func, four_in_arow_animate_ref (_tmp2_), four_in_arow_animate_unref);
#line 697 "../src/four-in-a-row.vala"
		_four_in_arow_animate_unref0 (temp);
#line 3148 "four-in-a-row.c"
	} else {
#line 706 "../src/four-in-a-row.vala"
		four_in_arow_play_sound (self, FOUR_IN_AROW_SOUND_ID_COLUMN_FULL);
#line 3152 "four-in-a-row.c"
	}
}

static void
four_in_arow_process_move (FourInARow* self,
                           guint8 c)
{
	FourInARowAnimate* temp = NULL;
	FourInARowAnimate* _tmp2_;
	FourInARowAnimate* _tmp3_;
#line 709 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 711 "../src/four-in-a-row.vala"
	if (self->priv->timeout != ((guint) 0)) {
#line 3167 "four-in-a-row.c"
		FourInARowAnimate* temp = NULL;
		FourInARowAnimate* _tmp0_;
		FourInARowAnimate* _tmp1_;
#line 713 "../src/four-in-a-row.vala"
		_tmp0_ = four_in_arow_animate_new (c, self, (guint8) 0);
#line 713 "../src/four-in-a-row.vala"
		temp = _tmp0_;
#line 714 "../src/four-in-a-row.vala"
		_tmp1_ = temp;
#line 714 "../src/four-in-a-row.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, FOUR_IN_AROW_SPEED_DROP, _four_in_arow_animate_exec_gsource_func, four_in_arow_animate_ref (_tmp1_), four_in_arow_animate_unref);
#line 715 "../src/four-in-a-row.vala"
		_four_in_arow_animate_unref0 (temp);
#line 715 "../src/four-in-a-row.vala"
		return;
#line 3183 "four-in-a-row.c"
	}
#line 718 "../src/four-in-a-row.vala"
	self->priv->column_moveto = c;
#line 719 "../src/four-in-a-row.vala"
	four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_MOVE;
#line 720 "../src/four-in-a-row.vala"
	_tmp2_ = four_in_arow_animate_new (c, self, (guint8) 0);
#line 720 "../src/four-in-a-row.vala"
	temp = _tmp2_;
#line 721 "../src/four-in-a-row.vala"
	_tmp3_ = temp;
#line 721 "../src/four-in-a-row.vala"
	self->priv->timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, FOUR_IN_AROW_SPEED_DROP, _four_in_arow_animate_exec_gsource_func, four_in_arow_animate_ref (_tmp3_), four_in_arow_animate_unref);
#line 709 "../src/four-in-a-row.vala"
	_four_in_arow_animate_unref0 (temp);
#line 3199 "four-in-a-row.c"
}

static inline void
four_in_arow_drop (FourInARow* self)
{
	Player _tmp0_ = 0;
	Player tile = 0;
	Board* _tmp1_;
	GameBoardView* _tmp2_;
	guint8 _tmp3_;
	Board* _tmp4_;
	GameBoardView* _tmp5_;
#line 724 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 726 "../src/four-in-a-row.vala"
	if (self->priv->player == PLAYER_HUMAN) {
#line 726 "../src/four-in-a-row.vala"
		_tmp0_ = PLAYER_HUMAN;
#line 3218 "four-in-a-row.c"
	} else {
#line 726 "../src/four-in-a-row.vala"
		_tmp0_ = PLAYER_OPPONENT;
#line 3222 "four-in-a-row.c"
	}
#line 726 "../src/four-in-a-row.vala"
	tile = _tmp0_;
#line 728 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->game_board;
#line 728 "../src/four-in-a-row.vala"
	board_set (_tmp1_, self->priv->row, self->priv->column, PLAYER_NOBODY);
#line 729 "../src/four-in-a-row.vala"
	_tmp2_ = self->priv->game_board_view;
#line 729 "../src/four-in-a-row.vala"
	game_board_view_draw_tile (_tmp2_, (gint) self->priv->row, (gint) self->priv->column);
#line 731 "../src/four-in-a-row.vala"
	_tmp3_ = self->priv->row;
#line 731 "../src/four-in-a-row.vala"
	self->priv->row = _tmp3_ + 1;
#line 732 "../src/four-in-a-row.vala"
	_tmp4_ = self->priv->game_board;
#line 732 "../src/four-in-a-row.vala"
	board_set (_tmp4_, self->priv->row, self->priv->column, tile);
#line 733 "../src/four-in-a-row.vala"
	_tmp5_ = self->priv->game_board_view;
#line 733 "../src/four-in-a-row.vala"
	game_board_view_draw_tile (_tmp5_, (gint) self->priv->row, (gint) self->priv->column);
#line 3246 "four-in-a-row.c"
}

static inline void
four_in_arow_move (FourInARow* self,
                   guint8 c)
{
	Board* _tmp0_;
	GameBoardView* _tmp1_;
	Player _tmp2_ = 0;
	Board* _tmp3_;
	GameBoardView* _tmp4_;
#line 736 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 738 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->game_board;
#line 738 "../src/four-in-a-row.vala"
	board_set (_tmp0_, (guint8) 0, self->priv->column, PLAYER_NOBODY);
#line 739 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->game_board_view;
#line 739 "../src/four-in-a-row.vala"
	game_board_view_draw_tile (_tmp1_, 0, (gint) self->priv->column);
#line 741 "../src/four-in-a-row.vala"
	self->priv->column = c;
#line 742 "../src/four-in-a-row.vala"
	if (self->priv->player == PLAYER_HUMAN) {
#line 742 "../src/four-in-a-row.vala"
		_tmp2_ = PLAYER_HUMAN;
#line 3274 "four-in-a-row.c"
	} else {
#line 742 "../src/four-in-a-row.vala"
		_tmp2_ = PLAYER_OPPONENT;
#line 3278 "four-in-a-row.c"
	}
#line 742 "../src/four-in-a-row.vala"
	_tmp3_ = self->priv->game_board;
#line 742 "../src/four-in-a-row.vala"
	board_set (_tmp3_, (guint8) 0, c, _tmp2_);
#line 744 "../src/four-in-a-row.vala"
	_tmp4_ = self->priv->game_board_view;
#line 744 "../src/four-in-a-row.vala"
	game_board_view_draw_tile (_tmp4_, 0, (gint) c);
#line 3288 "four-in-a-row.c"
}

static void
four_in_arow_move_cursor (FourInARow* self,
                          guint8 c)
{
#line 747 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 749 "../src/four-in-a-row.vala"
	four_in_arow_move (self, c);
#line 750 "../src/four-in-a-row.vala"
	self->priv->column_moveto = c;
#line 750 "../src/four-in-a-row.vala"
	self->priv->column = self->priv->column_moveto;
#line 751 "../src/four-in-a-row.vala"
	self->priv->row_dropto = (guint8) 0;
#line 751 "../src/four-in-a-row.vala"
	self->priv->row = self->priv->row_dropto;
#line 3307 "four-in-a-row.c"
}

static void
four_in_arow_set_status_message (FourInARow* self,
                                 const gchar* message)
{
	GameWindow* _tmp0_;
#line 754 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 756 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->window;
#line 756 "../src/four-in-a-row.vala"
	game_window_set_subtitle (_tmp0_, message);
#line 3321 "four-in-a-row.c"
}

static void
four_in_arow_stop_anim (FourInARow* self)
{
#line 777 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 779 "../src/four-in-a-row.vala"
	if (self->priv->timeout == ((guint) 0)) {
#line 780 "../src/four-in-a-row.vala"
		return;
#line 3333 "four-in-a-row.c"
	}
#line 781 "../src/four-in-a-row.vala"
	four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_NONE;
#line 782 "../src/four-in-a-row.vala"
	g_source_remove (self->priv->timeout);
#line 783 "../src/four-in-a-row.vala"
	self->priv->timeout = (guint) 0;
#line 3341 "four-in-a-row.c"
}

static void
four_in_arow_clear_board (FourInARow* self)
{
	Board* _tmp0_;
	gchar* _tmp1_;
#line 786 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 788 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->game_board;
#line 788 "../src/four-in-a-row.vala"
	board_clear (_tmp0_);
#line 789 "../src/four-in-a-row.vala"
	self->priv->moves = (guint8) 0;
#line 790 "../src/four-in-a-row.vala"
	_tmp1_ = g_strdup ("");
#line 790 "../src/four-in-a-row.vala"
	_g_free0 (self->priv->vstr);
#line 790 "../src/four-in-a-row.vala"
	self->priv->vstr = _tmp1_;
#line 3363 "four-in-a-row.c"
}

static inline void
four_in_arow_blink_tile (FourInARow* self,
                         guint8 row,
                         guint8 col,
                         Player tile,
                         guint8 n)
{
	guint8* _tmp0_;
	FourInARowAnimate* temp = NULL;
	FourInARowAnimate* _tmp1_;
	FourInARowAnimate* _tmp2_;
#line 793 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 795 "../src/four-in-a-row.vala"
	if (self->priv->timeout != ((guint) 0)) {
#line 796 "../src/four-in-a-row.vala"
		return;
#line 3383 "four-in-a-row.c"
	}
#line 797 "../src/four-in-a-row.vala"
	_tmp0_ = g_new0 (guint8, 1 * 4);
#line 797 "../src/four-in-a-row.vala"
	_tmp0_[0] = row;
#line 797 "../src/four-in-a-row.vala"
	_tmp0_[1] = col;
#line 797 "../src/four-in-a-row.vala"
	_tmp0_[2] = row;
#line 797 "../src/four-in-a-row.vala"
	_tmp0_[3] = col;
#line 797 "../src/four-in-a-row.vala"
	self->priv->blink_lines = (g_free (self->priv->blink_lines), NULL);
#line 797 "../src/four-in-a-row.vala"
	self->priv->blink_lines = _tmp0_;
#line 797 "../src/four-in-a-row.vala"
	self->priv->blink_lines_length1 = 1;
#line 797 "../src/four-in-a-row.vala"
	self->priv->blink_lines_length2 = 4;
#line 798 "../src/four-in-a-row.vala"
	self->priv->blink_line = (guint8) 0;
#line 799 "../src/four-in-a-row.vala"
	self->priv->blink_t = tile;
#line 800 "../src/four-in-a-row.vala"
	self->priv->blink_n = (guint8) (2 * n);
#line 801 "../src/four-in-a-row.vala"
	self->priv->blink_on = FALSE;
#line 802 "../src/four-in-a-row.vala"
	four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_BLINK;
#line 803 "../src/four-in-a-row.vala"
	_tmp1_ = four_in_arow_animate_new ((guint8) 0, self, (guint8) (2 * n));
#line 803 "../src/four-in-a-row.vala"
	temp = _tmp1_;
#line 804 "../src/four-in-a-row.vala"
	_tmp2_ = temp;
#line 804 "../src/four-in-a-row.vala"
	self->priv->timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, FOUR_IN_AROW_SPEED_BLINK, _four_in_arow_animate_exec_gsource_func, four_in_arow_animate_ref (_tmp2_), four_in_arow_animate_unref);
#line 793 "../src/four-in-a-row.vala"
	_four_in_arow_animate_unref0 (temp);
#line 3423 "four-in-a-row.c"
}

static inline void
four_in_arow_on_game_new (FourInARow* self)
{
#line 892 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 894 "../src/four-in-a-row.vala"
	four_in_arow_stop_anim (self);
#line 895 "../src/four-in-a-row.vala"
	four_in_arow_game_reset (self, TRUE);
#line 3435 "four-in-a-row.c"
}

static inline void
four_in_arow_on_game_hint (FourInARow* self)
{
	GameWindow* _tmp0_;
	GameWindow* _tmp1_;
	guint8 c = 0U;
	const gchar* _tmp2_;
	FourInARowAnimate* temp = NULL;
	FourInARowAnimate* _tmp3_;
	FourInARowAnimate* _tmp4_;
	Board* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 898 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 900 "../src/four-in-a-row.vala"
	if (self->priv->timeout != ((guint) 0)) {
#line 901 "../src/four-in-a-row.vala"
		return;
#line 3458 "four-in-a-row.c"
	}
#line 902 "../src/four-in-a-row.vala"
	if (self->priv->gameover) {
#line 903 "../src/four-in-a-row.vala"
		return;
#line 3464 "four-in-a-row.c"
	}
#line 905 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->window;
#line 905 "../src/four-in-a-row.vala"
	game_window_allow_hint (_tmp0_, FALSE);
#line 906 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->window;
#line 906 "../src/four-in-a-row.vala"
	game_window_allow_undo (_tmp1_, FALSE);
#line 909 "../src/four-in-a-row.vala"
	four_in_arow_set_status_message (self, _ ("I’m Thinking…"));
#line 911 "../src/four-in-a-row.vala"
	_tmp2_ = self->priv->vstr;
#line 911 "../src/four-in-a-row.vala"
	c = ai_playgame ((guint8) four_in_arow_size, DIFFICULTY_HARD, _tmp2_, (guint8) four_in_arow_target);
#line 912 "../src/four-in-a-row.vala"
	if (((gint) c) >= four_in_arow_size) {
#line 913 "../src/four-in-a-row.vala"
		g_assert_not_reached ();
#line 3484 "four-in-a-row.c"
	}
#line 915 "../src/four-in-a-row.vala"
	self->priv->column_moveto = c;
#line 916 "../src/four-in-a-row.vala"
	while (TRUE) {
#line 916 "../src/four-in-a-row.vala"
		if (!(self->priv->timeout != ((guint) 0))) {
#line 916 "../src/four-in-a-row.vala"
			break;
#line 3494 "four-in-a-row.c"
		}
#line 917 "../src/four-in-a-row.vala"
		gtk_main_iteration ();
#line 3498 "four-in-a-row.c"
	}
#line 918 "../src/four-in-a-row.vala"
	four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_HINT;
#line 919 "../src/four-in-a-row.vala"
	_tmp3_ = four_in_arow_animate_new ((guint8) 0, self, (guint8) 0);
#line 919 "../src/four-in-a-row.vala"
	temp = _tmp3_;
#line 920 "../src/four-in-a-row.vala"
	_tmp4_ = temp;
#line 920 "../src/four-in-a-row.vala"
	self->priv->timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, FOUR_IN_AROW_SPEED_MOVE, _four_in_arow_animate_exec_gsource_func, four_in_arow_animate_ref (_tmp4_), four_in_arow_animate_unref);
#line 922 "../src/four-in-a-row.vala"
	_tmp5_ = self->priv->game_board;
#line 922 "../src/four-in-a-row.vala"
	four_in_arow_blink_tile (self, (guint8) 0, c, board_get (_tmp5_, (guint8) 0, c), (guint8) 3);
#line 925 "../src/four-in-a-row.vala"
	_tmp6_ = g_strdup_printf (_ ("Hint: Column %d"), c + 1);
#line 925 "../src/four-in-a-row.vala"
	_tmp7_ = _tmp6_;
#line 925 "../src/four-in-a-row.vala"
	four_in_arow_set_status_message (self, _tmp7_);
#line 925 "../src/four-in-a-row.vala"
	_g_free0 (_tmp7_);
#line 927 "../src/four-in-a-row.vala"
	if (((gint) self->priv->moves) <= 0) {
#line 927 "../src/four-in-a-row.vala"
		_tmp8_ = TRUE;
#line 3526 "four-in-a-row.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 927 "../src/four-in-a-row.vala"
		if (((gint) self->priv->moves) == 1) {
#line 927 "../src/four-in-a-row.vala"
			_tmp9_ = four_in_arow_is_player_human (self);
#line 3533 "four-in-a-row.c"
		} else {
#line 927 "../src/four-in-a-row.vala"
			_tmp9_ = FALSE;
#line 3537 "four-in-a-row.c"
		}
#line 927 "../src/four-in-a-row.vala"
		_tmp8_ = _tmp9_;
#line 3541 "four-in-a-row.c"
	}
#line 927 "../src/four-in-a-row.vala"
	if (_tmp8_) {
#line 3545 "four-in-a-row.c"
		GameWindow* _tmp10_;
#line 928 "../src/four-in-a-row.vala"
		_tmp10_ = self->priv->window;
#line 928 "../src/four-in-a-row.vala"
		game_window_allow_undo (_tmp10_, FALSE);
#line 3551 "four-in-a-row.c"
	} else {
		GameWindow* _tmp11_;
#line 930 "../src/four-in-a-row.vala"
		_tmp11_ = self->priv->window;
#line 930 "../src/four-in-a-row.vala"
		game_window_allow_undo (_tmp11_, TRUE);
#line 3558 "four-in-a-row.c"
	}
#line 898 "../src/four-in-a-row.vala"
	_four_in_arow_animate_unref0 (temp);
#line 3562 "four-in-a-row.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 3579 "four-in-a-row.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 3606 "four-in-a-row.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 3612 "four-in-a-row.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 3618 "four-in-a-row.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 3622 "four-in-a-row.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 3630 "four-in-a-row.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 3634 "four-in-a-row.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 3646 "four-in-a-row.c"
}

static inline void
four_in_arow_on_game_undo (FourInARow* self)
{
	guint8 _tmp0_;
	guint8 c = 0U;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint8 _tmp4_;
	guint8 r = 0U;
	Board* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	Board* _tmp9_;
	GameBoardView* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
#line 933 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 935 "../src/four-in-a-row.vala"
	if (self->priv->timeout != ((guint) 0)) {
#line 936 "../src/four-in-a-row.vala"
		return;
#line 3672 "four-in-a-row.c"
	}
#line 938 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->moves;
#line 938 "../src/four-in-a-row.vala"
	self->priv->moves = _tmp0_ - 1;
#line 939 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->vstr;
#line 939 "../src/four-in-a-row.vala"
	_tmp2_ = g_strdup_printf ("%c", string_get (_tmp1_, (glong) self->priv->moves));
#line 939 "../src/four-in-a-row.vala"
	_tmp3_ = _tmp2_;
#line 939 "../src/four-in-a-row.vala"
	_tmp4_ = (guint8) (((guint8) atoi (_tmp3_)) - 1);
#line 939 "../src/four-in-a-row.vala"
	_g_free0 (_tmp3_);
#line 939 "../src/four-in-a-row.vala"
	c = _tmp4_;
#line 940 "../src/four-in-a-row.vala"
	_tmp5_ = self->priv->game_board;
#line 940 "../src/four-in-a-row.vala"
	r = (guint8) (board_first_empty_row (_tmp5_, c) + 1);
#line 941 "../src/four-in-a-row.vala"
	_tmp6_ = self->priv->vstr;
#line 941 "../src/four-in-a-row.vala"
	_tmp7_ = string_slice (_tmp6_, (glong) 0, (glong) self->priv->moves);
#line 941 "../src/four-in-a-row.vala"
	_g_free0 (self->priv->vstr);
#line 941 "../src/four-in-a-row.vala"
	self->priv->vstr = _tmp7_;
#line 943 "../src/four-in-a-row.vala"
	if (self->priv->gameover) {
#line 3704 "four-in-a-row.c"
		Scorebox* _tmp8_;
#line 945 "../src/four-in-a-row.vala"
		_tmp8_ = self->priv->scorebox;
#line 945 "../src/four-in-a-row.vala"
		scorebox_unwin (_tmp8_);
#line 946 "../src/four-in-a-row.vala"
		four_in_arow_set_gameover (self, FALSE);
#line 947 "../src/four-in-a-row.vala"
		four_in_arow_prompt_player (self);
#line 3714 "four-in-a-row.c"
	} else {
#line 950 "../src/four-in-a-row.vala"
		four_in_arow_swap_player (self);
#line 3718 "four-in-a-row.c"
	}
#line 951 "../src/four-in-a-row.vala"
	four_in_arow_move_cursor (self, c);
#line 953 "../src/four-in-a-row.vala"
	_tmp9_ = self->priv->game_board;
#line 953 "../src/four-in-a-row.vala"
	board_set (_tmp9_, r, c, PLAYER_NOBODY);
#line 954 "../src/four-in-a-row.vala"
	_tmp10_ = self->priv->game_board_view;
#line 954 "../src/four-in-a-row.vala"
	game_board_view_draw_tile (_tmp10_, (gint) r, (gint) c);
#line 956 "../src/four-in-a-row.vala"
	if (self->priv->one_player_game) {
#line 957 "../src/four-in-a-row.vala"
		_tmp12_ = !four_in_arow_is_player_human (self);
#line 3734 "four-in-a-row.c"
	} else {
#line 956 "../src/four-in-a-row.vala"
		_tmp12_ = FALSE;
#line 3738 "four-in-a-row.c"
	}
#line 956 "../src/four-in-a-row.vala"
	if (_tmp12_) {
#line 958 "../src/four-in-a-row.vala"
		_tmp11_ = ((gint) self->priv->moves) > 0;
#line 3744 "four-in-a-row.c"
	} else {
#line 956 "../src/four-in-a-row.vala"
		_tmp11_ = FALSE;
#line 3748 "four-in-a-row.c"
	}
#line 956 "../src/four-in-a-row.vala"
	if (_tmp11_) {
#line 3752 "four-in-a-row.c"
		guint8 _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		Board* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		Board* _tmp20_;
		GameBoardView* _tmp21_;
#line 960 "../src/four-in-a-row.vala"
		_tmp13_ = self->priv->moves;
#line 960 "../src/four-in-a-row.vala"
		self->priv->moves = _tmp13_ - 1;
#line 961 "../src/four-in-a-row.vala"
		_tmp14_ = self->priv->vstr;
#line 961 "../src/four-in-a-row.vala"
		_tmp15_ = g_strdup_printf ("%c", string_get (_tmp14_, (glong) self->priv->moves));
#line 961 "../src/four-in-a-row.vala"
		_tmp16_ = _tmp15_;
#line 961 "../src/four-in-a-row.vala"
		c = (guint8) (((guint8) atoi (_tmp16_)) - 1);
#line 961 "../src/four-in-a-row.vala"
		_g_free0 (_tmp16_);
#line 962 "../src/four-in-a-row.vala"
		_tmp17_ = self->priv->game_board;
#line 962 "../src/four-in-a-row.vala"
		r = (guint8) (board_first_empty_row (_tmp17_, c) + 1);
#line 963 "../src/four-in-a-row.vala"
		_tmp18_ = self->priv->vstr;
#line 963 "../src/four-in-a-row.vala"
		_tmp19_ = string_slice (_tmp18_, (glong) 0, (glong) self->priv->moves);
#line 963 "../src/four-in-a-row.vala"
		_g_free0 (self->priv->vstr);
#line 963 "../src/four-in-a-row.vala"
		self->priv->vstr = _tmp19_;
#line 964 "../src/four-in-a-row.vala"
		four_in_arow_swap_player (self);
#line 965 "../src/four-in-a-row.vala"
		four_in_arow_move_cursor (self, c);
#line 966 "../src/four-in-a-row.vala"
		_tmp20_ = self->priv->game_board;
#line 966 "../src/four-in-a-row.vala"
		board_set (_tmp20_, r, c, PLAYER_NOBODY);
#line 967 "../src/four-in-a-row.vala"
		_tmp21_ = self->priv->game_board_view;
#line 967 "../src/four-in-a-row.vala"
		game_board_view_draw_tile (_tmp21_, (gint) r, (gint) c);
#line 3800 "four-in-a-row.c"
	}
}

static void
four_in_arow_change_game_type (FourInARow* self,
                               GSimpleAction* action,
                               GVariant* gvariant)
{
	gchar* type = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 981 "../src/four-in-a-row.vala"
	static GQuark _tmp4_label0 = 0;
#line 981 "../src/four-in-a-row.vala"
	static GQuark _tmp4_label1 = 0;
#line 981 "../src/four-in-a-row.vala"
	static GQuark _tmp4_label2 = 0;
#line 976 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 976 "../src/four-in-a-row.vala"
	g_return_if_fail (action != NULL);
#line 976 "../src/four-in-a-row.vala"
	_vala_return_if_fail (gvariant != NULL, "gvariant != null");
#line 979 "../src/four-in-a-row.vala"
	_tmp0_ = g_variant_get_string ((GVariant*) gvariant, NULL);
#line 979 "../src/four-in-a-row.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 979 "../src/four-in-a-row.vala"
	type = _tmp1_;
#line 981 "../src/four-in-a-row.vala"
	_tmp2_ = type;
#line 981 "../src/four-in-a-row.vala"
	_tmp3_ = _tmp2_;
#line 981 "../src/four-in-a-row.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 981 "../src/four-in-a-row.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("human")))) {
#line 981 "../src/four-in-a-row.vala"
		switch (0) {
#line 3843 "four-in-a-row.c"
			default:
			{
				GSettings* _tmp6_;
				NewGameScreen* _tmp7_;
				GSettings* _tmp8_;
#line 983 "../src/four-in-a-row.vala"
				_tmp6_ = self->priv->settings;
#line 983 "../src/four-in-a-row.vala"
				g_settings_set_int (_tmp6_, "num-players", 1);
#line 983 "../src/four-in-a-row.vala"
				_tmp7_ = self->priv->new_game_screen;
#line 983 "../src/four-in-a-row.vala"
				new_game_screen_update_sensitivity (_tmp7_, TRUE);
#line 984 "../src/four-in-a-row.vala"
				_tmp8_ = self->priv->settings;
#line 984 "../src/four-in-a-row.vala"
				g_settings_set_string (_tmp8_, "first-player", "human");
#line 984 "../src/four-in-a-row.vala"
				_g_free0 (type);
#line 984 "../src/four-in-a-row.vala"
				return;
#line 3865 "four-in-a-row.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("computer")))) {
#line 981 "../src/four-in-a-row.vala"
		switch (0) {
#line 3871 "four-in-a-row.c"
			default:
			{
				GSettings* _tmp9_;
				NewGameScreen* _tmp10_;
				GSettings* _tmp11_;
#line 985 "../src/four-in-a-row.vala"
				_tmp9_ = self->priv->settings;
#line 985 "../src/four-in-a-row.vala"
				g_settings_set_int (_tmp9_, "num-players", 1);
#line 985 "../src/four-in-a-row.vala"
				_tmp10_ = self->priv->new_game_screen;
#line 985 "../src/four-in-a-row.vala"
				new_game_screen_update_sensitivity (_tmp10_, TRUE);
#line 986 "../src/four-in-a-row.vala"
				_tmp11_ = self->priv->settings;
#line 986 "../src/four-in-a-row.vala"
				g_settings_set_string (_tmp11_, "first-player", "computer");
#line 986 "../src/four-in-a-row.vala"
				_g_free0 (type);
#line 986 "../src/four-in-a-row.vala"
				return;
#line 3893 "four-in-a-row.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("two")))) {
#line 981 "../src/four-in-a-row.vala"
		switch (0) {
#line 3899 "four-in-a-row.c"
			default:
			{
				GSettings* _tmp12_;
				NewGameScreen* _tmp13_;
#line 987 "../src/four-in-a-row.vala"
				_tmp12_ = self->priv->settings;
#line 987 "../src/four-in-a-row.vala"
				g_settings_set_int (_tmp12_, "num-players", 2);
#line 987 "../src/four-in-a-row.vala"
				_tmp13_ = self->priv->new_game_screen;
#line 987 "../src/four-in-a-row.vala"
				new_game_screen_update_sensitivity (_tmp13_, FALSE);
#line 987 "../src/four-in-a-row.vala"
				_g_free0 (type);
#line 987 "../src/four-in-a-row.vala"
				return;
#line 3916 "four-in-a-row.c"
			}
		}
	} else {
#line 981 "../src/four-in-a-row.vala"
		switch (0) {
#line 3922 "four-in-a-row.c"
			default:
			{
#line 988 "../src/four-in-a-row.vala"
				g_assert_not_reached ();
#line 3927 "four-in-a-row.c"
			}
		}
	}
}

static void
four_in_arow_set_gameover (FourInARow* self,
                           gboolean new_value)
{
	GSimpleAction* _tmp0_;
#line 993 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 995 "../src/four-in-a-row.vala"
	self->priv->gameover = new_value;
#line 996 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->next_round_action;
#line 996 "../src/four-in-a-row.vala"
	g_simple_action_set_enabled (_tmp0_, new_value);
#line 3946 "four-in-a-row.c"
}

static inline void
four_in_arow_on_game_scores (FourInARow* self)
{
	Scorebox* _tmp0_;
#line 999 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1001 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->scorebox;
#line 1001 "../src/four-in-a-row.vala"
	gtk_window_present ((GtkWindow*) _tmp0_);
#line 1002 "../src/four-in-a-row.vala"
	return;
#line 3961 "four-in-a-row.c"
}

static inline void
four_in_arow_on_game_exit (FourInARow* self)
{
#line 1005 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1007 "../src/four-in-a-row.vala"
	four_in_arow_stop_anim (self);
#line 1008 "../src/four-in-a-row.vala"
	g_application_quit ((GApplication*) self);
#line 3973 "four-in-a-row.c"
}

static gboolean
_four_in_arow_on_window_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                          guint keyval,
                                                                          guint keycode,
                                                                          GdkModifierType state,
                                                                          gpointer self)
{
	gboolean result;
	result = four_in_arow_on_window_key_pressed ((FourInARow*) self, _sender, keyval, keycode, state);
#line 1023 "../src/four-in-a-row.vala"
	return result;
#line 3987 "four-in-a-row.c"
}

static gboolean
_four_in_arow_on_board_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self)
{
	gboolean result;
	result = four_in_arow_on_board_key_pressed ((FourInARow*) self, _sender, keyval, keycode, state);
#line 1026 "../src/four-in-a-row.vala"
	return result;
#line 4001 "four-in-a-row.c"
}

static inline void
four_in_arow_init_keyboard (FourInARow* self)
{
	GameWindow* _tmp0_;
	GtkEventControllerKey* _tmp1_;
	GtkEventControllerKey* _tmp2_;
	GtkEventControllerKey* _tmp3_;
	GameBoardView* _tmp4_;
	GtkEventControllerKey* _tmp5_;
	GtkEventControllerKey* _tmp6_;
#line 1019 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1021 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->window;
#line 1021 "../src/four-in-a-row.vala"
	_tmp1_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) _tmp0_);
#line 1021 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->window_key_controller);
#line 1021 "../src/four-in-a-row.vala"
	self->priv->window_key_controller = _tmp1_;
#line 1022 "../src/four-in-a-row.vala"
	_tmp2_ = self->priv->window_key_controller;
#line 1022 "../src/four-in-a-row.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp2_, GTK_PHASE_CAPTURE);
#line 1023 "../src/four-in-a-row.vala"
	_tmp3_ = self->priv->window_key_controller;
#line 1023 "../src/four-in-a-row.vala"
	g_signal_connect_object (_tmp3_, "key-pressed", (GCallback) _four_in_arow_on_window_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 1025 "../src/four-in-a-row.vala"
	_tmp4_ = self->priv->game_board_view;
#line 1025 "../src/four-in-a-row.vala"
	_tmp5_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) _tmp4_);
#line 1025 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->board_key_controller);
#line 1025 "../src/four-in-a-row.vala"
	self->priv->board_key_controller = _tmp5_;
#line 1026 "../src/four-in-a-row.vala"
	_tmp6_ = self->priv->board_key_controller;
#line 1026 "../src/four-in-a-row.vala"
	g_signal_connect_object (_tmp6_, "key-pressed", (GCallback) _four_in_arow_on_board_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 4044 "four-in-a-row.c"
}

static inline gboolean
four_in_arow_on_window_key_pressed (FourInARow* self,
                                    GtkEventControllerKey* _window_key_controller,
                                    guint keyval,
                                    guint keycode,
                                    GdkModifierType state)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* name = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp7_;
	gboolean result;
#line 1029 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1029 "../src/four-in-a-row.vala"
	g_return_val_if_fail (_window_key_controller != NULL, FALSE);
#line 1031 "../src/four-in-a-row.vala"
	_tmp1_ = gdk_keyval_name (keyval);
#line 1031 "../src/four-in-a-row.vala"
	_tmp0_ = _tmp1_;
#line 1031 "../src/four-in-a-row.vala"
	if (_tmp0_ == NULL) {
#line 1031 "../src/four-in-a-row.vala"
		_tmp0_ = "";
#line 4073 "four-in-a-row.c"
	}
#line 1031 "../src/four-in-a-row.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
#line 1031 "../src/four-in-a-row.vala"
	name = _tmp2_;
#line 1033 "../src/four-in-a-row.vala"
	_tmp3_ = name;
#line 1033 "../src/four-in-a-row.vala"
	if (g_strcmp0 (_tmp3_, "F1") == 0) {
#line 4083 "four-in-a-row.c"
		GameWindow* _tmp4_;
		HistoryButton* _tmp5_;
		HistoryButton* _tmp6_;
#line 1035 "../src/four-in-a-row.vala"
		_tmp4_ = self->priv->window;
#line 1035 "../src/four-in-a-row.vala"
		game_window_close_hamburger (_tmp4_);
#line 1036 "../src/four-in-a-row.vala"
		_tmp5_ = self->priv->history_button_1;
#line 1036 "../src/four-in-a-row.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp5_, FALSE);
#line 1037 "../src/four-in-a-row.vala"
		_tmp6_ = self->priv->history_button_2;
#line 1037 "../src/four-in-a-row.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp6_, FALSE);
#line 1038 "../src/four-in-a-row.vala"
		if ((state & GDK_CONTROL_MASK) != 0) {
#line 1039 "../src/four-in-a-row.vala"
			result = FALSE;
#line 1039 "../src/four-in-a-row.vala"
			_g_free0 (name);
#line 1039 "../src/four-in-a-row.vala"
			return result;
#line 4107 "four-in-a-row.c"
		}
#line 1040 "../src/four-in-a-row.vala"
		if ((state & GDK_SHIFT_MASK) != 0) {
#line 1042 "../src/four-in-a-row.vala"
			four_in_arow_on_help_about (self);
#line 1043 "../src/four-in-a-row.vala"
			result = TRUE;
#line 1043 "../src/four-in-a-row.vala"
			_g_free0 (name);
#line 1043 "../src/four-in-a-row.vala"
			return result;
#line 4119 "four-in-a-row.c"
		}
#line 1045 "../src/four-in-a-row.vala"
		four_in_arow_on_help_contents (self);
#line 1046 "../src/four-in-a-row.vala"
		result = TRUE;
#line 1046 "../src/four-in-a-row.vala"
		_g_free0 (name);
#line 1046 "../src/four-in-a-row.vala"
		return result;
#line 4129 "four-in-a-row.c"
	}
#line 1048 "../src/four-in-a-row.vala"
	_tmp7_ = name;
#line 1048 "../src/four-in-a-row.vala"
	if (g_strcmp0 (_tmp7_, "F10") == 0) {
#line 1050 "../src/four-in-a-row.vala"
		if ((state & GDK_CONTROL_MASK) != 0) {
#line 1052 "../src/four-in-a-row.vala"
			four_in_arow_toggle_game_menu (self);
#line 1053 "../src/four-in-a-row.vala"
			result = TRUE;
#line 1053 "../src/four-in-a-row.vala"
			_g_free0 (name);
#line 1053 "../src/four-in-a-row.vala"
			return result;
#line 4145 "four-in-a-row.c"
		}
#line 1055 "../src/four-in-a-row.vala"
		result = FALSE;
#line 1055 "../src/four-in-a-row.vala"
		_g_free0 (name);
#line 1055 "../src/four-in-a-row.vala"
		return result;
#line 4153 "four-in-a-row.c"
	}
#line 1057 "../src/four-in-a-row.vala"
	result = FALSE;
#line 1057 "../src/four-in-a-row.vala"
	_g_free0 (name);
#line 1057 "../src/four-in-a-row.vala"
	return result;
#line 4161 "four-in-a-row.c"
}

static void
_vala_GdkEvent_free (GdkEvent* self)
{
#line 1071 "../src/four-in-a-row.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 4169 "four-in-a-row.c"
}

static inline gboolean
four_in_arow_on_board_key_pressed (FourInARow* self,
                                   GtkEventControllerKey* _board_key_controller,
                                   guint keyval,
                                   guint keycode,
                                   GdkModifierType state)
{
	GdkEvent* event = NULL;
	GdkEvent* _tmp0_;
	gboolean is_modifier = FALSE;
	gboolean _tmp1_ = FALSE;
	GdkEvent* _tmp2_;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_;
	gchar* key = NULL;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	gboolean result;
#line 1060 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1060 "../src/four-in-a-row.vala"
	g_return_val_if_fail (_board_key_controller != NULL, FALSE);
#line 1062 "../src/four-in-a-row.vala"
	_tmp0_ = gtk_get_current_event ();
#line 1062 "../src/four-in-a-row.vala"
	event = _tmp0_;
#line 1064 "../src/four-in-a-row.vala"
	_tmp2_ = event;
#line 1064 "../src/four-in-a-row.vala"
	if (_tmp2_ != NULL) {
#line 4207 "four-in-a-row.c"
		GdkEvent* _tmp3_;
#line 1064 "../src/four-in-a-row.vala"
		_tmp3_ = event;
#line 1064 "../src/four-in-a-row.vala"
		_tmp1_ = ((GdkEvent*) _tmp3_)->type == GDK_KEY_PRESS;
#line 4213 "four-in-a-row.c"
	} else {
#line 1064 "../src/four-in-a-row.vala"
		_tmp1_ = FALSE;
#line 4217 "four-in-a-row.c"
	}
#line 1064 "../src/four-in-a-row.vala"
	if (_tmp1_) {
#line 4221 "four-in-a-row.c"
		GdkEvent* _tmp4_;
#line 1065 "../src/four-in-a-row.vala"
		_tmp4_ = event;
#line 1065 "../src/four-in-a-row.vala"
		is_modifier = ((GdkEventKey*) ((GdkEvent*) _tmp4_))->is_modifier == ((guint) 1);
#line 4227 "four-in-a-row.c"
	} else {
#line 1067 "../src/four-in-a-row.vala"
		is_modifier = FALSE;
#line 4231 "four-in-a-row.c"
	}
#line 1069 "../src/four-in-a-row.vala"
	_tmp6_ = gdk_keyval_name (keyval);
#line 1069 "../src/four-in-a-row.vala"
	_tmp5_ = _tmp6_;
#line 1069 "../src/four-in-a-row.vala"
	if (_tmp5_ == NULL) {
#line 1069 "../src/four-in-a-row.vala"
		_tmp5_ = "";
#line 4241 "four-in-a-row.c"
	}
#line 1069 "../src/four-in-a-row.vala"
	_tmp7_ = g_strdup ((const gchar*) _tmp5_);
#line 1069 "../src/four-in-a-row.vala"
	key = _tmp7_;
#line 1070 "../src/four-in-a-row.vala"
	_tmp10_ = key;
#line 1070 "../src/four-in-a-row.vala"
	if (g_strcmp0 (_tmp10_, "") == 0) {
#line 1070 "../src/four-in-a-row.vala"
		_tmp9_ = TRUE;
#line 4253 "four-in-a-row.c"
	} else {
		const gchar* _tmp11_;
#line 1070 "../src/four-in-a-row.vala"
		_tmp11_ = key;
#line 1070 "../src/four-in-a-row.vala"
		_tmp9_ = g_strcmp0 (_tmp11_, "Tab") == 0;
#line 4260 "four-in-a-row.c"
	}
#line 1070 "../src/four-in-a-row.vala"
	if (_tmp9_) {
#line 1070 "../src/four-in-a-row.vala"
		_tmp8_ = TRUE;
#line 4266 "four-in-a-row.c"
	} else {
#line 1070 "../src/four-in-a-row.vala"
		_tmp8_ = is_modifier;
#line 4270 "four-in-a-row.c"
	}
#line 1070 "../src/four-in-a-row.vala"
	if (_tmp8_) {
#line 1071 "../src/four-in-a-row.vala"
		result = FALSE;
#line 1071 "../src/four-in-a-row.vala"
		_g_free0 (key);
#line 1071 "../src/four-in-a-row.vala"
		__vala_GdkEvent_free0 (event);
#line 1071 "../src/four-in-a-row.vala"
		return result;
#line 4282 "four-in-a-row.c"
	}
#line 1073 "../src/four-in-a-row.vala"
	if (self->priv->timeout != ((guint) 0)) {
#line 1073 "../src/four-in-a-row.vala"
		_tmp12_ = TRUE;
#line 4288 "four-in-a-row.c"
	} else {
		gboolean _tmp13_ = FALSE;
#line 1074 "../src/four-in-a-row.vala"
		if (!self->priv->gameover) {
#line 1074 "../src/four-in-a-row.vala"
			_tmp13_ = !four_in_arow_is_player_human (self);
#line 4295 "four-in-a-row.c"
		} else {
#line 1074 "../src/four-in-a-row.vala"
			_tmp13_ = FALSE;
#line 4299 "four-in-a-row.c"
		}
#line 1074 "../src/four-in-a-row.vala"
		_tmp12_ = _tmp13_;
#line 4303 "four-in-a-row.c"
	}
#line 1073 "../src/four-in-a-row.vala"
	if (_tmp12_) {
#line 1075 "../src/four-in-a-row.vala"
		result = TRUE;
#line 1075 "../src/four-in-a-row.vala"
		_g_free0 (key);
#line 1075 "../src/four-in-a-row.vala"
		__vala_GdkEvent_free0 (event);
#line 1075 "../src/four-in-a-row.vala"
		return result;
#line 4315 "four-in-a-row.c"
	}
#line 1077 "../src/four-in-a-row.vala"
	if (self->priv->gameover) {
#line 1079 "../src/four-in-a-row.vala"
		four_in_arow_blink_winner (self, (guint8) 2);
#line 1080 "../src/four-in-a-row.vala"
		result = TRUE;
#line 1080 "../src/four-in-a-row.vala"
		_g_free0 (key);
#line 1080 "../src/four-in-a-row.vala"
		__vala_GdkEvent_free0 (event);
#line 1080 "../src/four-in-a-row.vala"
		return result;
#line 4329 "four-in-a-row.c"
	}
#line 1083 "../src/four-in-a-row.vala"
	_tmp15_ = key;
#line 1083 "../src/four-in-a-row.vala"
	if (g_strcmp0 (_tmp15_, "Left") == 0) {
#line 1083 "../src/four-in-a-row.vala"
		_tmp14_ = TRUE;
#line 4337 "four-in-a-row.c"
	} else {
		gint _tmp16_;
#line 1083 "../src/four-in-a-row.vala"
		_tmp16_ = self->priv->_keypress_left;
#line 1083 "../src/four-in-a-row.vala"
		_tmp14_ = keyval == ((guint) _tmp16_);
#line 4344 "four-in-a-row.c"
	}
#line 1083 "../src/four-in-a-row.vala"
	if (_tmp14_) {
#line 4348 "four-in-a-row.c"
		guint8 _tmp17_;
#line 1085 "../src/four-in-a-row.vala"
		if (((gint) self->priv->column) == 0) {
#line 1086 "../src/four-in-a-row.vala"
			result = TRUE;
#line 1086 "../src/four-in-a-row.vala"
			_g_free0 (key);
#line 1086 "../src/four-in-a-row.vala"
			__vala_GdkEvent_free0 (event);
#line 1086 "../src/four-in-a-row.vala"
			return result;
#line 4360 "four-in-a-row.c"
		}
#line 1087 "../src/four-in-a-row.vala"
		_tmp17_ = self->priv->column_moveto;
#line 1087 "../src/four-in-a-row.vala"
		self->priv->column_moveto = _tmp17_ - 1;
#line 1088 "../src/four-in-a-row.vala"
		four_in_arow_move_cursor (self, self->priv->column_moveto);
#line 4368 "four-in-a-row.c"
	} else {
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_;
#line 1090 "../src/four-in-a-row.vala"
		_tmp19_ = key;
#line 1090 "../src/four-in-a-row.vala"
		if (g_strcmp0 (_tmp19_, "Right") == 0) {
#line 1090 "../src/four-in-a-row.vala"
			_tmp18_ = TRUE;
#line 4378 "four-in-a-row.c"
		} else {
			gint _tmp20_;
#line 1090 "../src/four-in-a-row.vala"
			_tmp20_ = self->priv->_keypress_right;
#line 1090 "../src/four-in-a-row.vala"
			_tmp18_ = keyval == ((guint) _tmp20_);
#line 4385 "four-in-a-row.c"
		}
#line 1090 "../src/four-in-a-row.vala"
		if (_tmp18_) {
#line 4389 "four-in-a-row.c"
			guint8 _tmp21_;
#line 1092 "../src/four-in-a-row.vala"
			if (((gint) self->priv->column) >= (four_in_arow_size - 1)) {
#line 1093 "../src/four-in-a-row.vala"
				result = TRUE;
#line 1093 "../src/four-in-a-row.vala"
				_g_free0 (key);
#line 1093 "../src/four-in-a-row.vala"
				__vala_GdkEvent_free0 (event);
#line 1093 "../src/four-in-a-row.vala"
				return result;
#line 4401 "four-in-a-row.c"
			}
#line 1094 "../src/four-in-a-row.vala"
			_tmp21_ = self->priv->column_moveto;
#line 1094 "../src/four-in-a-row.vala"
			self->priv->column_moveto = _tmp21_ + 1;
#line 1095 "../src/four-in-a-row.vala"
			four_in_arow_move_cursor (self, self->priv->column_moveto);
#line 4409 "four-in-a-row.c"
		} else {
			gboolean _tmp22_ = FALSE;
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
			const gchar* _tmp26_;
#line 1097 "../src/four-in-a-row.vala"
			_tmp26_ = key;
#line 1097 "../src/four-in-a-row.vala"
			if (g_strcmp0 (_tmp26_, "space") == 0) {
#line 1097 "../src/four-in-a-row.vala"
				_tmp25_ = TRUE;
#line 4422 "four-in-a-row.c"
			} else {
				const gchar* _tmp27_;
#line 1097 "../src/four-in-a-row.vala"
				_tmp27_ = key;
#line 1097 "../src/four-in-a-row.vala"
				_tmp25_ = g_strcmp0 (_tmp27_, "Return") == 0;
#line 4429 "four-in-a-row.c"
			}
#line 1097 "../src/four-in-a-row.vala"
			if (_tmp25_) {
#line 1097 "../src/four-in-a-row.vala"
				_tmp24_ = TRUE;
#line 4435 "four-in-a-row.c"
			} else {
				const gchar* _tmp28_;
#line 1097 "../src/four-in-a-row.vala"
				_tmp28_ = key;
#line 1097 "../src/four-in-a-row.vala"
				_tmp24_ = g_strcmp0 (_tmp28_, "KP_Enter") == 0;
#line 4442 "four-in-a-row.c"
			}
#line 1097 "../src/four-in-a-row.vala"
			if (_tmp24_) {
#line 1097 "../src/four-in-a-row.vala"
				_tmp23_ = TRUE;
#line 4448 "four-in-a-row.c"
			} else {
				const gchar* _tmp29_;
#line 1097 "../src/four-in-a-row.vala"
				_tmp29_ = key;
#line 1097 "../src/four-in-a-row.vala"
				_tmp23_ = g_strcmp0 (_tmp29_, "Down") == 0;
#line 4455 "four-in-a-row.c"
			}
#line 1097 "../src/four-in-a-row.vala"
			if (_tmp23_) {
#line 1097 "../src/four-in-a-row.vala"
				_tmp22_ = TRUE;
#line 4461 "four-in-a-row.c"
			} else {
				gint _tmp30_;
#line 1097 "../src/four-in-a-row.vala"
				_tmp30_ = self->priv->_keypress_drop;
#line 1097 "../src/four-in-a-row.vala"
				_tmp22_ = keyval == ((guint) _tmp30_);
#line 4468 "four-in-a-row.c"
			}
#line 1097 "../src/four-in-a-row.vala"
			if (_tmp22_) {
#line 1098 "../src/four-in-a-row.vala"
				four_in_arow_process_move (self, self->priv->column);
#line 4474 "four-in-a-row.c"
			} else {
				gboolean _tmp31_ = FALSE;
				gboolean _tmp32_ = FALSE;
				gboolean _tmp33_ = FALSE;
				gboolean _tmp34_ = FALSE;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				const gchar* _tmp37_;
#line 1099 "../src/four-in-a-row.vala"
				_tmp37_ = key;
#line 1099 "../src/four-in-a-row.vala"
				if (g_strcmp0 (_tmp37_, "1") == 0) {
#line 1099 "../src/four-in-a-row.vala"
					_tmp36_ = TRUE;
#line 4489 "four-in-a-row.c"
				} else {
					const gchar* _tmp38_;
#line 1099 "../src/four-in-a-row.vala"
					_tmp38_ = key;
#line 1099 "../src/four-in-a-row.vala"
					_tmp36_ = g_strcmp0 (_tmp38_, "2") == 0;
#line 4496 "four-in-a-row.c"
				}
#line 1099 "../src/four-in-a-row.vala"
				if (_tmp36_) {
#line 1099 "../src/four-in-a-row.vala"
					_tmp35_ = TRUE;
#line 4502 "four-in-a-row.c"
				} else {
					const gchar* _tmp39_;
#line 1099 "../src/four-in-a-row.vala"
					_tmp39_ = key;
#line 1099 "../src/four-in-a-row.vala"
					_tmp35_ = g_strcmp0 (_tmp39_, "3") == 0;
#line 4509 "four-in-a-row.c"
				}
#line 1099 "../src/four-in-a-row.vala"
				if (_tmp35_) {
#line 1099 "../src/four-in-a-row.vala"
					_tmp34_ = TRUE;
#line 4515 "four-in-a-row.c"
				} else {
					const gchar* _tmp40_;
#line 1099 "../src/four-in-a-row.vala"
					_tmp40_ = key;
#line 1099 "../src/four-in-a-row.vala"
					_tmp34_ = g_strcmp0 (_tmp40_, "4") == 0;
#line 4522 "four-in-a-row.c"
				}
#line 1099 "../src/four-in-a-row.vala"
				if (_tmp34_) {
#line 1099 "../src/four-in-a-row.vala"
					_tmp33_ = TRUE;
#line 4528 "four-in-a-row.c"
				} else {
					const gchar* _tmp41_;
#line 1099 "../src/four-in-a-row.vala"
					_tmp41_ = key;
#line 1099 "../src/four-in-a-row.vala"
					_tmp33_ = g_strcmp0 (_tmp41_, "5") == 0;
#line 4535 "four-in-a-row.c"
				}
#line 1099 "../src/four-in-a-row.vala"
				if (_tmp33_) {
#line 1099 "../src/four-in-a-row.vala"
					_tmp32_ = TRUE;
#line 4541 "four-in-a-row.c"
				} else {
					const gchar* _tmp42_;
#line 1099 "../src/four-in-a-row.vala"
					_tmp42_ = key;
#line 1099 "../src/four-in-a-row.vala"
					_tmp32_ = g_strcmp0 (_tmp42_, "6") == 0;
#line 4548 "four-in-a-row.c"
				}
#line 1099 "../src/four-in-a-row.vala"
				if (_tmp32_) {
#line 1099 "../src/four-in-a-row.vala"
					_tmp31_ = TRUE;
#line 4554 "four-in-a-row.c"
				} else {
					const gchar* _tmp43_;
#line 1099 "../src/four-in-a-row.vala"
					_tmp43_ = key;
#line 1099 "../src/four-in-a-row.vala"
					_tmp31_ = g_strcmp0 (_tmp43_, "7") == 0;
#line 4561 "four-in-a-row.c"
				}
#line 1099 "../src/four-in-a-row.vala"
				if (_tmp31_) {
#line 4565 "four-in-a-row.c"
					const gchar* _tmp44_;
#line 1100 "../src/four-in-a-row.vala"
					_tmp44_ = key;
#line 1100 "../src/four-in-a-row.vala"
					four_in_arow_process_move (self, (guint8) (((guint8) atoi (_tmp44_)) - 1));
#line 4571 "four-in-a-row.c"
				}
			}
		}
	}
#line 1102 "../src/four-in-a-row.vala"
	result = TRUE;
#line 1102 "../src/four-in-a-row.vala"
	_g_free0 (key);
#line 1102 "../src/four-in-a-row.vala"
	__vala_GdkEvent_free0 (event);
#line 1102 "../src/four-in-a-row.vala"
	return result;
#line 4584 "four-in-a-row.c"
}

static inline gboolean
four_in_arow_column_clicked_cb (FourInARow* self,
                                guint8 column)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 1105 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1107 "../src/four-in-a-row.vala"
	if (self->priv->gameover) {
#line 1107 "../src/four-in-a-row.vala"
		_tmp0_ = self->priv->timeout == ((guint) 0);
#line 4599 "four-in-a-row.c"
	} else {
#line 1107 "../src/four-in-a-row.vala"
		_tmp0_ = FALSE;
#line 4603 "four-in-a-row.c"
	}
#line 1107 "../src/four-in-a-row.vala"
	if (_tmp0_) {
#line 1108 "../src/four-in-a-row.vala"
		four_in_arow_blink_winner (self, (guint8) 2);
#line 4609 "four-in-a-row.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 1109 "../src/four-in-a-row.vala"
		if (four_in_arow_is_player_human (self)) {
#line 1109 "../src/four-in-a-row.vala"
			_tmp1_ = self->priv->timeout == ((guint) 0);
#line 4616 "four-in-a-row.c"
		} else {
#line 1109 "../src/four-in-a-row.vala"
			_tmp1_ = FALSE;
#line 4620 "four-in-a-row.c"
		}
#line 1109 "../src/four-in-a-row.vala"
		if (_tmp1_) {
#line 1110 "../src/four-in-a-row.vala"
			four_in_arow_process_move (self, column);
#line 4626 "four-in-a-row.c"
		}
	}
#line 1111 "../src/four-in-a-row.vala"
	result = TRUE;
#line 1111 "../src/four-in-a-row.vala"
	return result;
#line 4633 "four-in-a-row.c"
}

static inline void
four_in_arow_on_help_about (FourInARow* self)
{
	gchar** authors = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gint authors_length1;
	gint _authors_size_;
	gchar** artists = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gint artists_length1;
	gint _artists_size_;
	gchar** documenters = NULL;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gint documenters_length1;
	gint _documenters_size_;
	gchar* copyright = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GameWindow* _tmp26_;
#line 1118 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1120 "../src/four-in-a-row.vala"
	_tmp0_ = g_strconcat (_ ("Tim Musson"), " <trmusson@ihug.co.nz>", NULL);
#line 1120 "../src/four-in-a-row.vala"
	_tmp1_ = g_strconcat (_ ("David Neary"), " <bolsh@gimp.org>", NULL);
#line 1120 "../src/four-in-a-row.vala"
	_tmp2_ = g_strconcat (_ ("Nikhar Agrawal"), " <nikharagrawal2006@gmail.com>", NULL);
#line 1120 "../src/four-in-a-row.vala"
	_tmp3_ = g_strconcat (_ ("Jacob Humphrey"), " <jacob.ryan.humphrey@gmail.com>", NULL);
#line 1120 "../src/four-in-a-row.vala"
	_tmp4_ = g_strconcat (_ ("Arnaud Bonatti"), " <arnaud.bonatti@gmail.com>", NULL);
#line 1120 "../src/four-in-a-row.vala"
	_tmp5_ = g_new0 (gchar*, 5 + 1);
#line 1120 "../src/four-in-a-row.vala"
	_tmp5_[0] = _tmp0_;
#line 1120 "../src/four-in-a-row.vala"
	_tmp5_[1] = _tmp1_;
#line 1120 "../src/four-in-a-row.vala"
	_tmp5_[2] = _tmp2_;
#line 1120 "../src/four-in-a-row.vala"
	_tmp5_[3] = _tmp3_;
#line 1120 "../src/four-in-a-row.vala"
	_tmp5_[4] = _tmp4_;
#line 1120 "../src/four-in-a-row.vala"
	authors = _tmp5_;
#line 1120 "../src/four-in-a-row.vala"
	authors_length1 = 5;
#line 1120 "../src/four-in-a-row.vala"
	_authors_size_ = authors_length1;
#line 1141 "../src/four-in-a-row.vala"
	_tmp6_ = g_strdup (_ ("Alan Horkan"));
#line 1141 "../src/four-in-a-row.vala"
	_tmp7_ = g_strdup (_ ("Anatol Drlicek"));
#line 1141 "../src/four-in-a-row.vala"
	_tmp8_ = g_strdup (_ ("Based on the Faenza icon theme by Matthieu James"));
#line 1141 "../src/four-in-a-row.vala"
	_tmp9_ = g_new0 (gchar*, 3 + 1);
#line 1141 "../src/four-in-a-row.vala"
	_tmp9_[0] = _tmp6_;
#line 1141 "../src/four-in-a-row.vala"
	_tmp9_[1] = _tmp7_;
#line 1141 "../src/four-in-a-row.vala"
	_tmp9_[2] = _tmp8_;
#line 1141 "../src/four-in-a-row.vala"
	artists = _tmp9_;
#line 1141 "../src/four-in-a-row.vala"
	artists_length1 = 3;
#line 1141 "../src/four-in-a-row.vala"
	_artists_size_ = artists_length1;
#line 1155 "../src/four-in-a-row.vala"
	_tmp10_ = g_strdup (_ ("Timothy Musson"));
#line 1155 "../src/four-in-a-row.vala"
	_tmp11_ = g_new0 (gchar*, 1 + 1);
#line 1155 "../src/four-in-a-row.vala"
	_tmp11_[0] = _tmp10_;
#line 1155 "../src/four-in-a-row.vala"
	documenters = _tmp11_;
#line 1155 "../src/four-in-a-row.vala"
	documenters_length1 = 1;
#line 1155 "../src/four-in-a-row.vala"
	_documenters_size_ = documenters_length1;
#line 1159 "../src/four-in-a-row.vala"
	_tmp12_ = g_strconcat (_ ("Copyright \xc2\xa9 1999-2008 – Tim Musson and David Neary"), "\n", NULL);
#line 1159 "../src/four-in-a-row.vala"
	_tmp13_ = _tmp12_;
#line 1159 "../src/four-in-a-row.vala"
	_tmp14_ = g_strconcat (_tmp13_, _ ("Copyright \xc2\xa9 2014 – Michael Catanzaro"), NULL);
#line 1159 "../src/four-in-a-row.vala"
	_tmp15_ = _tmp14_;
#line 1159 "../src/four-in-a-row.vala"
	_tmp16_ = g_strconcat (_tmp15_, "\n", NULL);
#line 1159 "../src/four-in-a-row.vala"
	_tmp17_ = _tmp16_;
#line 1159 "../src/four-in-a-row.vala"
	_tmp18_ = g_strconcat (_tmp17_, _ ("Copyright \xc2\xa9 2018 – Jacob Humphrey"), NULL);
#line 1159 "../src/four-in-a-row.vala"
	_tmp19_ = _tmp18_;
#line 1159 "../src/four-in-a-row.vala"
	_tmp20_ = g_strconcat (_tmp19_, "\n", NULL);
#line 1159 "../src/four-in-a-row.vala"
	_tmp21_ = _tmp20_;
#line 1159 "../src/four-in-a-row.vala"
	_tmp22_ = g_strdup_printf (_ ("Copyright \xc2\xa9 %u-%u – Arnaud Bonatti"), (guint) 2019, (guint) 2020);
#line 1159 "../src/four-in-a-row.vala"
	_tmp23_ = _tmp22_;
#line 1159 "../src/four-in-a-row.vala"
	_tmp24_ = g_strconcat (_tmp21_, _tmp23_, NULL);
#line 1159 "../src/four-in-a-row.vala"
	_tmp25_ = _tmp24_;
#line 1159 "../src/four-in-a-row.vala"
	_g_free0 (_tmp23_);
#line 1159 "../src/four-in-a-row.vala"
	_g_free0 (_tmp21_);
#line 1159 "../src/four-in-a-row.vala"
	_g_free0 (_tmp19_);
#line 1159 "../src/four-in-a-row.vala"
	_g_free0 (_tmp17_);
#line 1159 "../src/four-in-a-row.vala"
	_g_free0 (_tmp15_);
#line 1159 "../src/four-in-a-row.vala"
	_g_free0 (_tmp13_);
#line 1159 "../src/four-in-a-row.vala"
	copyright = _tmp25_;
#line 1173 "../src/four-in-a-row.vala"
	_tmp26_ = self->priv->window;
#line 1173 "../src/four-in-a-row.vala"
	gtk_show_about_dialog ((GtkWindow*) _tmp26_, "name", FOUR_IN_AROW_PROGRAM_NAME, "version", VERSION, "copyright", copyright, "license-type", GTK_LICENSE_GPL_3_0, "comments", _ ("Connect four in a row to win"), "authors", authors, "documenters", documenters, "artists", artists, "translator-credits", _ ("translator-credits"), "logo-icon-name", "org.gnome.Four-in-a-row", "website", "https://wiki.gnome.org/Apps/Four-in-a-row", NULL);
#line 1118 "../src/four-in-a-row.vala"
	_g_free0 (copyright);
#line 1118 "../src/four-in-a-row.vala"
	documenters = (_vala_array_free (documenters, documenters_length1, (GDestroyNotify) g_free), NULL);
#line 1118 "../src/four-in-a-row.vala"
	artists = (_vala_array_free (artists, artists_length1, (GDestroyNotify) g_free), NULL);
#line 1118 "../src/four-in-a-row.vala"
	authors = (_vala_array_free (authors, authors_length1, (GDestroyNotify) g_free), NULL);
#line 4792 "four-in-a-row.c"
}

static inline void
four_in_arow_on_help_contents (FourInARow* self)
{
	GError* _inner_error0_ = NULL;
#line 1189 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 4801 "four-in-a-row.c"
	{
		GameWindow* _tmp0_;
#line 1193 "../src/four-in-a-row.vala"
		_tmp0_ = self->priv->window;
#line 1193 "../src/four-in-a-row.vala"
		gtk_show_uri_on_window ((GtkWindow*) _tmp0_, "help:four-in-a-row", gtk_get_current_event_time (), &_inner_error0_);
#line 1193 "../src/four-in-a-row.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4810 "four-in-a-row.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 1191 "../src/four-in-a-row.vala"
		_error_ = _inner_error0_;
#line 1191 "../src/four-in-a-row.vala"
		_inner_error0_ = NULL;
#line 1197 "../src/four-in-a-row.vala"
		_tmp1_ = _error_;
#line 1197 "../src/four-in-a-row.vala"
		_tmp2_ = _tmp1_->message;
#line 1197 "../src/four-in-a-row.vala"
		g_warning ("four-in-a-row.vala:1197: Failed to show help: %s", _tmp2_);
#line 1191 "../src/four-in-a-row.vala"
		_g_error_free0 (_error_);
#line 4832 "four-in-a-row.c"
	}
	__finally0:
#line 1191 "../src/four-in-a-row.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1191 "../src/four-in-a-row.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1191 "../src/four-in-a-row.vala"
		g_clear_error (&_inner_error0_);
#line 1191 "../src/four-in-a-row.vala"
		return;
#line 4843 "four-in-a-row.c"
	}
}

static inline void
four_in_arow_init_sound (FourInARow* self)
{
	GError* _inner_error0_ = NULL;
#line 1223 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 4853 "four-in-a-row.c"
	{
		GSoundContext* _tmp0_ = NULL;
		GSoundContext* _tmp1_;
		GSoundContext* _tmp2_;
#line 1227 "../src/four-in-a-row.vala"
		_tmp1_ = gsound_context_new (NULL, &_inner_error0_);
#line 1227 "../src/four-in-a-row.vala"
		_tmp0_ = _tmp1_;
#line 1227 "../src/four-in-a-row.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4864 "four-in-a-row.c"
			goto __catch0_g_error;
		}
#line 1227 "../src/four-in-a-row.vala"
		_tmp2_ = _tmp0_;
#line 1227 "../src/four-in-a-row.vala"
		_tmp0_ = NULL;
#line 1227 "../src/four-in-a-row.vala"
		_g_object_unref0 (self->priv->sound_context);
#line 1227 "../src/four-in-a-row.vala"
		self->priv->sound_context = _tmp2_;
#line 1228 "../src/four-in-a-row.vala"
		self->priv->sound_context_state = FOUR_IN_AROW_SOUND_CONTEXT_STATE_WORKING;
#line 1225 "../src/four-in-a-row.vala"
		_g_object_unref0 (_tmp0_);
#line 4879 "four-in-a-row.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 1225 "../src/four-in-a-row.vala"
		e = _inner_error0_;
#line 1225 "../src/four-in-a-row.vala"
		_inner_error0_ = NULL;
#line 1232 "../src/four-in-a-row.vala"
		_tmp3_ = e;
#line 1232 "../src/four-in-a-row.vala"
		_tmp4_ = _tmp3_->message;
#line 1232 "../src/four-in-a-row.vala"
		g_warning ("four-in-a-row.vala:1232: %s", _tmp4_);
#line 1233 "../src/four-in-a-row.vala"
		self->priv->sound_context_state = FOUR_IN_AROW_SOUND_CONTEXT_STATE_ERRORED;
#line 1225 "../src/four-in-a-row.vala"
		_g_error_free0 (e);
#line 4901 "four-in-a-row.c"
	}
	__finally0:
#line 1225 "../src/four-in-a-row.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1225 "../src/four-in-a-row.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1225 "../src/four-in-a-row.vala"
		g_clear_error (&_inner_error0_);
#line 1225 "../src/four-in-a-row.vala"
		return;
#line 4912 "four-in-a-row.c"
	}
}

static void
four_in_arow_play_sound (FourInARow* self,
                         FourInARowSoundID id)
{
	gboolean _tmp0_;
#line 1237 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1239 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->_sound_on;
#line 1239 "../src/four-in-a-row.vala"
	if (_tmp0_) {
#line 1241 "../src/four-in-a-row.vala"
		if (self->priv->sound_context_state == FOUR_IN_AROW_SOUND_CONTEXT_STATE_INITIAL) {
#line 1242 "../src/four-in-a-row.vala"
			four_in_arow_init_sound (self);
#line 4931 "four-in-a-row.c"
		}
#line 1243 "../src/four-in-a-row.vala"
		if (self->priv->sound_context_state == FOUR_IN_AROW_SOUND_CONTEXT_STATE_WORKING) {
#line 4935 "four-in-a-row.c"
			GSoundContext* _tmp1_;
#line 1244 "../src/four-in-a-row.vala"
			_tmp1_ = self->priv->sound_context;
#line 1244 "../src/four-in-a-row.vala"
			four_in_arow_do_play_sound (id, _tmp1_);
#line 4941 "four-in-a-row.c"
		}
	}
}

static void
four_in_arow_do_play_sound (FourInARowSoundID id,
                            GSoundContext* sound_context)
{
	gchar* name = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* path = NULL;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 1248 "../src/four-in-a-row.vala"
	g_return_if_fail (sound_context != NULL);
#line 1252 "../src/four-in-a-row.vala"
	switch (id) {
#line 1252 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_SOUND_ID_DROP:
#line 4963 "four-in-a-row.c"
		{
			gchar* _tmp0_;
#line 1254 "../src/four-in-a-row.vala"
			_tmp0_ = g_strdup ("slide");
#line 1254 "../src/four-in-a-row.vala"
			_g_free0 (name);
#line 1254 "../src/four-in-a-row.vala"
			name = _tmp0_;
#line 1254 "../src/four-in-a-row.vala"
			break;
#line 4974 "four-in-a-row.c"
		}
#line 1252 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_SOUND_ID_I_WIN:
#line 4978 "four-in-a-row.c"
		{
			gchar* _tmp1_;
#line 1255 "../src/four-in-a-row.vala"
			_tmp1_ = g_strdup ("reverse");
#line 1255 "../src/four-in-a-row.vala"
			_g_free0 (name);
#line 1255 "../src/four-in-a-row.vala"
			name = _tmp1_;
#line 1255 "../src/four-in-a-row.vala"
			break;
#line 4989 "four-in-a-row.c"
		}
#line 1252 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_SOUND_ID_YOU_WIN:
#line 4993 "four-in-a-row.c"
		{
			gchar* _tmp2_;
#line 1256 "../src/four-in-a-row.vala"
			_tmp2_ = g_strdup ("bonus");
#line 1256 "../src/four-in-a-row.vala"
			_g_free0 (name);
#line 1256 "../src/four-in-a-row.vala"
			name = _tmp2_;
#line 1256 "../src/four-in-a-row.vala"
			break;
#line 5004 "four-in-a-row.c"
		}
#line 1252 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_SOUND_ID_PLAYER_WIN:
#line 5008 "four-in-a-row.c"
		{
			gchar* _tmp3_;
#line 1257 "../src/four-in-a-row.vala"
			_tmp3_ = g_strdup ("bonus");
#line 1257 "../src/four-in-a-row.vala"
			_g_free0 (name);
#line 1257 "../src/four-in-a-row.vala"
			name = _tmp3_;
#line 1257 "../src/four-in-a-row.vala"
			break;
#line 5019 "four-in-a-row.c"
		}
#line 1252 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_SOUND_ID_DRAWN_GAME:
#line 5023 "four-in-a-row.c"
		{
			gchar* _tmp4_;
#line 1258 "../src/four-in-a-row.vala"
			_tmp4_ = g_strdup ("reverse");
#line 1258 "../src/four-in-a-row.vala"
			_g_free0 (name);
#line 1258 "../src/four-in-a-row.vala"
			name = _tmp4_;
#line 1258 "../src/four-in-a-row.vala"
			break;
#line 5034 "four-in-a-row.c"
		}
#line 1252 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_SOUND_ID_COLUMN_FULL:
#line 5038 "four-in-a-row.c"
		{
			gchar* _tmp5_;
#line 1259 "../src/four-in-a-row.vala"
			_tmp5_ = g_strdup ("bad");
#line 1259 "../src/four-in-a-row.vala"
			_g_free0 (name);
#line 1259 "../src/four-in-a-row.vala"
			name = _tmp5_;
#line 1259 "../src/four-in-a-row.vala"
			break;
#line 5049 "four-in-a-row.c"
		}
		default:
		{
#line 1260 "../src/four-in-a-row.vala"
			g_assert_not_reached ();
#line 5055 "four-in-a-row.c"
		}
	}
#line 1263 "../src/four-in-a-row.vala"
	_tmp6_ = name;
#line 1263 "../src/four-in-a-row.vala"
	_tmp7_ = g_strconcat (_tmp6_, ".ogg", NULL);
#line 1263 "../src/four-in-a-row.vala"
	_g_free0 (name);
#line 1263 "../src/four-in-a-row.vala"
	name = _tmp7_;
#line 1264 "../src/four-in-a-row.vala"
	_tmp8_ = name;
#line 1264 "../src/four-in-a-row.vala"
	_tmp9_ = g_build_filename (SOUND_DIRECTORY, _tmp8_, NULL);
#line 1264 "../src/four-in-a-row.vala"
	path = _tmp9_;
#line 5072 "four-in-a-row.c"
	{
		const gchar* _tmp10_;
#line 1267 "../src/four-in-a-row.vala"
		_tmp10_ = name;
#line 1267 "../src/four-in-a-row.vala"
		gsound_context_play_simple (sound_context, NULL, &_inner_error0_, GSOUND_ATTR_MEDIA_NAME, _tmp10_, GSOUND_ATTR_MEDIA_FILENAME, path, NULL);
#line 1267 "../src/four-in-a-row.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5081 "four-in-a-row.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 1266 "../src/four-in-a-row.vala"
		e = _inner_error0_;
#line 1266 "../src/four-in-a-row.vala"
		_inner_error0_ = NULL;
#line 1270 "../src/four-in-a-row.vala"
		_tmp11_ = e;
#line 1270 "../src/four-in-a-row.vala"
		_tmp12_ = _tmp11_->message;
#line 1270 "../src/four-in-a-row.vala"
		g_warning ("four-in-a-row.vala:1270: %s", _tmp12_);
#line 1266 "../src/four-in-a-row.vala"
		_g_error_free0 (e);
#line 5103 "four-in-a-row.c"
	}
	__finally0:
#line 1266 "../src/four-in-a-row.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1266 "../src/four-in-a-row.vala"
		_g_free0 (path);
#line 1266 "../src/four-in-a-row.vala"
		_g_free0 (name);
#line 1266 "../src/four-in-a-row.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1266 "../src/four-in-a-row.vala"
		g_clear_error (&_inner_error0_);
#line 1266 "../src/four-in-a-row.vala"
		return;
#line 5118 "four-in-a-row.c"
	}
#line 1248 "../src/four-in-a-row.vala"
	_g_free0 (path);
#line 1248 "../src/four-in-a-row.vala"
	_g_free0 (name);
#line 5124 "four-in-a-row.c"
}

static inline void
four_in_arow_generate_game_menu (FourInARow* self)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
	GMenu* _tmp1_;
	GMenu* _tmp2_;
	GMenu* _tmp3_;
#line 1281 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1283 "../src/four-in-a-row.vala"
	_tmp0_ = g_menu_new ();
#line 1283 "../src/four-in-a-row.vala"
	section = _tmp0_;
#line 1285 "../src/four-in-a-row.vala"
	g_menu_append (section, _ ("_Undo last move"), "ui.undo");
#line 1289 "../src/four-in-a-row.vala"
	g_menu_append (section, _ ("_Hint"), "ui.hint");
#line 1290 "../src/four-in-a-row.vala"
	g_menu_freeze (section);
#line 1291 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->game_menu;
#line 1291 "../src/four-in-a-row.vala"
	g_menu_append_section (_tmp1_, NULL, (GMenuModel*) section);
#line 1293 "../src/four-in-a-row.vala"
	four_in_arow_update_round_section (self, TRUE);
#line 1294 "../src/four-in-a-row.vala"
	_tmp2_ = self->priv->game_menu;
#line 1294 "../src/four-in-a-row.vala"
	_tmp3_ = self->priv->round_section;
#line 1294 "../src/four-in-a-row.vala"
	g_menu_append_section (_tmp2_, NULL, (GMenuModel*) _tmp3_);
#line 1281 "../src/four-in-a-row.vala"
	_g_object_unref0 (section);
#line 5161 "four-in-a-row.c"
}

static void
four_in_arow_update_round_section (FourInARow* self,
                                   gboolean menu_init)
{
	GMenu* _tmp0_;
	gboolean _tmp3_ = FALSE;
	GMenu* _tmp5_;
#line 1297 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1299 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->round_section;
#line 1299 "../src/four-in-a-row.vala"
	g_menu_remove_all (_tmp0_);
#line 1300 "../src/four-in-a-row.vala"
	if (self->priv->gameover) {
#line 5179 "four-in-a-row.c"
		GMenu* _tmp1_;
#line 1301 "../src/four-in-a-row.vala"
		_tmp1_ = self->priv->round_section;
#line 1301 "../src/four-in-a-row.vala"
		g_menu_append (_tmp1_, _ ("Next _Round"), "app.next-round");
#line 5185 "four-in-a-row.c"
	} else {
		GMenu* _tmp2_;
#line 1303 "../src/four-in-a-row.vala"
		_tmp2_ = self->priv->round_section;
#line 1303 "../src/four-in-a-row.vala"
		g_menu_append (_tmp2_, _ ("_Give Up"), "app.give-up");
#line 5192 "four-in-a-row.c"
	}
#line 1305 "../src/four-in-a-row.vala"
	if (menu_init) {
#line 1305 "../src/four-in-a-row.vala"
		_tmp3_ = TRUE;
#line 5198 "four-in-a-row.c"
	} else {
		Scorebox* _tmp4_;
#line 1305 "../src/four-in-a-row.vala"
		_tmp4_ = self->priv->scorebox;
#line 1305 "../src/four-in-a-row.vala"
		_tmp3_ = scorebox_is_first_game (_tmp4_);
#line 5205 "four-in-a-row.c"
	}
#line 1305 "../src/four-in-a-row.vala"
	if (_tmp3_) {
#line 1306 "../src/four-in-a-row.vala"
		return;
#line 5211 "four-in-a-row.c"
	}
#line 1308 "../src/four-in-a-row.vala"
	_tmp5_ = self->priv->round_section;
#line 1308 "../src/four-in-a-row.vala"
	g_menu_append (_tmp5_, _ ("_Scores"), "app.scores");
#line 5217 "four-in-a-row.c"
}

static inline void
four_in_arow_on_give_up (FourInARow* self)
{
	Scorebox* _tmp0_;
#line 1311 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1313 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->scorebox;
#line 1313 "../src/four-in-a-row.vala"
	scorebox_give_up (_tmp0_, self->priv->player);
#line 1314 "../src/four-in-a-row.vala"
	four_in_arow_game_reset (self, FALSE);
#line 5232 "four-in-a-row.c"
}

static inline void
four_in_arow_on_next_round (FourInARow* self)
{
#line 1317 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1319 "../src/four-in-a-row.vala"
	four_in_arow_game_reset (self, FALSE);
#line 5242 "four-in-a-row.c"
}

static inline void
four_in_arow_toggle_game_menu (FourInARow* self)
{
	GameWindow* _tmp0_;
	GameWindow* _tmp1_;
	GameWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 1322 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 1324 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->window;
#line 1324 "../src/four-in-a-row.vala"
	if (game_window_new_game_screen_visible (_tmp0_)) {
#line 1325 "../src/four-in-a-row.vala"
		return;
#line 5261 "four-in-a-row.c"
	}
#line 1326 "../src/four-in-a-row.vala"
	_tmp1_ = self->priv->window;
#line 1326 "../src/four-in-a-row.vala"
	game_window_close_hamburger (_tmp1_);
#line 1327 "../src/four-in-a-row.vala"
	_tmp2_ = self->priv->window;
#line 1327 "../src/four-in-a-row.vala"
	_tmp3_ = game_window_get_is_extra_thin (_tmp2_);
#line 1327 "../src/four-in-a-row.vala"
	_tmp4_ = _tmp3_;
#line 1327 "../src/four-in-a-row.vala"
	if (_tmp4_) {
#line 5275 "four-in-a-row.c"
		HistoryButton* _tmp5_;
		HistoryButton* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 1328 "../src/four-in-a-row.vala"
		_tmp5_ = self->priv->history_button_2;
#line 1328 "../src/four-in-a-row.vala"
		_tmp6_ = self->priv->history_button_2;
#line 1328 "../src/four-in-a-row.vala"
		_tmp7_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp6_);
#line 1328 "../src/four-in-a-row.vala"
		_tmp8_ = _tmp7_;
#line 1328 "../src/four-in-a-row.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp5_, !_tmp8_);
#line 5290 "four-in-a-row.c"
	} else {
		HistoryButton* _tmp9_;
		HistoryButton* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 1330 "../src/four-in-a-row.vala"
		_tmp9_ = self->priv->history_button_1;
#line 1330 "../src/four-in-a-row.vala"
		_tmp10_ = self->priv->history_button_1;
#line 1330 "../src/four-in-a-row.vala"
		_tmp11_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp10_);
#line 1330 "../src/four-in-a-row.vala"
		_tmp12_ = _tmp11_;
#line 1330 "../src/four-in-a-row.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp9_, !_tmp12_);
#line 5306 "four-in-a-row.c"
	}
}

static gint
four_in_arow_get_keypress_drop (FourInARow* self)
{
	gint result;
#line 80 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 80 "../src/four-in-a-row.vala"
	result = self->priv->_keypress_drop;
#line 80 "../src/four-in-a-row.vala"
	return result;
#line 5320 "four-in-a-row.c"
}

void
four_in_arow_set_keypress_drop (FourInARow* self,
                                gint value)
{
#line 80 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/four-in-a-row.vala"
	self->priv->_keypress_drop = value;
#line 5331 "four-in-a-row.c"
}

static gint
four_in_arow_get_keypress_right (FourInARow* self)
{
	gint result;
#line 81 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 81 "../src/four-in-a-row.vala"
	result = self->priv->_keypress_right;
#line 81 "../src/four-in-a-row.vala"
	return result;
#line 5344 "four-in-a-row.c"
}

void
four_in_arow_set_keypress_right (FourInARow* self,
                                 gint value)
{
#line 81 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/four-in-a-row.vala"
	self->priv->_keypress_right = value;
#line 5355 "four-in-a-row.c"
}

static gint
four_in_arow_get_keypress_left (FourInARow* self)
{
	gint result;
#line 82 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 82 "../src/four-in-a-row.vala"
	result = self->priv->_keypress_left;
#line 82 "../src/four-in-a-row.vala"
	return result;
#line 5368 "four-in-a-row.c"
}

void
four_in_arow_set_keypress_left (FourInARow* self,
                                gint value)
{
#line 82 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/four-in-a-row.vala"
	self->priv->_keypress_left = value;
#line 5379 "four-in-a-row.c"
}

static gboolean
four_in_arow_get_sound_on (FourInARow* self)
{
	gboolean result;
#line 83 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../src/four-in-a-row.vala"
	result = self->priv->_sound_on;
#line 83 "../src/four-in-a-row.vala"
	return result;
#line 5392 "four-in-a-row.c"
}

void
four_in_arow_set_sound_on (FourInARow* self,
                           gboolean value)
{
#line 83 "../src/four-in-a-row.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/four-in-a-row.vala"
	self->priv->_sound_on = value;
#line 5403 "four-in-a-row.c"
}

static inline gpointer
four_in_arow_next_move_get_instance_private (FourInARowNextMove* self)
{
	return G_STRUCT_MEMBER_P (self, FourInARowNextMove_private_offset);
}

static FourInARowNextMove*
four_in_arow_next_move_construct (GType object_type,
                                  guint8 c,
                                  FourInARow* application)
{
	FourInARowNextMove* self = NULL;
	FourInARow* _tmp0_;
#line 764 "../src/four-in-a-row.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 764 "../src/four-in-a-row.vala"
	self = (FourInARowNextMove*) g_type_create_instance (object_type);
#line 766 "../src/four-in-a-row.vala"
	self->priv->c = c;
#line 767 "../src/four-in-a-row.vala"
	_tmp0_ = _g_object_ref0 (application);
#line 767 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->application);
#line 767 "../src/four-in-a-row.vala"
	self->priv->application = _tmp0_;
#line 764 "../src/four-in-a-row.vala"
	return self;
#line 5433 "four-in-a-row.c"
}

static FourInARowNextMove*
four_in_arow_next_move_new (guint8 c,
                            FourInARow* application)
{
#line 764 "../src/four-in-a-row.vala"
	return four_in_arow_next_move_construct (FOUR_IN_AROW_TYPE_NEXT_MOVE, c, application);
#line 5442 "four-in-a-row.c"
}

static gboolean
four_in_arow_next_move_exec (FourInARowNextMove* self)
{
	FourInARow* _tmp0_;
	gboolean result;
#line 770 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 772 "../src/four-in-a-row.vala"
	_tmp0_ = self->priv->application;
#line 772 "../src/four-in-a-row.vala"
	four_in_arow_process_move (_tmp0_, self->priv->c);
#line 773 "../src/four-in-a-row.vala"
	result = FALSE;
#line 773 "../src/four-in-a-row.vala"
	return result;
#line 5460 "four-in-a-row.c"
}

static void
four_in_arow_value_next_move_init (GValue* value)
{
#line 759 "../src/four-in-a-row.vala"
	value->data[0].v_pointer = NULL;
#line 5468 "four-in-a-row.c"
}

static void
four_in_arow_value_next_move_free_value (GValue* value)
{
#line 759 "../src/four-in-a-row.vala"
	if (value->data[0].v_pointer) {
#line 759 "../src/four-in-a-row.vala"
		four_in_arow_next_move_unref (value->data[0].v_pointer);
#line 5478 "four-in-a-row.c"
	}
}

static void
four_in_arow_value_next_move_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 759 "../src/four-in-a-row.vala"
	if (src_value->data[0].v_pointer) {
#line 759 "../src/four-in-a-row.vala"
		dest_value->data[0].v_pointer = four_in_arow_next_move_ref (src_value->data[0].v_pointer);
#line 5490 "four-in-a-row.c"
	} else {
#line 759 "../src/four-in-a-row.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5494 "four-in-a-row.c"
	}
}

static gpointer
four_in_arow_value_next_move_peek_pointer (const GValue* value)
{
#line 759 "../src/four-in-a-row.vala"
	return value->data[0].v_pointer;
#line 5503 "four-in-a-row.c"
}

static gchar*
four_in_arow_value_next_move_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 759 "../src/four-in-a-row.vala"
	if (collect_values[0].v_pointer) {
#line 5514 "four-in-a-row.c"
		FourInARowNextMove * object;
		object = collect_values[0].v_pointer;
#line 759 "../src/four-in-a-row.vala"
		if (object->parent_instance.g_class == NULL) {
#line 759 "../src/four-in-a-row.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5521 "four-in-a-row.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 759 "../src/four-in-a-row.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5525 "four-in-a-row.c"
		}
#line 759 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = four_in_arow_next_move_ref (object);
#line 5529 "four-in-a-row.c"
	} else {
#line 759 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = NULL;
#line 5533 "four-in-a-row.c"
	}
#line 759 "../src/four-in-a-row.vala"
	return NULL;
#line 5537 "four-in-a-row.c"
}

static gchar*
four_in_arow_value_next_move_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	FourInARowNextMove ** object_p;
	object_p = collect_values[0].v_pointer;
#line 759 "../src/four-in-a-row.vala"
	if (!object_p) {
#line 759 "../src/four-in-a-row.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5552 "four-in-a-row.c"
	}
#line 759 "../src/four-in-a-row.vala"
	if (!value->data[0].v_pointer) {
#line 759 "../src/four-in-a-row.vala"
		*object_p = NULL;
#line 5558 "four-in-a-row.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 759 "../src/four-in-a-row.vala"
		*object_p = value->data[0].v_pointer;
#line 5562 "four-in-a-row.c"
	} else {
#line 759 "../src/four-in-a-row.vala"
		*object_p = four_in_arow_next_move_ref (value->data[0].v_pointer);
#line 5566 "four-in-a-row.c"
	}
#line 759 "../src/four-in-a-row.vala"
	return NULL;
#line 5570 "four-in-a-row.c"
}

static GParamSpec*
four_in_arow_param_spec_next_move (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	FourInARowParamSpecNextMove* spec;
#line 759 "../src/four-in-a-row.vala"
	g_return_val_if_fail (g_type_is_a (object_type, FOUR_IN_AROW_TYPE_NEXT_MOVE), NULL);
#line 759 "../src/four-in-a-row.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 759 "../src/four-in-a-row.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 759 "../src/four-in-a-row.vala"
	return G_PARAM_SPEC (spec);
#line 5589 "four-in-a-row.c"
}

static gpointer
four_in_arow_value_get_next_move (const GValue* value)
{
#line 759 "../src/four-in-a-row.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, FOUR_IN_AROW_TYPE_NEXT_MOVE), NULL);
#line 759 "../src/four-in-a-row.vala"
	return value->data[0].v_pointer;
#line 5599 "four-in-a-row.c"
}

static void
four_in_arow_value_set_next_move (GValue* value,
                                  gpointer v_object)
{
	FourInARowNextMove * old;
#line 759 "../src/four-in-a-row.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, FOUR_IN_AROW_TYPE_NEXT_MOVE));
#line 759 "../src/four-in-a-row.vala"
	old = value->data[0].v_pointer;
#line 759 "../src/four-in-a-row.vala"
	if (v_object) {
#line 759 "../src/four-in-a-row.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, FOUR_IN_AROW_TYPE_NEXT_MOVE));
#line 759 "../src/four-in-a-row.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 759 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = v_object;
#line 759 "../src/four-in-a-row.vala"
		four_in_arow_next_move_ref (value->data[0].v_pointer);
#line 5621 "four-in-a-row.c"
	} else {
#line 759 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = NULL;
#line 5625 "four-in-a-row.c"
	}
#line 759 "../src/four-in-a-row.vala"
	if (old) {
#line 759 "../src/four-in-a-row.vala"
		four_in_arow_next_move_unref (old);
#line 5631 "four-in-a-row.c"
	}
}

static void
four_in_arow_value_take_next_move (GValue* value,
                                   gpointer v_object)
{
	FourInARowNextMove * old;
#line 759 "../src/four-in-a-row.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, FOUR_IN_AROW_TYPE_NEXT_MOVE));
#line 759 "../src/four-in-a-row.vala"
	old = value->data[0].v_pointer;
#line 759 "../src/four-in-a-row.vala"
	if (v_object) {
#line 759 "../src/four-in-a-row.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, FOUR_IN_AROW_TYPE_NEXT_MOVE));
#line 759 "../src/four-in-a-row.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 759 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = v_object;
#line 5652 "four-in-a-row.c"
	} else {
#line 759 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = NULL;
#line 5656 "four-in-a-row.c"
	}
#line 759 "../src/four-in-a-row.vala"
	if (old) {
#line 759 "../src/four-in-a-row.vala"
		four_in_arow_next_move_unref (old);
#line 5662 "four-in-a-row.c"
	}
}

static void
four_in_arow_next_move_class_init (FourInARowNextMoveClass * klass,
                                   gpointer klass_data)
{
#line 759 "../src/four-in-a-row.vala"
	four_in_arow_next_move_parent_class = g_type_class_peek_parent (klass);
#line 759 "../src/four-in-a-row.vala"
	((FourInARowNextMoveClass *) klass)->finalize = four_in_arow_next_move_finalize;
#line 759 "../src/four-in-a-row.vala"
	g_type_class_adjust_private_offset (klass, &FourInARowNextMove_private_offset);
#line 5676 "four-in-a-row.c"
}

static void
four_in_arow_next_move_instance_init (FourInARowNextMove * self,
                                      gpointer klass)
{
#line 759 "../src/four-in-a-row.vala"
	self->priv = four_in_arow_next_move_get_instance_private (self);
#line 759 "../src/four-in-a-row.vala"
	self->ref_count = 1;
#line 5687 "four-in-a-row.c"
}

static void
four_in_arow_next_move_finalize (FourInARowNextMove * obj)
{
	FourInARowNextMove * self;
#line 759 "../src/four-in-a-row.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOUR_IN_AROW_TYPE_NEXT_MOVE, FourInARowNextMove);
#line 759 "../src/four-in-a-row.vala"
	g_signal_handlers_destroy (self);
#line 762 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->application);
#line 5700 "four-in-a-row.c"
}

static GType
four_in_arow_next_move_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { four_in_arow_value_next_move_init, four_in_arow_value_next_move_free_value, four_in_arow_value_next_move_copy_value, four_in_arow_value_next_move_peek_pointer, "p", four_in_arow_value_next_move_collect_value, "p", four_in_arow_value_next_move_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (FourInARowNextMoveClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) four_in_arow_next_move_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FourInARowNextMove), 0, (GInstanceInitFunc) four_in_arow_next_move_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType four_in_arow_next_move_type_id;
	four_in_arow_next_move_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FourInARowNextMove", &g_define_type_info, &g_define_type_fundamental_info, 0);
	FourInARowNextMove_private_offset = g_type_add_instance_private (four_in_arow_next_move_type_id, sizeof (FourInARowNextMovePrivate));
	return four_in_arow_next_move_type_id;
}

static GType
four_in_arow_next_move_get_type (void)
{
	static volatile gsize four_in_arow_next_move_type_id__once = 0;
	if (g_once_init_enter (&four_in_arow_next_move_type_id__once)) {
		GType four_in_arow_next_move_type_id;
		four_in_arow_next_move_type_id = four_in_arow_next_move_get_type_once ();
		g_once_init_leave (&four_in_arow_next_move_type_id__once, four_in_arow_next_move_type_id);
	}
	return four_in_arow_next_move_type_id__once;
}

static gpointer
four_in_arow_next_move_ref (gpointer instance)
{
	FourInARowNextMove * self;
	self = instance;
#line 759 "../src/four-in-a-row.vala"
	g_atomic_int_inc (&self->ref_count);
#line 759 "../src/four-in-a-row.vala"
	return instance;
#line 5736 "four-in-a-row.c"
}

static void
four_in_arow_next_move_unref (gpointer instance)
{
	FourInARowNextMove * self;
	self = instance;
#line 759 "../src/four-in-a-row.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 759 "../src/four-in-a-row.vala"
		FOUR_IN_AROW_NEXT_MOVE_GET_CLASS (self)->finalize (self);
#line 759 "../src/four-in-a-row.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5750 "four-in-a-row.c"
	}
}

static inline gpointer
four_in_arow_animate_get_instance_private (FourInARowAnimate* self)
{
	return G_STRUCT_MEMBER_P (self, FourInARowAnimate_private_offset);
}

static FourInARowAnimate*
four_in_arow_animate_construct (GType object_type,
                                guint8 c,
                                FourInARow* application,
                                guint8 blink_n_times)
{
	FourInARowAnimate* self = NULL;
	FourInARow* _tmp0_;
#line 813 "../src/four-in-a-row.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 813 "../src/four-in-a-row.vala"
	self = (FourInARowAnimate*) g_type_create_instance (object_type);
#line 815 "../src/four-in-a-row.vala"
	self->priv->c = c;
#line 816 "../src/four-in-a-row.vala"
	_tmp0_ = _g_object_ref0 (application);
#line 816 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->application);
#line 816 "../src/four-in-a-row.vala"
	self->priv->application = _tmp0_;
#line 817 "../src/four-in-a-row.vala"
	self->priv->blink_n_times = blink_n_times;
#line 813 "../src/four-in-a-row.vala"
	return self;
#line 5784 "four-in-a-row.c"
}

static FourInARowAnimate*
four_in_arow_animate_new (guint8 c,
                          FourInARow* application,
                          guint8 blink_n_times)
{
#line 813 "../src/four-in-a-row.vala"
	return four_in_arow_animate_construct (FOUR_IN_AROW_TYPE_ANIMATE, c, application, blink_n_times);
#line 5794 "four-in-a-row.c"
}

static gboolean
four_in_arow_animate_exec (FourInARowAnimate* self)
{
	gboolean result;
#line 820 "../src/four-in-a-row.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 822 "../src/four-in-a-row.vala"
	switch (four_in_arow_anim) {
#line 822 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_ANIM_ID_NONE:
#line 5807 "four-in-a-row.c"
		{
#line 825 "../src/four-in-a-row.vala"
			result = FALSE;
#line 825 "../src/four-in-a-row.vala"
			return result;
#line 5813 "four-in-a-row.c"
		}
#line 822 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_ANIM_ID_HINT:
#line 822 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_ANIM_ID_MOVE:
#line 5819 "four-in-a-row.c"
		{
			FourInARow* _tmp0_;
			FourInARow* _tmp1_;
#line 829 "../src/four-in-a-row.vala"
			_tmp0_ = self->priv->application;
#line 829 "../src/four-in-a-row.vala"
			_tmp1_ = self->priv->application;
#line 829 "../src/four-in-a-row.vala"
			if (_tmp0_->priv->column < _tmp1_->priv->column_moveto) {
#line 5829 "four-in-a-row.c"
				FourInARow* _tmp2_;
				FourInARow* _tmp3_;
#line 830 "../src/four-in-a-row.vala"
				_tmp2_ = self->priv->application;
#line 830 "../src/four-in-a-row.vala"
				_tmp3_ = self->priv->application;
#line 830 "../src/four-in-a-row.vala"
				four_in_arow_move (_tmp2_, (guint8) (_tmp3_->priv->column + 1));
#line 5838 "four-in-a-row.c"
			} else {
				FourInARow* _tmp4_;
				FourInARow* _tmp5_;
#line 831 "../src/four-in-a-row.vala"
				_tmp4_ = self->priv->application;
#line 831 "../src/four-in-a-row.vala"
				_tmp5_ = self->priv->application;
#line 831 "../src/four-in-a-row.vala"
				if (_tmp4_->priv->column > _tmp5_->priv->column_moveto) {
#line 5848 "four-in-a-row.c"
					FourInARow* _tmp6_;
					FourInARow* _tmp7_;
#line 832 "../src/four-in-a-row.vala"
					_tmp6_ = self->priv->application;
#line 832 "../src/four-in-a-row.vala"
					_tmp7_ = self->priv->application;
#line 832 "../src/four-in-a-row.vala"
					four_in_arow_move (_tmp6_, (guint8) (_tmp7_->priv->column - 1));
#line 5857 "four-in-a-row.c"
				} else {
					FourInARow* _tmp8_;
#line 835 "../src/four-in-a-row.vala"
					_tmp8_ = self->priv->application;
#line 835 "../src/four-in-a-row.vala"
					_tmp8_->priv->timeout = (guint) 0;
#line 836 "../src/four-in-a-row.vala"
					if (four_in_arow_anim == FOUR_IN_AROW_ANIM_ID_MOVE) {
#line 5866 "four-in-a-row.c"
						FourInARow* _tmp9_;
#line 838 "../src/four-in-a-row.vala"
						four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_NONE;
#line 839 "../src/four-in-a-row.vala"
						_tmp9_ = self->priv->application;
#line 839 "../src/four-in-a-row.vala"
						four_in_arow_process_move2 (_tmp9_, self->priv->c);
#line 5874 "four-in-a-row.c"
					} else {
#line 842 "../src/four-in-a-row.vala"
						four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_NONE;
#line 5878 "four-in-a-row.c"
					}
#line 843 "../src/four-in-a-row.vala"
					result = FALSE;
#line 843 "../src/four-in-a-row.vala"
					return result;
#line 5884 "four-in-a-row.c"
				}
			}
#line 845 "../src/four-in-a-row.vala"
			result = TRUE;
#line 845 "../src/four-in-a-row.vala"
			return result;
#line 5891 "four-in-a-row.c"
		}
#line 822 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_ANIM_ID_DROP:
#line 5895 "four-in-a-row.c"
		{
			FourInARow* _tmp10_;
			FourInARow* _tmp11_;
#line 848 "../src/four-in-a-row.vala"
			_tmp10_ = self->priv->application;
#line 848 "../src/four-in-a-row.vala"
			_tmp11_ = self->priv->application;
#line 848 "../src/four-in-a-row.vala"
			if (_tmp10_->priv->row < _tmp11_->priv->row_dropto) {
#line 5905 "four-in-a-row.c"
				FourInARow* _tmp12_;
#line 849 "../src/four-in-a-row.vala"
				_tmp12_ = self->priv->application;
#line 849 "../src/four-in-a-row.vala"
				four_in_arow_drop (_tmp12_);
#line 5911 "four-in-a-row.c"
			} else {
				FourInARow* _tmp13_;
				FourInARow* _tmp14_;
#line 852 "../src/four-in-a-row.vala"
				four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_NONE;
#line 853 "../src/four-in-a-row.vala"
				_tmp13_ = self->priv->application;
#line 853 "../src/four-in-a-row.vala"
				_tmp13_->priv->timeout = (guint) 0;
#line 854 "../src/four-in-a-row.vala"
				_tmp14_ = self->priv->application;
#line 854 "../src/four-in-a-row.vala"
				four_in_arow_process_move3 (_tmp14_, self->priv->c);
#line 855 "../src/four-in-a-row.vala"
				result = FALSE;
#line 855 "../src/four-in-a-row.vala"
				return result;
#line 5929 "four-in-a-row.c"
			}
#line 857 "../src/four-in-a-row.vala"
			result = TRUE;
#line 857 "../src/four-in-a-row.vala"
			return result;
#line 5935 "four-in-a-row.c"
		}
#line 822 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_ANIM_ID_BLINK:
#line 5939 "four-in-a-row.c"
		{
			Player _tmp15_ = 0;
			FourInARow* _tmp16_;
			FourInARow* _tmp18_;
			FourInARow* _tmp19_;
			guint8* _tmp20_;
			gint _tmp20__length1;
			gint _tmp20__length2;
			FourInARow* _tmp21_;
			guint8 _tmp22_;
			FourInARow* _tmp23_;
			guint8* _tmp24_;
			gint _tmp24__length1;
			gint _tmp24__length2;
			FourInARow* _tmp25_;
			guint8 _tmp26_;
			FourInARow* _tmp27_;
			guint8* _tmp28_;
			gint _tmp28__length1;
			gint _tmp28__length2;
			FourInARow* _tmp29_;
			guint8 _tmp30_;
			FourInARow* _tmp31_;
			guint8* _tmp32_;
			gint _tmp32__length1;
			gint _tmp32__length2;
			FourInARow* _tmp33_;
			guint8 _tmp34_;
			FourInARow* _tmp35_;
			guint8 _tmp36_;
			gboolean _tmp37_ = FALSE;
			FourInARow* _tmp38_;
			FourInARow* _tmp49_;
			FourInARow* _tmp50_;
#line 864 "../src/four-in-a-row.vala"
			_tmp16_ = self->priv->application;
#line 864 "../src/four-in-a-row.vala"
			if (_tmp16_->priv->blink_on) {
#line 5978 "four-in-a-row.c"
				FourInARow* _tmp17_;
#line 864 "../src/four-in-a-row.vala"
				_tmp17_ = self->priv->application;
#line 864 "../src/four-in-a-row.vala"
				_tmp15_ = _tmp17_->priv->blink_t;
#line 5984 "four-in-a-row.c"
			} else {
#line 864 "../src/four-in-a-row.vala"
				_tmp15_ = PLAYER_NOBODY;
#line 5988 "four-in-a-row.c"
			}
#line 860 "../src/four-in-a-row.vala"
			_tmp18_ = self->priv->application;
#line 860 "../src/four-in-a-row.vala"
			_tmp19_ = self->priv->application;
#line 860 "../src/four-in-a-row.vala"
			_tmp20_ = _tmp19_->priv->blink_lines;
#line 860 "../src/four-in-a-row.vala"
			_tmp20__length1 = _tmp19_->priv->blink_lines_length1;
#line 860 "../src/four-in-a-row.vala"
			_tmp20__length2 = _tmp19_->priv->blink_lines_length2;
#line 860 "../src/four-in-a-row.vala"
			_tmp21_ = self->priv->application;
#line 860 "../src/four-in-a-row.vala"
			_tmp22_ = _tmp20_[(_tmp21_->priv->blink_line * _tmp20__length2) + 0];
#line 860 "../src/four-in-a-row.vala"
			_tmp23_ = self->priv->application;
#line 860 "../src/four-in-a-row.vala"
			_tmp24_ = _tmp23_->priv->blink_lines;
#line 860 "../src/four-in-a-row.vala"
			_tmp24__length1 = _tmp23_->priv->blink_lines_length1;
#line 860 "../src/four-in-a-row.vala"
			_tmp24__length2 = _tmp23_->priv->blink_lines_length2;
#line 860 "../src/four-in-a-row.vala"
			_tmp25_ = self->priv->application;
#line 860 "../src/four-in-a-row.vala"
			_tmp26_ = _tmp24_[(_tmp25_->priv->blink_line * _tmp24__length2) + 1];
#line 860 "../src/four-in-a-row.vala"
			_tmp27_ = self->priv->application;
#line 860 "../src/four-in-a-row.vala"
			_tmp28_ = _tmp27_->priv->blink_lines;
#line 860 "../src/four-in-a-row.vala"
			_tmp28__length1 = _tmp27_->priv->blink_lines_length1;
#line 860 "../src/four-in-a-row.vala"
			_tmp28__length2 = _tmp27_->priv->blink_lines_length2;
#line 860 "../src/four-in-a-row.vala"
			_tmp29_ = self->priv->application;
#line 860 "../src/four-in-a-row.vala"
			_tmp30_ = _tmp28_[(_tmp29_->priv->blink_line * _tmp28__length2) + 2];
#line 860 "../src/four-in-a-row.vala"
			_tmp31_ = self->priv->application;
#line 860 "../src/four-in-a-row.vala"
			_tmp32_ = _tmp31_->priv->blink_lines;
#line 860 "../src/four-in-a-row.vala"
			_tmp32__length1 = _tmp31_->priv->blink_lines_length1;
#line 860 "../src/four-in-a-row.vala"
			_tmp32__length2 = _tmp31_->priv->blink_lines_length2;
#line 860 "../src/four-in-a-row.vala"
			_tmp33_ = self->priv->application;
#line 860 "../src/four-in-a-row.vala"
			_tmp34_ = _tmp32_[(_tmp33_->priv->blink_line * _tmp32__length2) + 3];
#line 860 "../src/four-in-a-row.vala"
			four_in_arow_draw_line (_tmp18_, _tmp22_, _tmp26_, _tmp30_, _tmp34_, _tmp15_);
#line 865 "../src/four-in-a-row.vala"
			_tmp35_ = self->priv->application;
#line 865 "../src/four-in-a-row.vala"
			_tmp36_ = _tmp35_->priv->blink_n;
#line 865 "../src/four-in-a-row.vala"
			_tmp35_->priv->blink_n = _tmp36_ - 1;
#line 866 "../src/four-in-a-row.vala"
			_tmp38_ = self->priv->application;
#line 866 "../src/four-in-a-row.vala"
			if (((gint) _tmp38_->priv->blink_n) == 0) {
#line 6052 "four-in-a-row.c"
				FourInARow* _tmp39_;
#line 866 "../src/four-in-a-row.vala"
				_tmp39_ = self->priv->application;
#line 866 "../src/four-in-a-row.vala"
				_tmp37_ = _tmp39_->priv->blink_on;
#line 6058 "four-in-a-row.c"
			} else {
#line 866 "../src/four-in-a-row.vala"
				_tmp37_ = FALSE;
#line 6062 "four-in-a-row.c"
			}
#line 866 "../src/four-in-a-row.vala"
			if (_tmp37_) {
#line 6066 "four-in-a-row.c"
				FourInARow* _tmp40_;
				FourInARow* _tmp41_;
				guint8* _tmp42_;
				gint _tmp42__length1;
				gint _tmp42__length2;
				gint _tmp43_;
#line 868 "../src/four-in-a-row.vala"
				_tmp40_ = self->priv->application;
#line 868 "../src/four-in-a-row.vala"
				_tmp41_ = self->priv->application;
#line 868 "../src/four-in-a-row.vala"
				_tmp42_ = _tmp41_->priv->blink_lines;
#line 868 "../src/four-in-a-row.vala"
				_tmp42__length1 = _tmp41_->priv->blink_lines_length1;
#line 868 "../src/four-in-a-row.vala"
				_tmp42__length2 = _tmp41_->priv->blink_lines_length2;
#line 868 "../src/four-in-a-row.vala"
				_tmp43_ = _tmp42__length1;
#line 868 "../src/four-in-a-row.vala"
				if (((gint) _tmp40_->priv->blink_line) >= (_tmp43_ - 1)) {
#line 6087 "four-in-a-row.c"
					FourInARow* _tmp44_;
#line 870 "../src/four-in-a-row.vala"
					four_in_arow_anim = FOUR_IN_AROW_ANIM_ID_NONE;
#line 871 "../src/four-in-a-row.vala"
					_tmp44_ = self->priv->application;
#line 871 "../src/four-in-a-row.vala"
					_tmp44_->priv->timeout = (guint) 0;
#line 872 "../src/four-in-a-row.vala"
					result = FALSE;
#line 872 "../src/four-in-a-row.vala"
					return result;
#line 6099 "four-in-a-row.c"
				} else {
					FourInARow* _tmp45_;
					guint8 _tmp46_;
					FourInARow* _tmp47_;
					FourInARow* _tmp48_;
#line 876 "../src/four-in-a-row.vala"
					_tmp45_ = self->priv->application;
#line 876 "../src/four-in-a-row.vala"
					_tmp46_ = _tmp45_->priv->blink_line;
#line 876 "../src/four-in-a-row.vala"
					_tmp45_->priv->blink_line = _tmp46_ + 1;
#line 877 "../src/four-in-a-row.vala"
					_tmp47_ = self->priv->application;
#line 877 "../src/four-in-a-row.vala"
					_tmp48_ = self->priv->application;
#line 877 "../src/four-in-a-row.vala"
					_tmp48_->priv->blink_n = _tmp48_->priv->blink_n + self->priv->blink_n_times;
#line 6117 "four-in-a-row.c"
				}
			}
#line 880 "../src/four-in-a-row.vala"
			_tmp49_ = self->priv->application;
#line 880 "../src/four-in-a-row.vala"
			_tmp50_ = self->priv->application;
#line 880 "../src/four-in-a-row.vala"
			_tmp49_->priv->blink_on = !_tmp50_->priv->blink_on;
#line 881 "../src/four-in-a-row.vala"
			result = TRUE;
#line 881 "../src/four-in-a-row.vala"
			return result;
#line 6130 "four-in-a-row.c"
		}
		default:
		{
#line 883 "../src/four-in-a-row.vala"
			g_assert_not_reached ();
#line 6136 "four-in-a-row.c"
		}
	}
}

static void
four_in_arow_value_animate_init (GValue* value)
{
#line 807 "../src/four-in-a-row.vala"
	value->data[0].v_pointer = NULL;
#line 6146 "four-in-a-row.c"
}

static void
four_in_arow_value_animate_free_value (GValue* value)
{
#line 807 "../src/four-in-a-row.vala"
	if (value->data[0].v_pointer) {
#line 807 "../src/four-in-a-row.vala"
		four_in_arow_animate_unref (value->data[0].v_pointer);
#line 6156 "four-in-a-row.c"
	}
}

static void
four_in_arow_value_animate_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
#line 807 "../src/four-in-a-row.vala"
	if (src_value->data[0].v_pointer) {
#line 807 "../src/four-in-a-row.vala"
		dest_value->data[0].v_pointer = four_in_arow_animate_ref (src_value->data[0].v_pointer);
#line 6168 "four-in-a-row.c"
	} else {
#line 807 "../src/four-in-a-row.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6172 "four-in-a-row.c"
	}
}

static gpointer
four_in_arow_value_animate_peek_pointer (const GValue* value)
{
#line 807 "../src/four-in-a-row.vala"
	return value->data[0].v_pointer;
#line 6181 "four-in-a-row.c"
}

static gchar*
four_in_arow_value_animate_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
#line 807 "../src/four-in-a-row.vala"
	if (collect_values[0].v_pointer) {
#line 6192 "four-in-a-row.c"
		FourInARowAnimate * object;
		object = collect_values[0].v_pointer;
#line 807 "../src/four-in-a-row.vala"
		if (object->parent_instance.g_class == NULL) {
#line 807 "../src/four-in-a-row.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6199 "four-in-a-row.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 807 "../src/four-in-a-row.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6203 "four-in-a-row.c"
		}
#line 807 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = four_in_arow_animate_ref (object);
#line 6207 "four-in-a-row.c"
	} else {
#line 807 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = NULL;
#line 6211 "four-in-a-row.c"
	}
#line 807 "../src/four-in-a-row.vala"
	return NULL;
#line 6215 "four-in-a-row.c"
}

static gchar*
four_in_arow_value_animate_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	FourInARowAnimate ** object_p;
	object_p = collect_values[0].v_pointer;
#line 807 "../src/four-in-a-row.vala"
	if (!object_p) {
#line 807 "../src/four-in-a-row.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6230 "four-in-a-row.c"
	}
#line 807 "../src/four-in-a-row.vala"
	if (!value->data[0].v_pointer) {
#line 807 "../src/four-in-a-row.vala"
		*object_p = NULL;
#line 6236 "four-in-a-row.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 807 "../src/four-in-a-row.vala"
		*object_p = value->data[0].v_pointer;
#line 6240 "four-in-a-row.c"
	} else {
#line 807 "../src/four-in-a-row.vala"
		*object_p = four_in_arow_animate_ref (value->data[0].v_pointer);
#line 6244 "four-in-a-row.c"
	}
#line 807 "../src/four-in-a-row.vala"
	return NULL;
#line 6248 "four-in-a-row.c"
}

static GParamSpec*
four_in_arow_param_spec_animate (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	FourInARowParamSpecAnimate* spec;
#line 807 "../src/four-in-a-row.vala"
	g_return_val_if_fail (g_type_is_a (object_type, FOUR_IN_AROW_TYPE_ANIMATE), NULL);
#line 807 "../src/four-in-a-row.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 807 "../src/four-in-a-row.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 807 "../src/four-in-a-row.vala"
	return G_PARAM_SPEC (spec);
#line 6267 "four-in-a-row.c"
}

static gpointer
four_in_arow_value_get_animate (const GValue* value)
{
#line 807 "../src/four-in-a-row.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, FOUR_IN_AROW_TYPE_ANIMATE), NULL);
#line 807 "../src/four-in-a-row.vala"
	return value->data[0].v_pointer;
#line 6277 "four-in-a-row.c"
}

static void
four_in_arow_value_set_animate (GValue* value,
                                gpointer v_object)
{
	FourInARowAnimate * old;
#line 807 "../src/four-in-a-row.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, FOUR_IN_AROW_TYPE_ANIMATE));
#line 807 "../src/four-in-a-row.vala"
	old = value->data[0].v_pointer;
#line 807 "../src/four-in-a-row.vala"
	if (v_object) {
#line 807 "../src/four-in-a-row.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, FOUR_IN_AROW_TYPE_ANIMATE));
#line 807 "../src/four-in-a-row.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 807 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = v_object;
#line 807 "../src/four-in-a-row.vala"
		four_in_arow_animate_ref (value->data[0].v_pointer);
#line 6299 "four-in-a-row.c"
	} else {
#line 807 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = NULL;
#line 6303 "four-in-a-row.c"
	}
#line 807 "../src/four-in-a-row.vala"
	if (old) {
#line 807 "../src/four-in-a-row.vala"
		four_in_arow_animate_unref (old);
#line 6309 "four-in-a-row.c"
	}
}

static void
four_in_arow_value_take_animate (GValue* value,
                                 gpointer v_object)
{
	FourInARowAnimate * old;
#line 807 "../src/four-in-a-row.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, FOUR_IN_AROW_TYPE_ANIMATE));
#line 807 "../src/four-in-a-row.vala"
	old = value->data[0].v_pointer;
#line 807 "../src/four-in-a-row.vala"
	if (v_object) {
#line 807 "../src/four-in-a-row.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, FOUR_IN_AROW_TYPE_ANIMATE));
#line 807 "../src/four-in-a-row.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 807 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = v_object;
#line 6330 "four-in-a-row.c"
	} else {
#line 807 "../src/four-in-a-row.vala"
		value->data[0].v_pointer = NULL;
#line 6334 "four-in-a-row.c"
	}
#line 807 "../src/four-in-a-row.vala"
	if (old) {
#line 807 "../src/four-in-a-row.vala"
		four_in_arow_animate_unref (old);
#line 6340 "four-in-a-row.c"
	}
}

static void
four_in_arow_animate_class_init (FourInARowAnimateClass * klass,
                                 gpointer klass_data)
{
#line 807 "../src/four-in-a-row.vala"
	four_in_arow_animate_parent_class = g_type_class_peek_parent (klass);
#line 807 "../src/four-in-a-row.vala"
	((FourInARowAnimateClass *) klass)->finalize = four_in_arow_animate_finalize;
#line 807 "../src/four-in-a-row.vala"
	g_type_class_adjust_private_offset (klass, &FourInARowAnimate_private_offset);
#line 6354 "four-in-a-row.c"
}

static void
four_in_arow_animate_instance_init (FourInARowAnimate * self,
                                    gpointer klass)
{
#line 807 "../src/four-in-a-row.vala"
	self->priv = four_in_arow_animate_get_instance_private (self);
#line 807 "../src/four-in-a-row.vala"
	self->ref_count = 1;
#line 6365 "four-in-a-row.c"
}

static void
four_in_arow_animate_finalize (FourInARowAnimate * obj)
{
	FourInARowAnimate * self;
#line 807 "../src/four-in-a-row.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOUR_IN_AROW_TYPE_ANIMATE, FourInARowAnimate);
#line 807 "../src/four-in-a-row.vala"
	g_signal_handlers_destroy (self);
#line 810 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->application);
#line 6378 "four-in-a-row.c"
}

static GType
four_in_arow_animate_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { four_in_arow_value_animate_init, four_in_arow_value_animate_free_value, four_in_arow_value_animate_copy_value, four_in_arow_value_animate_peek_pointer, "p", four_in_arow_value_animate_collect_value, "p", four_in_arow_value_animate_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (FourInARowAnimateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) four_in_arow_animate_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FourInARowAnimate), 0, (GInstanceInitFunc) four_in_arow_animate_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType four_in_arow_animate_type_id;
	four_in_arow_animate_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FourInARowAnimate", &g_define_type_info, &g_define_type_fundamental_info, 0);
	FourInARowAnimate_private_offset = g_type_add_instance_private (four_in_arow_animate_type_id, sizeof (FourInARowAnimatePrivate));
	return four_in_arow_animate_type_id;
}

static GType
four_in_arow_animate_get_type (void)
{
	static volatile gsize four_in_arow_animate_type_id__once = 0;
	if (g_once_init_enter (&four_in_arow_animate_type_id__once)) {
		GType four_in_arow_animate_type_id;
		four_in_arow_animate_type_id = four_in_arow_animate_get_type_once ();
		g_once_init_leave (&four_in_arow_animate_type_id__once, four_in_arow_animate_type_id);
	}
	return four_in_arow_animate_type_id__once;
}

static gpointer
four_in_arow_animate_ref (gpointer instance)
{
	FourInARowAnimate * self;
	self = instance;
#line 807 "../src/four-in-a-row.vala"
	g_atomic_int_inc (&self->ref_count);
#line 807 "../src/four-in-a-row.vala"
	return instance;
#line 6414 "four-in-a-row.c"
}

static void
four_in_arow_animate_unref (gpointer instance)
{
	FourInARowAnimate * self;
	self = instance;
#line 807 "../src/four-in-a-row.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 807 "../src/four-in-a-row.vala"
		FOUR_IN_AROW_ANIMATE_GET_CLASS (self)->finalize (self);
#line 807 "../src/four-in-a-row.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6428 "four-in-a-row.c"
	}
}

static void
four_in_arow_class_init (FourInARowClass * klass,
                         gpointer klass_data)
{
#line 24 "../src/four-in-a-row.vala"
	four_in_arow_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/four-in-a-row.vala"
	g_type_class_adjust_private_offset (klass, &FourInARow_private_offset);
#line 24 "../src/four-in-a-row.vala"
	((GApplicationClass *) klass)->handle_local_options = (gint (*) (GApplication*, GVariantDict*)) four_in_arow_real_handle_local_options;
#line 24 "../src/four-in-a-row.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) four_in_arow_real_startup;
#line 24 "../src/four-in-a-row.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) four_in_arow_real_activate;
#line 24 "../src/four-in-a-row.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_four_in_arow_get_property;
#line 24 "../src/four-in-a-row.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_four_in_arow_set_property;
#line 24 "../src/four-in-a-row.vala"
	G_OBJECT_CLASS (klass)->finalize = four_in_arow_finalize;
#line 24 "../src/four-in-a-row.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOUR_IN_AROW_KEYPRESS_DROP_PROPERTY, four_in_arow_properties[FOUR_IN_AROW_KEYPRESS_DROP_PROPERTY] = g_param_spec_int ("keypress-drop", "keypress-drop", "keypress-drop", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 24 "../src/four-in-a-row.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOUR_IN_AROW_KEYPRESS_RIGHT_PROPERTY, four_in_arow_properties[FOUR_IN_AROW_KEYPRESS_RIGHT_PROPERTY] = g_param_spec_int ("keypress-right", "keypress-right", "keypress-right", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 24 "../src/four-in-a-row.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOUR_IN_AROW_KEYPRESS_LEFT_PROPERTY, four_in_arow_properties[FOUR_IN_AROW_KEYPRESS_LEFT_PROPERTY] = g_param_spec_int ("keypress-left", "keypress-left", "keypress-left", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 24 "../src/four-in-a-row.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOUR_IN_AROW_SOUND_ON_PROPERTY, four_in_arow_properties[FOUR_IN_AROW_SOUND_ON_PROPERTY] = g_param_spec_boolean ("sound-on", "sound-on", "sound-on", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 6460 "four-in-a-row.c"
}

static void
four_in_arow_instance_init (FourInARow * self,
                            gpointer klass)
{
	GSettings* _tmp0_;
	guint8* _tmp1_;
	GMenu* _tmp2_;
	GMenu* _tmp3_;
#line 24 "../src/four-in-a-row.vala"
	self->priv = four_in_arow_get_instance_private (self);
#line 26 "../src/four-in-a-row.vala"
	_tmp0_ = g_settings_new ("org.gnome.Four-in-a-row");
#line 26 "../src/four-in-a-row.vala"
	self->priv->settings = _tmp0_;
#line 45 "../src/four-in-a-row.vala"
	self->priv->gameover = TRUE;
#line 46 "../src/four-in-a-row.vala"
	self->priv->player = PLAYER_NOBODY;
#line 47 "../src/four-in-a-row.vala"
	self->priv->winner = PLAYER_NOBODY;
#line 48 "../src/four-in-a-row.vala"
	self->priv->last_first_player = PLAYER_NOBODY;
#line 52 "../src/four-in-a-row.vala"
	self->priv->playgame_timeout = (guint) 0;
#line 72 "../src/four-in-a-row.vala"
	_tmp1_ = g_new0 (guint8, 1 * 0);
#line 72 "../src/four-in-a-row.vala"
	self->priv->blink_lines = _tmp1_;
#line 72 "../src/four-in-a-row.vala"
	self->priv->blink_lines_length1 = 1;
#line 72 "../src/four-in-a-row.vala"
	self->priv->blink_lines_length2 = 0;
#line 73 "../src/four-in-a-row.vala"
	self->priv->blink_line = (guint8) 0;
#line 74 "../src/four-in-a-row.vala"
	self->priv->blink_t = PLAYER_NOBODY;
#line 75 "../src/four-in-a-row.vala"
	self->priv->blink_n = (guint8) 0;
#line 76 "../src/four-in-a-row.vala"
	self->priv->blink_on = FALSE;
#line 77 "../src/four-in-a-row.vala"
	self->priv->timeout = (guint) 0;
#line 1206 "../src/four-in-a-row.vala"
	self->priv->sound_context_state = FOUR_IN_AROW_SOUND_CONTEXT_STATE_INITIAL;
#line 1278 "../src/four-in-a-row.vala"
	_tmp2_ = g_menu_new ();
#line 1278 "../src/four-in-a-row.vala"
	self->priv->game_menu = _tmp2_;
#line 1279 "../src/four-in-a-row.vala"
	_tmp3_ = g_menu_new ();
#line 1279 "../src/four-in-a-row.vala"
	self->priv->round_section = _tmp3_;
#line 6515 "four-in-a-row.c"
}

static void
four_in_arow_finalize (GObject * obj)
{
	FourInARow * self;
#line 24 "../src/four-in-a-row.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FOUR_IN_AROW, FourInARow);
#line 26 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->settings);
#line 49 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->game_board);
#line 55 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->scorebox);
#line 56 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->game_board_view);
#line 57 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->window);
#line 58 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->new_game_screen);
#line 59 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->history_button_1);
#line 60 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->history_button_2);
#line 63 "../src/four-in-a-row.vala"
	_g_free0 (self->priv->vstr);
#line 72 "../src/four-in-a-row.vala"
	self->priv->blink_lines = (g_free (self->priv->blink_lines), NULL);
#line 85 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->theme_manager);
#line 975 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->game_type_action);
#line 992 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->next_round_action);
#line 1016 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->window_key_controller);
#line 1017 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->board_key_controller);
#line 1205 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->sound_context);
#line 1278 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->game_menu);
#line 1279 "../src/four-in-a-row.vala"
	_g_object_unref0 (self->priv->round_section);
#line 24 "../src/four-in-a-row.vala"
	G_OBJECT_CLASS (four_in_arow_parent_class)->finalize (obj);
#line 6562 "four-in-a-row.c"
}

static GType
four_in_arow_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FourInARowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) four_in_arow_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FourInARow), 0, (GInstanceInitFunc) four_in_arow_instance_init, NULL };
	GType four_in_arow_type_id;
	four_in_arow_type_id = g_type_register_static (gtk_application_get_type (), "FourInARow", &g_define_type_info, 0);
	FourInARow_private_offset = g_type_add_instance_private (four_in_arow_type_id, sizeof (FourInARowPrivate));
	return four_in_arow_type_id;
}

GType
four_in_arow_get_type (void)
{
	static volatile gsize four_in_arow_type_id__once = 0;
	if (g_once_init_enter (&four_in_arow_type_id__once)) {
		GType four_in_arow_type_id;
		four_in_arow_type_id = four_in_arow_get_type_once ();
		g_once_init_leave (&four_in_arow_type_id__once, four_in_arow_type_id);
	}
	return four_in_arow_type_id__once;
}

static void
_vala_four_in_arow_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	FourInARow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FOUR_IN_AROW, FourInARow);
#line 24 "../src/four-in-a-row.vala"
	switch (property_id) {
#line 24 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_KEYPRESS_DROP_PROPERTY:
#line 24 "../src/four-in-a-row.vala"
		g_value_set_int (value, four_in_arow_get_keypress_drop (self));
#line 24 "../src/four-in-a-row.vala"
		break;
#line 24 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_KEYPRESS_RIGHT_PROPERTY:
#line 24 "../src/four-in-a-row.vala"
		g_value_set_int (value, four_in_arow_get_keypress_right (self));
#line 24 "../src/four-in-a-row.vala"
		break;
#line 24 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_KEYPRESS_LEFT_PROPERTY:
#line 24 "../src/four-in-a-row.vala"
		g_value_set_int (value, four_in_arow_get_keypress_left (self));
#line 24 "../src/four-in-a-row.vala"
		break;
#line 24 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_SOUND_ON_PROPERTY:
#line 24 "../src/four-in-a-row.vala"
		g_value_set_boolean (value, four_in_arow_get_sound_on (self));
#line 24 "../src/four-in-a-row.vala"
		break;
#line 6621 "four-in-a-row.c"
		default:
#line 24 "../src/four-in-a-row.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/four-in-a-row.vala"
		break;
#line 6627 "four-in-a-row.c"
	}
}

static void
_vala_four_in_arow_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	FourInARow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FOUR_IN_AROW, FourInARow);
#line 24 "../src/four-in-a-row.vala"
	switch (property_id) {
#line 24 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_KEYPRESS_DROP_PROPERTY:
#line 24 "../src/four-in-a-row.vala"
		four_in_arow_set_keypress_drop (self, g_value_get_int (value));
#line 24 "../src/four-in-a-row.vala"
		break;
#line 24 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_KEYPRESS_RIGHT_PROPERTY:
#line 24 "../src/four-in-a-row.vala"
		four_in_arow_set_keypress_right (self, g_value_get_int (value));
#line 24 "../src/four-in-a-row.vala"
		break;
#line 24 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_KEYPRESS_LEFT_PROPERTY:
#line 24 "../src/four-in-a-row.vala"
		four_in_arow_set_keypress_left (self, g_value_get_int (value));
#line 24 "../src/four-in-a-row.vala"
		break;
#line 24 "../src/four-in-a-row.vala"
		case FOUR_IN_AROW_SOUND_ON_PROPERTY:
#line 24 "../src/four-in-a-row.vala"
		four_in_arow_set_sound_on (self, g_value_get_boolean (value));
#line 24 "../src/four-in-a-row.vala"
		break;
#line 6665 "four-in-a-row.c"
		default:
#line 24 "../src/four-in-a-row.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/four-in-a-row.vala"
		break;
#line 6671 "four-in-a-row.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

